require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ASM_ATOMIC_H)) {
    eval 'sub _ASM_ATOMIC_H () {1;}' unless defined(&_ASM_ATOMIC_H);
    require 'sys/ccompile.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined(&__lint)  && defined(&__GNUC__)) {
	eval 'sub SUF_8 () {"b";}' unless defined(&SUF_8);
	eval 'sub SUF_16 () {"w";}' unless defined(&SUF_16);
	eval 'sub SUF_32 () {"l";}' unless defined(&SUF_32);
	eval 'sub SUF_64 () {"q";}' unless defined(&SUF_64);
	if(defined(&__amd64)) {
	    eval 'sub SUF_LONG () { &SUF_64;}' unless defined(&SUF_LONG);
	    eval 'sub SUF_PTR () { &SUF_64;}' unless defined(&SUF_PTR);
	    eval 'sub __ATOMIC_OP64 () {(...)  &__ATOMIC_OPXX( &__VA_ARGS__);}' unless defined(&__ATOMIC_OP64);
	}
 elsif(defined(&__i386)) {
	    eval 'sub SUF_LONG () { &SUF_32;}' unless defined(&SUF_LONG);
	    eval 'sub SUF_PTR () { &SUF_32;}' unless defined(&SUF_PTR);
	    eval 'sub __ATOMIC_OP64 () {(...);}' unless defined(&__ATOMIC_OP64);
	} else {
	    die("port me");
	}
	if(defined(&__amd64) || defined(&__i386)) {
	    eval 'sub __ATOMIC_OPXX {
	        my($fxn, $type, $op) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ATOMIC_OPXX);
	    undef(&__ATOMIC_OPXX) if defined(&__ATOMIC_OPXX);
	    eval 'sub __ATOMIC_OPXX {
	        my($fxn, $type1, $type2, $op, $reg) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ATOMIC_OPXX);
	    undef(&__ATOMIC_OPXX) if defined(&__ATOMIC_OPXX);
	    eval 'sub __ATOMIC_OPXX {
	        my($fxn, $type, $op, $reg) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ATOMIC_OPXX);
	    undef(&__ATOMIC_OPXX) if defined(&__ATOMIC_OPXX);
	    eval 'sub __ATOMIC_OPXX {
	        my($fxn, $type, $op, $reg) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__ATOMIC_OPXX);
	    undef(&__ATOMIC_OPXX) if defined(&__ATOMIC_OPXX);
	} else {
	    die("port me");
	}
	undef(&SUF_8) if defined(&SUF_8);
	undef(&SUF_16) if defined(&SUF_16);
	undef(&SUF_32) if defined(&SUF_32);
	undef(&SUF_64) if defined(&SUF_64);
	undef(&SUF_LONG) if defined(&SUF_LONG);
	undef(&SUF_PTR) if defined(&SUF_PTR);
	undef(&__ATOMIC_OP64) if defined(&__ATOMIC_OP64);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
