require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_AUXV_H)) {
    eval 'sub _SYS_AUXV_H () {1;}' unless defined(&_SYS_AUXV_H);
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined(&_ASM)) {
	if(defined(&_SYSCALL32)) {
	}
    }
    eval 'sub AT_NULL () {0;}' unless defined(&AT_NULL);
    eval 'sub AT_IGNORE () {1;}' unless defined(&AT_IGNORE);
    eval 'sub AT_EXECFD () {2;}' unless defined(&AT_EXECFD);
    eval 'sub AT_PHDR () {3;}' unless defined(&AT_PHDR);
    eval 'sub AT_PHENT () {4;}' unless defined(&AT_PHENT);
    eval 'sub AT_PHNUM () {5;}' unless defined(&AT_PHNUM);
    eval 'sub AT_PAGESZ () {6;}' unless defined(&AT_PAGESZ);
    eval 'sub AT_BASE () {7;}' unless defined(&AT_BASE);
    eval 'sub AT_FLAGS () {8;}' unless defined(&AT_FLAGS);
    eval 'sub AT_ENTRY () {9;}' unless defined(&AT_ENTRY);
    eval 'sub AT_SUN_UID () {2000;}' unless defined(&AT_SUN_UID);
    eval 'sub AT_SUN_RUID () {2001;}' unless defined(&AT_SUN_RUID);
    eval 'sub AT_SUN_GID () {2002;}' unless defined(&AT_SUN_GID);
    eval 'sub AT_SUN_RGID () {2003;}' unless defined(&AT_SUN_RGID);
    eval 'sub AT_SUN_LDELF () {2004;}' unless defined(&AT_SUN_LDELF);
    eval 'sub AT_SUN_LDSHDR () {2005;}' unless defined(&AT_SUN_LDSHDR);
    eval 'sub AT_SUN_LDNAME () {2006;}' unless defined(&AT_SUN_LDNAME);
    eval 'sub AT_SUN_LPAGESZ () {2007;}' unless defined(&AT_SUN_LPAGESZ);
    eval 'sub AT_SUN_PLATFORM () {2008;}' unless defined(&AT_SUN_PLATFORM);
    eval 'sub AT_SUN_HWCAP () {2009;}' unless defined(&AT_SUN_HWCAP);
    eval 'sub AT_SUN_HWCAP2 () {2023;}' unless defined(&AT_SUN_HWCAP2);
    if(defined(&_KERNEL)) {
	if(defined(&_SYSCALL32)) {
	}
    } else {
    }
    eval 'sub AT_SUN_IFLUSH () {2010;}' unless defined(&AT_SUN_IFLUSH);
    eval 'sub AT_SUN_CPU () {2011;}' unless defined(&AT_SUN_CPU);
    eval 'sub AT_SUN_EXECNAME () {2014;}' unless defined(&AT_SUN_EXECNAME);
    eval 'sub AT_SUN_MMU () {2015;}' unless defined(&AT_SUN_MMU);
    eval 'sub AT_SUN_LDDATA () {2016;}' unless defined(&AT_SUN_LDDATA);
    eval 'sub AT_SUN_AUXFLAGS () {2017;}' unless defined(&AT_SUN_AUXFLAGS);
    eval 'sub AT_SUN_EMULATOR () {2018;}' unless defined(&AT_SUN_EMULATOR);
    eval 'sub AT_SUN_BRANDNAME () {2019;}' unless defined(&AT_SUN_BRANDNAME);
    eval 'sub AT_SUN_BRAND_AUX1 () {2020;}' unless defined(&AT_SUN_BRAND_AUX1);
    eval 'sub AT_SUN_BRAND_AUX2 () {2021;}' unless defined(&AT_SUN_BRAND_AUX2);
    eval 'sub AT_SUN_BRAND_AUX3 () {2022;}' unless defined(&AT_SUN_BRAND_AUX3);
    eval 'sub AF_SUN_SETUGID () {0x1;}' unless defined(&AF_SUN_SETUGID);
    eval 'sub AF_SUN_HWCAPVERIFY () {0x2;}' unless defined(&AF_SUN_HWCAPVERIFY);
    eval 'sub AF_SUN_NOPLM () {0x4;}' unless defined(&AF_SUN_NOPLM);
    if(defined(&__cplusplus)) {
    }
    if(defined(&_AUXV_TARGET_ALL) || defined(&_AUXV_TARGET_SPARC) || defined(&__sparc)) {
	require 'sys/auxv_SPARC.ph';
    }
    if(defined(&_AUXV_TARGET_ALL) || defined(&_AUXV_TARGET_386) || defined(&__x86)) {
	require 'sys/auxv_386.ph';
    }
}
1;
