require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_AVL_DATA_H)) {
    eval 'sub _SYS_AVL_DATA_H () {1;}' unless defined(&_SYS_AVL_DATA_H);
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_LP64)) {
	eval 'sub AVL_XPARENT {
	    my($n) = @_;
    	    eval q((($n)-> &avl_parent));
	}' unless defined(&AVL_XPARENT);
	eval 'sub AVL_SETPARENT {
	    my($n, $p) = @_;
    	    eval q((($n)-> &avl_parent = ($p)));
	}' unless defined(&AVL_SETPARENT);
	eval 'sub AVL_XCHILD {
	    my($n) = @_;
    	    eval q((($n)-> &avl_child_index));
	}' unless defined(&AVL_XCHILD);
	eval 'sub AVL_SETCHILD {
	    my($n, $c) = @_;
    	    eval q((-> &avl_child_index = ($c)));
	}' unless defined(&AVL_SETCHILD);
	eval 'sub AVL_XBALANCE {
	    my($n) = @_;
    	    eval q((($n)-> &avl_balance));
	}' unless defined(&AVL_XBALANCE);
	eval 'sub AVL_SETBALANCE {
	    my($n, $b) = @_;
    	    eval q((-> &avl_balance = ($b)));
	}' unless defined(&AVL_SETBALANCE);
    } else {
	eval 'sub AVL_XPARENT {
	    my($n) = @_;
    	    eval q(((($n)-> &avl_pcb & ~7)));
	}' unless defined(&AVL_XPARENT);
	eval 'sub AVL_SETPARENT {
	    my($n, $p) = @_;
    	    eval q((($n)-> &avl_pcb = ((($n)-> &avl_pcb & 7) | ( &uintptr_t)($p))));
	}' unless defined(&AVL_SETPARENT);
	eval 'sub AVL_XCHILD {
	    my($n) = @_;
    	    eval q(((($n)-> &avl_pcb >> 2) & 1));
	}' unless defined(&AVL_XCHILD);
	eval 'sub AVL_SETCHILD {
	    my($n, $c) = @_;
    	    eval q((($n)-> &avl_pcb = ( &uintptr_t)((($n)-> &avl_pcb & ~4) | (($c) << 2))));
	}' unless defined(&AVL_SETCHILD);
	eval 'sub AVL_XBALANCE {
	    my($n) = @_;
    	    eval q((((($n)-> &avl_pcb & 3) - 1)));
	}' unless defined(&AVL_XBALANCE);
	eval 'sub AVL_SETBALANCE {
	    my($n, $b) = @_;
    	    eval q((($n)-> &avl_pcb = ( &uintptr_t)(((($n)-> &avl_pcb & ~3) | (($b) + 1)))));
	}' unless defined(&AVL_SETBALANCE);
    }
    eval 'sub AVL_NODE2DATA {
        my($n, $o) = @_;
	    eval q((( &void *)(( &uintptr_t)($n) - ($o))));
    }' unless defined(&AVL_NODE2DATA);
    eval 'sub AVL_DATA2NODE {
        my($d, $o) = @_;
	    eval q(((( &uintptr_t)($d) + ($o))));
    }' unless defined(&AVL_DATA2NODE);
    eval 'sub AVL_INDEX2NODE {
        my($x) = @_;
	    eval q((( &avl_node_t *)(($x) & ~1)));
    }' unless defined(&AVL_INDEX2NODE);
    eval 'sub AVL_INDEX2CHILD {
        my($x) = @_;
	    eval q((($x) & 1));
    }' unless defined(&AVL_INDEX2CHILD);
    eval 'sub AVL_MKINDEX {
        my($n, $c) = @_;
	    eval q((( &avl_index_t)($n) | ($c)));
    }' unless defined(&AVL_MKINDEX);
    if(defined(&__cplusplus)) {
    }
}
1;
