require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CCOMPILE_H)) {
    eval 'sub _SYS_CCOMPILE_H () {1;}' unless defined(&_SYS_CCOMPILE_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&__GNUC__)) {
	eval 'sub __GNUC_VERSION () {( &__GNUC__ * 10000+  &__GNUC_MINOR__ * 100+  &__GNUC_PATCHLEVEL__);}' unless defined(&__GNUC_VERSION);
    } else {
	eval 'sub __GNUC_VERSION () {0;}' unless defined(&__GNUC_VERSION);
    }
    if(defined(&__ATTRIBUTE_IMPLEMENTED) || defined(&__GNUC__)) {
	eval 'sub __sun_attr___PRINTFLIKE__ {
	    my($__n) = @_;
    	    eval q( &__attribute__(( &__format__( &printf, $__n, ($__n)+1))));
	}' unless defined(&__sun_attr___PRINTFLIKE__);
	eval 'sub __sun_attr___VPRINTFLIKE__ {
	    my($__n) = @_;
    	    eval q( &__attribute__(( &__format__( &printf, $__n, 0))));
	}' unless defined(&__sun_attr___VPRINTFLIKE__);
	if((defined(&__GNUC_VERSION) ? &__GNUC_VERSION : undef) < 30402) {
	    eval 'sub __sun_attr___KPRINTFLIKE__ () { &__sun_attr___PRINTFLIKE__;}' unless defined(&__sun_attr___KPRINTFLIKE__);
	    eval 'sub __sun_attr___KVPRINTFLIKE__ () { &__sun_attr___VPRINTFLIKE__;}' unless defined(&__sun_attr___KVPRINTFLIKE__);
	} else {
	    eval 'sub __sun_attr___KPRINTFLIKE__ {
	        my($__n) = @_;
    		eval q( &__attribute__(( &__format__( &cmn_err, $__n, ($__n)+1))));
	    }' unless defined(&__sun_attr___KPRINTFLIKE__);
	    eval 'sub __sun_attr___KVPRINTFLIKE__ {
	        my($__n) = @_;
    		eval q( &__attribute__(( &__format__( &cmn_err, $__n, 0))));
	    }' unless defined(&__sun_attr___KVPRINTFLIKE__);
	}
	eval 'sub __sun_attr___noreturn__ () { &__attribute__(( &__noreturn__));}' unless defined(&__sun_attr___noreturn__);
	if((defined(&__GNUC_VERSION) ? &__GNUC_VERSION : undef) >= 40200) {
	    eval 'sub __sun_attr___gnu_inline__ () { &__attribute__(( &__gnu_inline__));}' unless defined(&__sun_attr___gnu_inline__);
	} else {
	    eval 'sub __sun_attr___gnu_inline__ () {1;}' unless defined(&__sun_attr___gnu_inline__);
	}
	if((defined(&__GNUC_VERSION) ? &__GNUC_VERSION : undef) >= 40100) {
	    eval 'sub __sun_attr___returns_twice__ () { &__attribute__(( &__returns_twice__));}' unless defined(&__sun_attr___returns_twice__);
	} else {
	    eval 'sub __sun_attr___returns_twice__ () {1;}' unless defined(&__sun_attr___returns_twice__);
	}
	eval 'sub __sun_attr___pure__ () { &__attribute__(( &__pure__));}' unless defined(&__sun_attr___pure__);
	eval 'sub __sun_attr___const__ () { &__attribute__(( &__const__));}' unless defined(&__sun_attr___const__);
	eval 'sub __sun_attr___packed__ () { &__attribute__(( &__packed__));}' unless defined(&__sun_attr___packed__);
	if((defined(&__GNUC_VERSION) ? &__GNUC_VERSION : undef) >= 20700) {
	    eval 'sub __sun_attr___unused__ () { &__attribute__(( &__unused__));}' unless defined(&__sun_attr___unused__);
	} else {
	    eval 'sub __sun_attr___unused__ () {1;}' unless defined(&__sun_attr___unused__);
	}
	eval 'sub ___sun_attr_inner {
	    my($__a) = @_;
    	    eval q( &__sun_attr_$__a);
	}' unless defined(&___sun_attr_inner);
	eval 'sub __sun_attr__ {
	    my($__a) = @_;
    	    eval q( &___sun_attr_inner $__a);
	}' unless defined(&__sun_attr__);
    } else {
	eval 'sub __sun_attr__ {
	    my($__a) = @_;
    	    eval q();
	}' unless defined(&__sun_attr__);
    }
    eval 'sub __PRINTFLIKE {
        my($__n) = @_;
	    eval q( &__sun_attr__(( &__PRINTFLIKE__($__n))));
    }' unless defined(&__PRINTFLIKE);
    eval 'sub __VPRINTFLIKE {
        my($__n) = @_;
	    eval q( &__sun_attr__(( &__VPRINTFLIKE__($__n))));
    }' unless defined(&__VPRINTFLIKE);
    eval 'sub __KPRINTFLIKE {
        my($__n) = @_;
	    eval q( &__sun_attr__(( &__KPRINTFLIKE__($__n))));
    }' unless defined(&__KPRINTFLIKE);
    eval 'sub __KVPRINTFLIKE {
        my($__n) = @_;
	    eval q( &__sun_attr__(( &__KVPRINTFLIKE__($__n))));
    }' unless defined(&__KVPRINTFLIKE);
    eval 'sub __NORETURN () { &__sun_attr__(( &__noreturn__));}' unless defined(&__NORETURN);
    eval 'sub __GNU_INLINE () { &__inline__  &__sun_attr__(( &__gnu_inline__));}' unless defined(&__GNU_INLINE);
    eval 'sub __RETURNS_TWICE () { &__sun_attr__(( &__returns_twice__));}' unless defined(&__RETURNS_TWICE);
    eval 'sub __CONST () { &__sun_attr__(( &__const__));}' unless defined(&__CONST);
    eval 'sub __PURE () { &__sun_attr__(( &__pure__));}' unless defined(&__PURE);
    eval 'sub __GNU_UNUSED () { &__sun_attr__(( &__unused__));}' unless defined(&__GNU_UNUSED);
    if(defined(&__cplusplus)) {
    }
}
1;
