require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CPC_IMPL_H)) {
    eval 'sub _SYS_CPC_IMPL_H () {1;}' unless defined(&_SYS_CPC_IMPL_H);
    require 'sys/types.ph';
    require 'sys/time.ph';
    require 'sys/ksynch.ph';
    if(defined(&_KERNEL)  && defined(&_MULTI_DATAMODEL)) {
	require 'sys/types32.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub CPC_BIND_LWP_INHERIT () {(0x1);}' unless defined(&CPC_BIND_LWP_INHERIT);
    eval 'sub CPC_BIND_EMT_OVF () {(0x2);}' unless defined(&CPC_BIND_EMT_OVF);
    eval 'sub CPC_MAX_IMPL_NAME () {512;}' unless defined(&CPC_MAX_IMPL_NAME);
    eval 'sub CPC_MAX_CPUREF () {1024;}' unless defined(&CPC_MAX_CPUREF);
    eval 'sub CPC_OVF_NOTIFY_EMT () {0x1;}' unless defined(&CPC_OVF_NOTIFY_EMT);
    eval 'sub CPC_COUNT_USER () {0x2;}' unless defined(&CPC_COUNT_USER);
    eval 'sub CPC_COUNT_SYSTEM () {0x4;}' unless defined(&CPC_COUNT_SYSTEM);
    eval 'sub CPC_COUNT_HV () {0x8;}' unless defined(&CPC_COUNT_HV);
    eval 'sub CPC_COUNT_SAMPLE_MODE () {0x10;}' unless defined(&CPC_COUNT_SAMPLE_MODE);
    eval 'sub KCPC_REQ_ALL_FLAGS () {( &CPC_OVF_NOTIFY_EMT |  &CPC_COUNT_USER |  &CPC_COUNT_SYSTEM |  &CPC_COUNT_HV |  &CPC_COUNT_SAMPLE_MODE);}' unless defined(&KCPC_REQ_ALL_FLAGS);
    eval 'sub KCPC_REQ_VALID_FLAGS {
        my($flags) = @_;
	    eval q(((($flags) |  &KCPC_REQ_ALL_FLAGS) ==  &KCPC_REQ_ALL_FLAGS));
    }' unless defined(&KCPC_REQ_VALID_FLAGS);
    eval 'sub CPC_CAP_OVERFLOW_INTERRUPT () {0x1;}' unless defined(&CPC_CAP_OVERFLOW_INTERRUPT);
    eval 'sub CPC_CAP_OVERFLOW_PRECISE () {0x2;}' unless defined(&CPC_CAP_OVERFLOW_PRECISE);
    eval 'sub CPC_SET_ALL_FLAGS () {0x1;}' unless defined(&CPC_SET_ALL_FLAGS);
    eval 'sub CPC_SET_VALID_FLAGS {
        my($flags) = @_;
	    eval q(((($flags) |  &CPC_SET_ALL_FLAGS) ==  &CPC_SET_ALL_FLAGS));
    }' unless defined(&CPC_SET_VALID_FLAGS);
    eval 'sub CPC_BIND () {0;}' unless defined(&CPC_BIND);
    eval 'sub CPC_SAMPLE () {1;}' unless defined(&CPC_SAMPLE);
    eval 'sub CPC_INVALIDATE () {2;}' unless defined(&CPC_INVALIDATE);
    eval 'sub CPC_RELE () {3;}' unless defined(&CPC_RELE);
    eval 'sub CPC_EVLIST_SIZE () {4;}' unless defined(&CPC_EVLIST_SIZE);
    eval 'sub CPC_LIST_EVENTS () {5;}' unless defined(&CPC_LIST_EVENTS);
    eval 'sub CPC_ATTRLIST_SIZE () {6;}' unless defined(&CPC_ATTRLIST_SIZE);
    eval 'sub CPC_LIST_ATTRS () {7;}' unless defined(&CPC_LIST_ATTRS);
    eval 'sub CPC_IMPL_NAME () {8;}' unless defined(&CPC_IMPL_NAME);
    eval 'sub CPC_CPUREF () {9;}' unless defined(&CPC_CPUREF);
    eval 'sub CPC_USR_EVENTS () {10;}' unless defined(&CPC_USR_EVENTS);
    eval 'sub CPC_SYS_EVENTS () {11;}' unless defined(&CPC_SYS_EVENTS);
    eval 'sub CPC_NPIC () {12;}' unless defined(&CPC_NPIC);
    eval 'sub CPC_CAPS () {13;}' unless defined(&CPC_CAPS);
    eval 'sub CPC_ENABLE () {14;}' unless defined(&CPC_ENABLE);
    eval 'sub CPC_DISABLE () {15;}' unless defined(&CPC_DISABLE);
    eval 'sub CPC_PRESET () {16;}' unless defined(&CPC_PRESET);
    eval 'sub CPC_RESTART () {17;}' unless defined(&CPC_RESTART);
    eval 'sub _CPCIO_IOC () {(((((ord(\'c\'<<8)|\'p\')<<8)|\'c\'))<<8);}' unless defined(&_CPCIO_IOC);
    eval 'sub CPCIO_BIND () {( &_CPCIO_IOC | 0x1);}' unless defined(&CPCIO_BIND);
    eval 'sub CPCIO_SAMPLE () {( &_CPCIO_IOC | 0x2);}' unless defined(&CPCIO_SAMPLE);
    eval 'sub CPCIO_RELE () {( &_CPCIO_IOC | 0x3);}' unless defined(&CPCIO_RELE);
    eval 'sub CPC_MAX_EVENT_LEN () {512;}' unless defined(&CPC_MAX_EVENT_LEN);
    eval 'sub CPC_MAX_ATTR_LEN () {32;}' unless defined(&CPC_MAX_ATTR_LEN);
    if(defined(&_KERNEL)) {
	if(defined(&_MULTI_DATAMODEL)) {
	}
	eval 'sub KCPC_LOG2_HASH_BUCKETS () {6;}' unless defined(&KCPC_LOG2_HASH_BUCKETS);
	eval 'sub CPC_HASH_BUCKETS () {(1 <<  &KCPC_LOG2_HASH_BUCKETS);}' unless defined(&CPC_HASH_BUCKETS);
	eval 'sub CPC_HASH_CTX {
	    my($ctx) = @_;
    	    eval q((((($ctx)) >> 7) & ( &CPC_HASH_BUCKETS - 1)));
	}' unless defined(&CPC_HASH_CTX);
	eval 'sub KCPC_CTX_FREEZE () {0x1;}' unless defined(&KCPC_CTX_FREEZE);
	eval 'sub KCPC_CTX_SIGOVF () {0x2;}' unless defined(&KCPC_CTX_SIGOVF);
	eval 'sub KCPC_CTX_NONPRIV () {0x4;}' unless defined(&KCPC_CTX_NONPRIV);
	eval 'sub KCPC_CTX_LWPINHERIT () {0x8;}' unless defined(&KCPC_CTX_LWPINHERIT);
	eval 'sub KCPC_CTX_INVALID () {0x100;}' unless defined(&KCPC_CTX_INVALID);
	eval 'sub KCPC_CTX_INVALID_STOPPED () {0x200;}' unless defined(&KCPC_CTX_INVALID_STOPPED);
	eval 'sub KCPC_CTX_RESTORE () {0x400;}' unless defined(&KCPC_CTX_RESTORE);
	eval 'sub KCPC_PIC_OVERFLOWED () {0x1;}' unless defined(&KCPC_PIC_OVERFLOWED);
	eval("sub DCPC_INTR_INACTIVE () { 0; }") unless defined(&DCPC_INTR_INACTIVE);
	eval("sub DCPC_INTR_FREE () { 1; }") unless defined(&DCPC_INTR_FREE);
	eval("sub DCPC_INTR_PROCESSING () { 2; }") unless defined(&DCPC_INTR_PROCESSING);
	eval("sub DCPC_INTR_CONFIG () { 3; }") unless defined(&DCPC_INTR_CONFIG);
	eval("sub DCPC_UMASK () { 0x1; }") unless defined(&DCPC_UMASK);
	eval("sub DCPC_EMASK () { 0x2; }") unless defined(&DCPC_EMASK);
	if(defined(&__sparc)) {
	    eval 'sub KCPC_GET_TICK () { &ultra_gettick;}' unless defined(&KCPC_GET_TICK);
	} else {
	    eval 'sub KCPC_GET_TICK () { &tsc_read;}' unless defined(&KCPC_GET_TICK);
	}
	eval 'sub PCBE_NAMELEN () {30;}' unless defined(&PCBE_NAMELEN);
    }
    eval 'sub CPC_INVALID_EVENT () {1;}' unless defined(&CPC_INVALID_EVENT);
    eval 'sub CPC_INVALID_PICNUM () {2;}' unless defined(&CPC_INVALID_PICNUM);
    eval 'sub CPC_INVALID_ATTRIBUTE () {3;}' unless defined(&CPC_INVALID_ATTRIBUTE);
    eval 'sub CPC_ATTRIBUTE_OUT_OF_RANGE () {4;}' unless defined(&CPC_ATTRIBUTE_OUT_OF_RANGE);
    eval 'sub CPC_RESOURCE_UNAVAIL () {5;}' unless defined(&CPC_RESOURCE_UNAVAIL);
    eval 'sub CPC_PIC_NOT_CAPABLE () {6;}' unless defined(&CPC_PIC_NOT_CAPABLE);
    eval 'sub CPC_REQ_INVALID_FLAGS () {7;}' unless defined(&CPC_REQ_INVALID_FLAGS);
    eval 'sub CPC_CONFLICTING_REQS () {8;}' unless defined(&CPC_CONFLICTING_REQS);
    eval 'sub CPC_ATTR_REQUIRES_PRIVILEGE () {9;}' unless defined(&CPC_ATTR_REQUIRES_PRIVILEGE);
    eval 'sub CPC_PBIND_FAILED () {10;}' unless defined(&CPC_PBIND_FAILED);
    eval 'sub CPC_HV_NO_ACCESS () {11;}' unless defined(&CPC_HV_NO_ACCESS);
    if(defined(&__cplusplus)) {
    }
}
1;
