require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_DDI_INTR_H)) {
    eval 'sub _SYS_DDI_INTR_H () {1;}' unless defined(&_SYS_DDI_INTR_H);
    require 'sys/ddipropdefs.ph';
    require 'sys/rwlock.ph';
    require 'sys/processor.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub DDI_INTR_NOTFOUND () {1;}' unless defined(&DDI_INTR_NOTFOUND);
	eval 'sub DDI_INTR_CLAIMED () {1;}' unless defined(&DDI_INTR_CLAIMED);
	eval 'sub DDI_INTR_UNCLAIMED () {0;}' unless defined(&DDI_INTR_UNCLAIMED);
	eval 'sub DDI_INTR_TYPE_FIXED () {0x1;}' unless defined(&DDI_INTR_TYPE_FIXED);
	eval 'sub DDI_INTR_TYPE_MSI () {0x2;}' unless defined(&DDI_INTR_TYPE_MSI);
	eval 'sub DDI_INTR_TYPE_MSIX () {0x4;}' unless defined(&DDI_INTR_TYPE_MSIX);
	eval 'sub DDI_INTR_PRI_MIN () {1;}' unless defined(&DDI_INTR_PRI_MIN);
	eval 'sub DDI_INTR_PRI_MAX () {12;}' unless defined(&DDI_INTR_PRI_MAX);
	eval 'sub DDI_INTR_SOFTPRI_MIN () {1;}' unless defined(&DDI_INTR_SOFTPRI_MIN);
	eval 'sub DDI_INTR_SOFTPRI_MAX () {9;}' unless defined(&DDI_INTR_SOFTPRI_MAX);
	eval 'sub DDI_INTR_SOFTPRI_DEFAULT () { &DDI_INTR_SOFTPRI_MIN;}' unless defined(&DDI_INTR_SOFTPRI_DEFAULT);
	eval 'sub DDI_INTR_FLAG_LEVEL () {0x1;}' unless defined(&DDI_INTR_FLAG_LEVEL);
	eval 'sub DDI_INTR_FLAG_EDGE () {0x2;}' unless defined(&DDI_INTR_FLAG_EDGE);
	eval 'sub DDI_INTR_FLAG_MASKABLE () {0x10;}' unless defined(&DDI_INTR_FLAG_MASKABLE);
	eval 'sub DDI_INTR_FLAG_PENDING () {0x20;}' unless defined(&DDI_INTR_FLAG_PENDING);
	eval 'sub DDI_INTR_FLAG_BLOCK () {0x100;}' unless defined(&DDI_INTR_FLAG_BLOCK);
	eval 'sub DDI_INTR_FLAG_MSI64 () {0x200;}' unless defined(&DDI_INTR_FLAG_MSI64);
	eval 'sub DDI_INTR_PRI {
	    my($pri) = @_;
    	    eval q(( &void *)(( &uintptr_t)($pri)));
	}' unless defined(&DDI_INTR_PRI);
	eval 'sub DDI_INTR_ALLOC_NORMAL () {0;}' unless defined(&DDI_INTR_ALLOC_NORMAL);
	eval 'sub DDI_INTR_ALLOC_STRICT () {1;}' unless defined(&DDI_INTR_ALLOC_STRICT);
    }
    require 'sys/ddi_intr_impl.ph';
    if(defined(&_KERNEL)) {
	eval 'sub DDI_SOFTINT_FIXED () {0;}' unless defined(&DDI_SOFTINT_FIXED);
	eval 'sub DDI_SOFTINT_LOW () {8;}' unless defined(&DDI_SOFTINT_LOW);
	eval 'sub DDI_SOFTINT_MED () {128;}' unless defined(&DDI_SOFTINT_MED);
	eval 'sub DDI_SOFTINT_HIGH () {256;}' unless defined(&DDI_SOFTINT_HIGH);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
