require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_DDI_INTR_IMPL_H)) {
    eval 'sub _SYS_DDI_INTR_IMPL_H () {1;}' unless defined(&_SYS_DDI_INTR_IMPL_H);
    require 'sys/list.ph';
    require 'sys/ksynch.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval("sub DDI_INTROP_SUPPORTED_TYPES () { 1; }") unless defined(&DDI_INTROP_SUPPORTED_TYPES);
	eval("sub DDI_INTROP_NINTRS () { 2; }") unless defined(&DDI_INTROP_NINTRS);
	eval("sub DDI_INTROP_ALLOC () { 3; }") unless defined(&DDI_INTROP_ALLOC);
	eval("sub DDI_INTROP_GETPRI () { 4; }") unless defined(&DDI_INTROP_GETPRI);
	eval("sub DDI_INTROP_SETPRI () { 5; }") unless defined(&DDI_INTROP_SETPRI);
	eval("sub DDI_INTROP_ADDISR () { 6; }") unless defined(&DDI_INTROP_ADDISR);
	eval("sub DDI_INTROP_DUPVEC () { 7; }") unless defined(&DDI_INTROP_DUPVEC);
	eval("sub DDI_INTROP_ENABLE () { 8; }") unless defined(&DDI_INTROP_ENABLE);
	eval("sub DDI_INTROP_BLOCKENABLE () { 9; }") unless defined(&DDI_INTROP_BLOCKENABLE);
	eval("sub DDI_INTROP_BLOCKDISABLE () { 10; }") unless defined(&DDI_INTROP_BLOCKDISABLE);
	eval("sub DDI_INTROP_DISABLE () { 11; }") unless defined(&DDI_INTROP_DISABLE);
	eval("sub DDI_INTROP_REMISR () { 12; }") unless defined(&DDI_INTROP_REMISR);
	eval("sub DDI_INTROP_FREE () { 13; }") unless defined(&DDI_INTROP_FREE);
	eval("sub DDI_INTROP_GETCAP () { 14; }") unless defined(&DDI_INTROP_GETCAP);
	eval("sub DDI_INTROP_SETCAP () { 15; }") unless defined(&DDI_INTROP_SETCAP);
	eval("sub DDI_INTROP_SETMASK () { 16; }") unless defined(&DDI_INTROP_SETMASK);
	eval("sub DDI_INTROP_CLRMASK () { 17; }") unless defined(&DDI_INTROP_CLRMASK);
	eval("sub DDI_INTROP_GETPENDING () { 18; }") unless defined(&DDI_INTROP_GETPENDING);
	eval("sub DDI_INTROP_NAVAIL () { 19; }") unless defined(&DDI_INTROP_NAVAIL);
	eval("sub DDI_INTROP_GETPOOL () { 20; }") unless defined(&DDI_INTROP_GETPOOL);
	eval("sub DDI_INTROP_GETTARGET () { 21; }") unless defined(&DDI_INTROP_GETTARGET);
	eval("sub DDI_INTROP_SETTARGET () { 22; }") unless defined(&DDI_INTROP_SETTARGET);
	eval 'sub DDI_INTR_VERSION_1 () {1;}' unless defined(&DDI_INTR_VERSION_1);
	eval 'sub DDI_INTR_VERSION () { &DDI_INTR_VERSION_1;}' unless defined(&DDI_INTR_VERSION);
	eval 'sub DDI_IHDL_STATE_ALLOC () {0x1;}' unless defined(&DDI_IHDL_STATE_ALLOC);
	eval 'sub DDI_IHDL_STATE_ADDED () {0x2;}' unless defined(&DDI_IHDL_STATE_ADDED);
	eval 'sub DDI_IHDL_STATE_ENABLE () {0x4;}' unless defined(&DDI_IHDL_STATE_ENABLE);
	eval 'sub DDI_INTR_IS_MSI_OR_MSIX {
	    my($type) = @_;
    	    eval q((($type) ==  &DDI_INTR_TYPE_MSI || ($type) ==  &DDI_INTR_TYPE_MSIX));
	}' unless defined(&DDI_INTR_IS_MSI_OR_MSIX);
	eval 'sub DDI_INTR_BEHAVIOR_FLAG_VALID {
	    my($f) = @_;
    	    eval q(((($f) ==  &DDI_INTR_ALLOC_NORMAL) || (($f) ==  &DDI_INTR_ALLOC_STRICT)));
	}' unless defined(&DDI_INTR_BEHAVIOR_FLAG_VALID);
	eval 'sub DDI_INTR_TYPE_FLAG_VALID {
	    my($t) = @_;
    	    eval q(((($t) ==  &DDI_INTR_TYPE_FIXED) || (($t) ==  &DDI_INTR_TYPE_MSI) || (($t) ==  &DDI_INTR_TYPE_MSIX)));
	}' unless defined(&DDI_INTR_TYPE_FLAG_VALID);
	eval 'sub DDI_INTR_MSIX_DUP () {0x1;}' unless defined(&DDI_INTR_MSIX_DUP);
	eval 'sub DDI_MAX_MSI_ALLOC () {2;}' unless defined(&DDI_MAX_MSI_ALLOC);
	eval 'sub DDI_DEFAULT_MSIX_ALLOC () {2;}' unless defined(&DDI_DEFAULT_MSIX_ALLOC);
	eval 'sub DDI_MSIX_ALLOC_DIVIDER () {32;}' unless defined(&DDI_MSIX_ALLOC_DIVIDER);
	eval 'sub DDI_MIN_MSIX_ALLOC () {8;}' unless defined(&DDI_MIN_MSIX_ALLOC);
	eval 'sub DDI_MAX_MSIX_ALLOC () {2048;}' unless defined(&DDI_MAX_MSIX_ALLOC);
	eval 'sub DDI_SOFT_INTR_PRI_M () {4;}' unless defined(&DDI_SOFT_INTR_PRI_M);
	eval 'sub DDI_SOFT_INTR_PRI_H () {6;}' unless defined(&DDI_SOFT_INTR_PRI_H);
	eval 'sub DDI_IRM_POLICY_LARGE () {1;}' unless defined(&DDI_IRM_POLICY_LARGE);
	eval 'sub DDI_IRM_POLICY_EVEN () {2;}' unless defined(&DDI_IRM_POLICY_EVEN);
	eval 'sub DDI_IRM_POLICY_VALID {
	    my($p) = @_;
    	    eval q(((($p) ==  &DDI_IRM_POLICY_LARGE) || (($p) ==  &DDI_IRM_POLICY_EVEN)));
	}' unless defined(&DDI_IRM_POLICY_VALID);
	eval 'sub DDI_IRM_FLAG_ACTIVE () {0x1;}' unless defined(&DDI_IRM_FLAG_ACTIVE);
	eval 'sub DDI_IRM_FLAG_QUEUED () {0x2;}' unless defined(&DDI_IRM_FLAG_QUEUED);
	eval 'sub DDI_IRM_FLAG_WAITERS () {0x4;}' unless defined(&DDI_IRM_FLAG_WAITERS);
	eval 'sub DDI_IRM_FLAG_EXIT () {0x8;}' unless defined(&DDI_IRM_FLAG_EXIT);
	eval 'sub DDI_IRM_FLAG_NEW () {0x10;}' unless defined(&DDI_IRM_FLAG_NEW);
	eval 'sub DDI_IRM_FLAG_CALLBACK () {0x20;}' unless defined(&DDI_IRM_FLAG_CALLBACK);
	if(defined(&__i386) || defined(&__amd64)) {
	}
	eval 'sub NEXUS_HAS_INTR_OP {
	    my($dip) = @_;
    	    eval q((( &DEVI($dip)-> ($devi_ops->{devo_bus_ops}))  && ( &DEVI($dip)-> ($devi_ops->{devo_bus_ops}->{busops_rev}) >=  &BUSO_REV_9)  && ( &DEVI($dip)-> ($devi_ops->{devo_bus_ops}->{bus_intr_op}))));
	}' unless defined(&NEXUS_HAS_INTR_OP);
	if(defined(&__i386) || defined(&__amd64)) {
	}
	eval 'sub DDI_INTR_ASSIGN_HDLR_N_ARGS {
	    my($hdlp, $func, $arg1, $arg2) = @_;
    	    eval q( ($hdlp->{ih_cb_func}) = $func;  ($hdlp->{ih_cb_arg1}) = $arg1;  ($hdlp->{ih_cb_arg2}) = $arg2;);
	}' unless defined(&DDI_INTR_ASSIGN_HDLR_N_ARGS);
	if(defined(&DEBUG)) {
	    eval 'sub I_DDI_VERIFY_MSIX_HANDLE {
	        my($hdlp) = @_;
    		eval q( &if (( ($hdlp->{ih_type}) ==  &DDI_INTR_TYPE_MSIX)  && ( ($hdlp->{ih_flags}) &  &DDI_INTR_MSIX_DUP)) {  &ASSERT( ($hdlp->{ih_dip}) ==  ($hdlp->{ih_main}->{ih_dip}));  &ASSERT( ($hdlp->{ih_type}) ==  ($hdlp->{ih_main}->{ih_type}));  &ASSERT( ($hdlp->{ih_vector}) ==  ($hdlp->{ih_main}->{ih_vector}));  &ASSERT( ($hdlp->{ih_ver}) ==  ($hdlp->{ih_main}->{ih_ver}));  &ASSERT( ($hdlp->{ih_cap}) ==  ($hdlp->{ih_main}->{ih_cap}));  &ASSERT( ($hdlp->{ih_pri}) ==  ($hdlp->{ih_main}->{ih_pri})); });
	    }' unless defined(&I_DDI_VERIFY_MSIX_HANDLE);
	} else {
	    eval 'sub I_DDI_VERIFY_MSIX_HANDLE {
	        my($hdlp) = @_;
    		eval q();
	    }' unless defined(&I_DDI_VERIFY_MSIX_HANDLE);
	}
    } else {
    }
    if(defined(&_KERNEL)) {
	eval("sub DDI_INTR_CTLOPS_NONE () { 0; }") unless defined(&DDI_INTR_CTLOPS_NONE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
