require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_DDITYPES_H)) {
    eval 'sub _SYS_DDITYPES_H () {1;}' unless defined(&_SYS_DDITYPES_H);
    require 'sys/isa_defs.ph';
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	eval 'sub dmac_laddress () { ($_dmu->{_dmac_ll});}' unless defined(&dmac_laddress);
	if(defined(&_LONG_LONG_HTOL)) {
	    eval 'sub dmac_notused () { ($_dmu->{_dmac_la[0]});}' unless defined(&dmac_notused);
	    eval 'sub dmac_address () { ($_dmu->{_dmac_la[1]});}' unless defined(&dmac_address);
	} else {
	    eval 'sub dmac_address () { ($_dmu->{_dmac_la[0]});}' unless defined(&dmac_address);
	    eval 'sub dmac_notused () { ($_dmu->{_dmac_la[1]});}' unless defined(&dmac_notused);
	}
	eval 'sub idev_vector () { ($idu->{_idev_vector});}' unless defined(&idev_vector);
	eval 'sub idev_priority () { ($idu->{_idev_priority});}' unless defined(&idev_priority);
	eval 'sub DEVID_NONE () {0;}' unless defined(&DEVID_NONE);
	eval 'sub DEVID_SCSI3_WWN () {1;}' unless defined(&DEVID_SCSI3_WWN);
	eval 'sub DEVID_SCSI_SERIAL () {2;}' unless defined(&DEVID_SCSI_SERIAL);
	eval 'sub DEVID_FAB () {3;}' unless defined(&DEVID_FAB);
	eval 'sub DEVID_ENCAP () {4;}' unless defined(&DEVID_ENCAP);
	eval 'sub DEVID_ATA_SERIAL () {5;}' unless defined(&DEVID_ATA_SERIAL);
	eval 'sub DEVID_SCSI3_VPD_T10 () {6;}' unless defined(&DEVID_SCSI3_VPD_T10);
	eval 'sub DEVID_SCSI3_VPD_EUI () {7;}' unless defined(&DEVID_SCSI3_VPD_EUI);
	eval 'sub DEVID_SCSI3_VPD_NAA () {8;}' unless defined(&DEVID_SCSI3_VPD_NAA);
	eval 'sub DEVID_MAXTYPE () {8;}' unless defined(&DEVID_MAXTYPE);
	eval 'sub DEVID_SCSI_ENCODE_VERSION1 () {0;}' unless defined(&DEVID_SCSI_ENCODE_VERSION1);
	eval 'sub DEVID_SCSI_ENCODE_VERSION2 () {1;}' unless defined(&DEVID_SCSI_ENCODE_VERSION2);
	eval 'sub DEVID_SCSI_ENCODE_VERSION_LATEST () { &DEVID_SCSI_ENCODE_VERSION2;}' unless defined(&DEVID_SCSI_ENCODE_VERSION_LATEST);
	eval 'sub DEVID_SMP_ENCODE_VERSION1 () {0;}' unless defined(&DEVID_SMP_ENCODE_VERSION1);
	eval 'sub DEVID_SMP_ENCODE_VERSION_LATEST () { &DEVID_SMP_ENCODE_VERSION1;}' unless defined(&DEVID_SMP_ENCODE_VERSION_LATEST);
	eval 'sub DEVID_MINOR_NAME_ALL () {(0);}' unless defined(&DEVID_MINOR_NAME_ALL);
	eval 'sub DEVID_MINOR_NAME_ALL_CHR () {(1);}' unless defined(&DEVID_MINOR_NAME_ALL_CHR);
	eval 'sub DEVID_MINOR_NAME_ALL_BLK () {(2);}' unless defined(&DEVID_MINOR_NAME_ALL_BLK);
	eval("sub DDI_DEVMAP_VALIDATE () { 0; }") unless defined(&DDI_DEVMAP_VALIDATE);
	eval("sub DS_INVAL () { -1; }") unless defined(&DS_INVAL);
	eval("sub DS_PROTO () { 0; }") unless defined(&DS_PROTO);
	eval("sub DS_LINKED () { 1; }") unless defined(&DS_LINKED);
	eval("sub DS_BOUND () { 2; }") unless defined(&DS_BOUND);
	eval("sub DS_INITIALIZED () { 3; }") unless defined(&DS_INITIALIZED);
	eval("sub DS_PROBED () { 4; }") unless defined(&DS_PROBED);
	eval("sub DS_ATTACHED () { 5; }") unless defined(&DS_ATTACHED);
	eval("sub DS_READY () { 6; }") unless defined(&DS_READY);
	eval("sub EPL_KERNEL () { 0; }") unless defined(&EPL_KERNEL);
	eval("sub EPL_INTERRUPT () { 1; }") unless defined(&EPL_INTERRUPT);
	eval("sub EPL_HIGHLEVEL () { 2; }") unless defined(&EPL_HIGHLEVEL);
    }
    if(defined(&_KERNEL)) {
	unless(defined(&_ASM)) {
	    eval 'sub DDI_DEVICE_ATTR_V0 () {0x1;}' unless defined(&DDI_DEVICE_ATTR_V0);
	    eval 'sub DDI_DEVICE_ATTR_V1 () {0x2;}' unless defined(&DDI_DEVICE_ATTR_V1);
	    eval 'sub DDI_NEVERSWAP_ACC () {0x;}' unless defined(&DDI_NEVERSWAP_ACC);
	    eval 'sub DDI_STRUCTURE_LE_ACC () {0x1;}' unless defined(&DDI_STRUCTURE_LE_ACC);
	    eval 'sub DDI_STRUCTURE_BE_ACC () {0x2;}' unless defined(&DDI_STRUCTURE_BE_ACC);
	    eval 'sub DDI_STRICTORDER_ACC () {0x;}' unless defined(&DDI_STRICTORDER_ACC);
	    eval 'sub DDI_UNORDERED_OK_ACC () {0x1;}' unless defined(&DDI_UNORDERED_OK_ACC);
	    eval 'sub DDI_MERGING_OK_ACC () {0x2;}' unless defined(&DDI_MERGING_OK_ACC);
	    eval 'sub DDI_LOADCACHING_OK_ACC () {0x3;}' unless defined(&DDI_LOADCACHING_OK_ACC);
	    eval 'sub DDI_STORECACHING_OK_ACC () {0x4;}' unless defined(&DDI_STORECACHING_OK_ACC);
	    eval 'sub DDI_DATA_SZ01_ACC () {1;}' unless defined(&DDI_DATA_SZ01_ACC);
	    eval 'sub DDI_DATA_SZ02_ACC () {2;}' unless defined(&DDI_DATA_SZ02_ACC);
	    eval 'sub DDI_DATA_SZ04_ACC () {4;}' unless defined(&DDI_DATA_SZ04_ACC);
	    eval 'sub DDI_DATA_SZ08_ACC () {8;}' unless defined(&DDI_DATA_SZ08_ACC);
	    eval 'sub VERS_ACCHDL () {0x1;}' unless defined(&VERS_ACCHDL);
	}
	eval 'sub DDI_DEFAULT_ACC () {0x1;}' unless defined(&DDI_DEFAULT_ACC);
	eval 'sub DDI_FLAGERR_ACC () {0x2;}' unless defined(&DDI_FLAGERR_ACC);
	eval 'sub DDI_CAUTIOUS_ACC () {0x3;}' unless defined(&DDI_CAUTIOUS_ACC);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
