require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_DISP_H)) {
    eval 'sub _SYS_DISP_H () {1;}' unless defined(&_SYS_DISP_H);
    require 'sys/priocntl.ph';
    require 'sys/thread.ph';
    require 'sys/class.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	eval 'sub MAXCLSYSPRI () {99;}' unless defined(&MAXCLSYSPRI);
	eval 'sub MINCLSYSPRI () {60;}' unless defined(&MINCLSYSPRI);
    }
    if(defined(&_KERNEL)) {
	eval 'sub DISP_MAXRUNPRI {
	    my($t) = @_;
    	    eval q((($t)-> ($t_disp_queue->{disp_maxrunpri})));
	}' unless defined(&DISP_MAXRUNPRI);
	eval 'sub KPREEMPT_SYNC () {(-1);}' unless defined(&KPREEMPT_SYNC);
	eval 'sub kpreempt_disable () {
	    eval q({  ($curthread->{t_preempt})++;  &ASSERT( ($curthread->{t_preempt}) >= 1); });
	}' unless defined(&kpreempt_disable);
	eval 'sub kpreempt_enable () {
	    eval q({  &ASSERT( ($curthread->{t_preempt}) >= 1);  &if (-- ($curthread->{t_preempt}) == 0 &&  ($CPU->{cpu_kprunrun}))  &kpreempt( &KPREEMPT_SYNC); });
	}' unless defined(&kpreempt_enable);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
