require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_FILE_H)) {
    eval 'sub _SYS_FILE_H () {1;}' unless defined(&_SYS_FILE_H);
    require 'sys/t_lock.ph';
    if(defined(&_KERNEL)) {
	require 'sys/model.ph';
	require 'sys/user.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub FOPEN () {0xffffffff;}' unless defined(&FOPEN);
    eval 'sub FREAD () {0x1;}' unless defined(&FREAD);
    eval 'sub FWRITE () {0x2;}' unless defined(&FWRITE);
    eval 'sub FNDELAY () {0x4;}' unless defined(&FNDELAY);
    eval 'sub FAPPEND () {0x8;}' unless defined(&FAPPEND);
    eval 'sub FSYNC () {0x10;}' unless defined(&FSYNC);
    eval 'sub FREVOKED () {0x20;}' unless defined(&FREVOKED);
    eval 'sub FDSYNC () {0x40;}' unless defined(&FDSYNC);
    eval 'sub FNONBLOCK () {0x80;}' unless defined(&FNONBLOCK);
    eval 'sub FMASK () {0xa0ff;}' unless defined(&FMASK);
    eval 'sub FCREAT () {0x100;}' unless defined(&FCREAT);
    eval 'sub FTRUNC () {0x200;}' unless defined(&FTRUNC);
    eval 'sub FEXCL () {0x400;}' unless defined(&FEXCL);
    eval 'sub FASYNC () {0x1000;}' unless defined(&FASYNC);
    eval 'sub FOFFMAX () {0x2000;}' unless defined(&FOFFMAX);
    eval 'sub FXATTR () {0x4000;}' unless defined(&FXATTR);
    eval 'sub FNOCTTY () {0x800;}' unless defined(&FNOCTTY);
    eval 'sub FRSYNC () {0x8000;}' unless defined(&FRSYNC);
    eval 'sub FNODSYNC () {0x10000;}' unless defined(&FNODSYNC);
    eval 'sub FNOFOLLOW () {0x20000;}' unless defined(&FNOFOLLOW);
    eval 'sub FNOLINKS () {0x40000;}' unless defined(&FNOLINKS);
    eval 'sub FIGNORECASE () {0x80000;}' unless defined(&FIGNORECASE);
    eval 'sub FXATTRDIROPEN () {0x100000;}' unless defined(&FXATTRDIROPEN);
    eval 'sub FSEARCH () {0x200000;}' unless defined(&FSEARCH);
    eval 'sub FEXEC () {0x400000;}' unless defined(&FEXEC);
    eval 'sub FCLOEXEC () {0x800000;}' unless defined(&FCLOEXEC);
    if(!defined(&_KERNEL)  && !defined(&_BOOT)) {
	unless(defined(&_FCNTL_H)) {
	    require 'fcntl.ph';
	}
	eval 'sub LOCK_SH () {1;}' unless defined(&LOCK_SH);
	eval 'sub LOCK_EX () {2;}' unless defined(&LOCK_EX);
	eval 'sub LOCK_NB () {4;}' unless defined(&LOCK_NB);
	eval 'sub LOCK_UN () {8;}' unless defined(&LOCK_UN);
    }
    if(defined(&_KERNEL)) {
	eval 'sub FEPOLLED () {0x8000;}' unless defined(&FEPOLLED);
	eval 'sub FMODELS () { &DATAMODEL_MASK;}' unless defined(&FMODELS);
	eval 'sub FILP32 () { &DATAMODEL_ILP32;}' unless defined(&FILP32);
	eval 'sub FLP64 () { &DATAMODEL_LP64;}' unless defined(&FLP64);
	eval 'sub FNATIVE () { &DATAMODEL_NATIVE;}' unless defined(&FNATIVE);
	eval 'sub OFFSET_MAX {
	    my($fd) = @_;
    	    eval q((( ($fd->{f_flag}) &  &FOFFMAX) ?  &MAXOFFSET_T :  &MAXOFF32_T));
	}' unless defined(&OFFSET_MAX);
	eval 'sub FKIOCTL () {0x80000000;}' unless defined(&FKIOCTL);
	eval 'sub FKLYR () {0x40000000;}' unless defined(&FKLYR);
    }
    unless(defined(&L_SET)) {
	eval 'sub L_SET () {0;}' unless defined(&L_SET);
    }
    if(defined(&_KERNEL)) {
	unless(defined(&_BOOT)) {
	}
	if(defined(&DEBUG)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
