require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_HYPERVISOR_H)) {
    eval 'sub _SYS_HYPERVISOR_H () {1;}' unless defined(&_SYS_HYPERVISOR_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub xen_mb () { &membar_enter;}' unless defined(&xen_mb);
    eval 'sub xen_wmb () { &membar_producer;}' unless defined(&xen_wmb);
    unless(defined(&__xpv)) {
	require 'sys/xpv_support.ph';
    } else {
	require 'sys/xpv_impl.ph';
    }
    require 'sys/xen_errno.ph';
    if(!defined(&_ASM)) {
	require 'sys/processor.ph';
	require 'sys/cpuvar.ph';
	if(defined(&__xpv)) {
	    require 'sys/xen_mmu.ph';
	}
	require 'sys/systm.ph';
	require 'xen/public/callback.ph';
	require 'xen/public/event_channel.ph';
	require 'xen/public/grant_table.ph';
	require 'xen/public/io/blkif.ph';
	require 'xen/public/io/xenbus.ph';
	require 'xen/public/memory.ph';
	require 'xen/public/nmi.ph';
	require 'xen/public/physdev.ph';
	require 'xen/public/sched.ph';
	require 'xen/public/platform.ph';
	require 'xen/public/vcpu.ph';
	require 'xen/public/version.ph';
	require 'xen/public/hvm/params.ph';
	require 'xen/public/arch-x86/xen-mca.ph';
	if(defined(&__amd64)) {
	}
	unless(defined(&__xpv)) {
	    eval 'sub DOMAIN_IS_INITDOMAIN {
	        my($info) = @_;
    		eval q(( &__lintzero));
	    }' unless defined(&DOMAIN_IS_INITDOMAIN);
	    eval 'sub DOMAIN_IS_PRIVILEGED {
	        my($info) = @_;
    		eval q(( &__lintzero));
	    }' unless defined(&DOMAIN_IS_PRIVILEGED);
	} else {
	    eval 'sub DOMAIN_IS_INITDOMAIN {
	        my($info) = @_;
    		eval q(((($info)-> &flags &  &SIF_INITDOMAIN) ==  &SIF_INITDOMAIN));
	    }' unless defined(&DOMAIN_IS_INITDOMAIN);
	    eval 'sub DOMAIN_IS_PRIVILEGED {
	        my($info) = @_;
    		eval q(((($info)-> &flags &  &SIF_PRIVILEGED) ==  &SIF_PRIVILEGED));
	    }' unless defined(&DOMAIN_IS_PRIVILEGED);
	}
	if(defined(&__amd64)) {
	} else {
	}
	if(defined(&__amd64)) {
	}
	if(defined(&__xpv)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
