require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_INT_CONST_H)) {
    eval 'sub _SYS_INT_CONST_H () {1;}' unless defined(&_SYS_INT_CONST_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&__STDC__)) {
	eval 'sub __CONCAT__ {
	    my($A,$B) = @_;
    	    eval q($A  $B);
	}' unless defined(&__CONCAT__);
    } else {
	eval 'sub __CONCAT__ {
	    my($A,$B) = @_;
    	    eval q($A $B);
	}' unless defined(&__CONCAT__);
    }
    if(defined(&_CHAR_IS_SIGNED) || defined(&__STDC__)) {
	eval 'sub INT8_C {
	    my($c) = @_;
    	    eval q(($c));
	}' unless defined(&INT8_C);
    }
    eval 'sub INT16_C {
        my($c) = @_;
	    eval q(($c));
    }' unless defined(&INT16_C);
    eval 'sub INT32_C {
        my($c) = @_;
	    eval q(($c));
    }' unless defined(&INT32_C);
    if(defined(&_LP64)) {
	eval 'sub INT64_C {
	    my($c) = @_;
    	    eval q( &__CONCAT__($c, &l));
	}' unless defined(&INT64_C);
    } else {
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub INT64_C {
	        my($c) = @_;
    		eval q( &__CONCAT__($c, &ll));
	    }' unless defined(&INT64_C);
	}
    }
    eval 'sub UINT8_C {
        my($c) = @_;
	    eval q(($c));
    }' unless defined(&UINT8_C);
    eval 'sub UINT16_C {
        my($c) = @_;
	    eval q(($c));
    }' unless defined(&UINT16_C);
    eval 'sub UINT32_C {
        my($c) = @_;
	    eval q( &__CONCAT__($c, &u));
    }' unless defined(&UINT32_C);
    if(defined(&_LP64)) {
	eval 'sub UINT64_C {
	    my($c) = @_;
    	    eval q( &__CONCAT__($c, &ul));
	}' unless defined(&UINT64_C);
    } else {
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub UINT64_C {
	        my($c) = @_;
    		eval q( &__CONCAT__($c, &ull));
	    }' unless defined(&UINT64_C);
	}
    }
    if(defined(&_LP64)) {
	eval 'sub INTMAX_C {
	    my($c) = @_;
    	    eval q( &__CONCAT__($c, &l));
	}' unless defined(&INTMAX_C);
	eval 'sub UINTMAX_C {
	    my($c) = @_;
    	    eval q( &__CONCAT__($c, &ul));
	}' unless defined(&UINTMAX_C);
    } else {
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub INTMAX_C {
	        my($c) = @_;
    		eval q( &__CONCAT__($c, &ll));
	    }' unless defined(&INTMAX_C);
	    eval 'sub UINTMAX_C {
	        my($c) = @_;
    		eval q( &__CONCAT__($c, &ull));
	    }' unless defined(&UINTMAX_C);
	} else {
	    eval 'sub INTMAX_C {
	        my($c) = @_;
    		eval q(($c));
	    }' unless defined(&INTMAX_C);
	    eval 'sub UINTMAX_C {
	        my($c) = @_;
    		eval q(($c));
	    }' unless defined(&UINTMAX_C);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
