require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SIGNAL_ISO_H)) {
    eval 'sub _SYS_SIGNAL_ISO_H () {1;}' unless defined(&_SYS_SIGNAL_ISO_H);
    require 'sys/unistd.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub SIGHUP () {1;}' unless defined(&SIGHUP);
    eval 'sub SIGINT () {2;}' unless defined(&SIGINT);
    eval 'sub SIGQUIT () {3;}' unless defined(&SIGQUIT);
    eval 'sub SIGILL () {4;}' unless defined(&SIGILL);
    eval 'sub SIGTRAP () {5;}' unless defined(&SIGTRAP);
    eval 'sub SIGIOT () {6;}' unless defined(&SIGIOT);
    eval 'sub SIGABRT () {6;}' unless defined(&SIGABRT);
    eval 'sub SIGEMT () {7;}' unless defined(&SIGEMT);
    eval 'sub SIGFPE () {8;}' unless defined(&SIGFPE);
    eval 'sub SIGKILL () {9;}' unless defined(&SIGKILL);
    eval 'sub SIGBUS () {10;}' unless defined(&SIGBUS);
    eval 'sub SIGSEGV () {11;}' unless defined(&SIGSEGV);
    eval 'sub SIGSYS () {12;}' unless defined(&SIGSYS);
    eval 'sub SIGPIPE () {13;}' unless defined(&SIGPIPE);
    eval 'sub SIGALRM () {14;}' unless defined(&SIGALRM);
    eval 'sub SIGTERM () {15;}' unless defined(&SIGTERM);
    eval 'sub SIGUSR1 () {16;}' unless defined(&SIGUSR1);
    eval 'sub SIGUSR2 () {17;}' unless defined(&SIGUSR2);
    eval 'sub SIGCLD () {18;}' unless defined(&SIGCLD);
    eval 'sub SIGCHLD () {18;}' unless defined(&SIGCHLD);
    eval 'sub SIGPWR () {19;}' unless defined(&SIGPWR);
    eval 'sub SIGWINCH () {20;}' unless defined(&SIGWINCH);
    eval 'sub SIGURG () {21;}' unless defined(&SIGURG);
    eval 'sub SIGPOLL () {22;}' unless defined(&SIGPOLL);
    eval 'sub SIGIO () { &SIGPOLL;}' unless defined(&SIGIO);
    eval 'sub SIGSTOP () {23;}' unless defined(&SIGSTOP);
    eval 'sub SIGTSTP () {24;}' unless defined(&SIGTSTP);
    eval 'sub SIGCONT () {25;}' unless defined(&SIGCONT);
    eval 'sub SIGTTIN () {26;}' unless defined(&SIGTTIN);
    eval 'sub SIGTTOU () {27;}' unless defined(&SIGTTOU);
    eval 'sub SIGVTALRM () {28;}' unless defined(&SIGVTALRM);
    eval 'sub SIGPROF () {29;}' unless defined(&SIGPROF);
    eval 'sub SIGXCPU () {30;}' unless defined(&SIGXCPU);
    eval 'sub SIGXFSZ () {31;}' unless defined(&SIGXFSZ);
    eval 'sub SIGWAITING () {32;}' unless defined(&SIGWAITING);
    eval 'sub SIGLWP () {33;}' unless defined(&SIGLWP);
    eval 'sub SIGFREEZE () {34;}' unless defined(&SIGFREEZE);
    eval 'sub SIGTHAW () {35;}' unless defined(&SIGTHAW);
    eval 'sub SIGCANCEL () {36;}' unless defined(&SIGCANCEL);
    eval 'sub SIGLOST () {37;}' unless defined(&SIGLOST);
    eval 'sub SIGXRES () {38;}' unless defined(&SIGXRES);
    eval 'sub SIGJVM1 () {39;}' unless defined(&SIGJVM1);
    eval 'sub SIGJVM2 () {40;}' unless defined(&SIGJVM2);
    eval 'sub SIGINFO () {41;}' unless defined(&SIGINFO);
    eval 'sub _SIGRTMIN () {42;}' unless defined(&_SIGRTMIN);
    eval 'sub _SIGRTMAX () {73;}' unless defined(&_SIGRTMAX);
    eval 'sub SIGRTMIN () {( &_sysconf( &_SC_SIGRT_MIN));}' unless defined(&SIGRTMIN);
    eval 'sub SIGRTMAX () {( &_sysconf( &_SC_SIGRT_MAX));}' unless defined(&SIGRTMAX);
    if(defined(&__cplusplus)) {
	eval 'sub SIG_PF () { &SIG_TYP;}' unless defined(&SIG_PF);
	eval 'sub SIG_DFL () {( &SIG_PF)0;}' unless defined(&SIG_DFL);
	eval 'sub SIG_ERR () {( &SIG_PF)-1;}' unless defined(&SIG_ERR);
	eval 'sub SIG_IGN () {( &SIG_PF)1;}' unless defined(&SIG_IGN);
	eval 'sub SIG_HOLD () {( &SIG_PF)2;}' unless defined(&SIG_HOLD);
    }
 elsif(defined(&__lint)) {
	eval 'sub SIG_DFL () {0;}' unless defined(&SIG_DFL);
	eval 'sub SIG_ERR () {0;}' unless defined(&SIG_ERR);
	eval 'sub SIG_IGN () {0;}' unless defined(&SIG_IGN);
	eval 'sub SIG_HOLD () {0;}' unless defined(&SIG_HOLD);
    } else {
	eval 'sub SIG_DFL () {0;}' unless defined(&SIG_DFL);
	eval 'sub SIG_ERR () {-1;}' unless defined(&SIG_ERR);
	eval 'sub SIG_IGN () {1;}' unless defined(&SIG_IGN);
	eval 'sub SIG_HOLD () {2;}' unless defined(&SIG_HOLD);
    }
    eval 'sub SIG_BLOCK () {1;}' unless defined(&SIG_BLOCK);
    eval 'sub SIG_UNBLOCK () {2;}' unless defined(&SIG_UNBLOCK);
    eval 'sub SIG_SETMASK () {3;}' unless defined(&SIG_SETMASK);
    if(defined(&__cplusplus)) {
    }
}
1;
