require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_KMEM_H)) {
    eval 'sub _SYS_KMEM_H () {1;}' unless defined(&_SYS_KMEM_H);
    require 'sys/types.ph';
    require 'sys/vmem.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub KM_SLEEP () {0x;}' unless defined(&KM_SLEEP);
    eval 'sub KM_NOSLEEP () {0x1;}' unless defined(&KM_NOSLEEP);
    eval 'sub KM_PANIC () {0x2;}' unless defined(&KM_PANIC);
    eval 'sub KM_PUSHPAGE () {0x4;}' unless defined(&KM_PUSHPAGE);
    eval 'sub KM_NORMALPRI () {0x8;}' unless defined(&KM_NORMALPRI);
    eval 'sub KM_VMFLAGS () {0xff;}' unless defined(&KM_VMFLAGS);
    eval 'sub KM_FLAGS () {0xffff;}' unless defined(&KM_FLAGS);
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
    }
    eval 'sub KMC_NOTOUCH () {0x10000;}' unless defined(&KMC_NOTOUCH);
    eval 'sub KMC_NODEBUG () {0x20000;}' unless defined(&KMC_NODEBUG);
    eval 'sub KMC_NOMAGAZINE () {0x40000;}' unless defined(&KMC_NOMAGAZINE);
    eval 'sub KMC_NOHASH () {0x80000;}' unless defined(&KMC_NOHASH);
    eval 'sub KMC_QCACHE () {0x100000;}' unless defined(&KMC_QCACHE);
    eval 'sub KMC_KMEM_ALLOC () {0x200000;}' unless defined(&KMC_KMEM_ALLOC);
    eval 'sub KMC_IDENTIFIER () {0x400000;}' unless defined(&KMC_IDENTIFIER);
    eval 'sub KMC_PREFILL () {0x800000;}' unless defined(&KMC_PREFILL);
    eval("sub KMEM_CBRC_YES () { 0; }") unless defined(&KMEM_CBRC_YES);
    eval("sub KMEM_CBRC_NO () { 1; }") unless defined(&KMEM_CBRC_NO);
    eval("sub KMEM_CBRC_LATER () { 2; }") unless defined(&KMEM_CBRC_LATER);
    eval("sub KMEM_CBRC_DONT_NEED () { 3; }") unless defined(&KMEM_CBRC_DONT_NEED);
    eval("sub KMEM_CBRC_DONT_KNOW () { 4; }") unless defined(&KMEM_CBRC_DONT_KNOW);
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	eval 'sub POINTER_IS_VALID {
	    my($p) = @_;
    	    eval q((!(( &uintptr_t)($p) & 0x3)));
	}' unless defined(&POINTER_IS_VALID);
	eval 'sub POINTER_INVALIDATE {
	    my($pp) = @_;
    	    eval q((*($pp) = ( &void *)(( &uintptr_t)(*($pp)) | 0x1)));
	}' unless defined(&POINTER_INVALIDATE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
