require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_PARAM_H)) {
    eval 'sub _SYS_PARAM_H () {1;}' unless defined(&_SYS_PARAM_H);
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
	require 'sys/isa_defs.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(!defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	unless(defined(&_POSIX_VDISABLE)) {
	    eval 'sub _POSIX_VDISABLE () {0;}' unless defined(&_POSIX_VDISABLE);
	}
    }
    unless(defined(&MAX_INPUT)) {
	eval 'sub MAX_INPUT () {512;}' unless defined(&MAX_INPUT);
    }
    unless(defined(&MAX_CANON)) {
	eval 'sub MAX_CANON () {256;}' unless defined(&MAX_CANON);
    }
    eval 'sub UID_NOBODY () {65534;}' unless defined(&UID_NOBODY);
    eval 'sub GID_NOBODY () { &UID_NOBODY;}' unless defined(&GID_NOBODY);
    eval 'sub UID_UNKNOWN () {96;}' unless defined(&UID_UNKNOWN);
    eval 'sub GID_UNKNOWN () { &UID_UNKNOWN;}' unless defined(&GID_UNKNOWN);
    eval 'sub UID_DLADM () {15;}' unless defined(&UID_DLADM);
    eval 'sub UID_NETADM () {16;}' unless defined(&UID_NETADM);
    eval 'sub GID_NETADM () {65;}' unless defined(&GID_NETADM);
    eval 'sub UID_NOACCESS () {60002;}' unless defined(&UID_NOACCESS);
    if(defined(&_KERNEL)) {
	eval 'sub MAX_TASKID () {999999;}' unless defined(&MAX_TASKID);
	eval 'sub MAX_MAXPID () {999999;}' unless defined(&MAX_MAXPID);
	eval 'sub MAXEPHUID () {0xfffffffc;}' unless defined(&MAXEPHUID);
	eval 'sub FAMOUS_PID_SCHED () {0;}' unless defined(&FAMOUS_PID_SCHED);
	eval 'sub FAMOUS_PID_INIT () {1;}' unless defined(&FAMOUS_PID_INIT);
	eval 'sub FAMOUS_PID_PAGEOUT () {2;}' unless defined(&FAMOUS_PID_PAGEOUT);
	eval 'sub FAMOUS_PID_FSFLUSH () {3;}' unless defined(&FAMOUS_PID_FSFLUSH);
	eval 'sub FAMOUS_PIDS () {4;}' unless defined(&FAMOUS_PIDS);
    }
    if(defined(&DEBUG)) {
	eval 'sub DEFAULT_MAXPID () {999999;}' unless defined(&DEFAULT_MAXPID);
	eval 'sub DEFAULT_JUMPPID () {100000;}' unless defined(&DEFAULT_JUMPPID);
    } else {
	eval 'sub DEFAULT_MAXPID () {30000;}' unless defined(&DEFAULT_MAXPID);
	eval 'sub DEFAULT_JUMPPID () {0;}' unless defined(&DEFAULT_JUMPPID);
    }
    eval 'sub MAXUID () {2147483647;}' unless defined(&MAXUID);
    eval 'sub MAXPROJID () { &MAXUID;}' unless defined(&MAXPROJID);
    eval 'sub MAXLINK () {32767;}' unless defined(&MAXLINK);
    eval 'sub MINEPHUID () {0x80000000;}' unless defined(&MINEPHUID);
    eval 'sub NMOUNT () {40;}' unless defined(&NMOUNT);
    eval 'sub CANBSIZ () {256;}' unless defined(&CANBSIZ);
    eval 'sub NOFILE () {20;}' unless defined(&NOFILE);
    eval 'sub NGROUPS_UMIN () {0;}' unless defined(&NGROUPS_UMIN);
    eval 'sub NGROUPS_UMAX () {1024;}' unless defined(&NGROUPS_UMAX);
    eval 'sub NGROUPS_OLDMAX () {32;}' unless defined(&NGROUPS_OLDMAX);
    eval 'sub NGROUPS_MAX_DEFAULT () {16;}' unless defined(&NGROUPS_MAX_DEFAULT);
    eval 'sub NZERO () {20;}' unless defined(&NZERO);
    eval 'sub NBPW () {$sizeof{\'int\'};}' unless defined(&NBPW);
    unless(defined(&NULL)) {
	if(defined(&_LP64)) {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	} else {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	}
    }
    eval 'sub CMASK () {022;}' unless defined(&CMASK);
    eval 'sub CDLIMIT () {(1<<11);}' unless defined(&CDLIMIT);
    eval 'sub NBPS () {0x20000;}' unless defined(&NBPS);
    eval 'sub NBPSCTR () {512;}' unless defined(&NBPSCTR);
    eval 'sub UBSIZE () {512;}' unless defined(&UBSIZE);
    eval 'sub SCTRSHFT () {9;}' unless defined(&SCTRSHFT);
    if(defined(&_LITTLE_ENDIAN)) {
	eval 'sub lobyte {
	    my($X) = @_;
    	    eval q(((($X))[0]));
	}' unless defined(&lobyte);
	eval 'sub hibyte {
	    my($X) = @_;
    	    eval q(((($X))[1]));
	}' unless defined(&hibyte);
	eval 'sub loword {
	    my($X) = @_;
    	    eval q(((( &ushort_t *)($X))[0]));
	}' unless defined(&loword);
	eval 'sub hiword {
	    my($X) = @_;
    	    eval q(((( &ushort_t *)($X))[1]));
	}' unless defined(&hiword);
    }
    if(defined(&_BIG_ENDIAN)) {
	eval 'sub lobyte {
	    my($X) = @_;
    	    eval q(((($X))[1]));
	}' unless defined(&lobyte);
	eval 'sub hibyte {
	    my($X) = @_;
    	    eval q(((($X))[0]));
	}' unless defined(&hibyte);
	eval 'sub loword {
	    my($X) = @_;
    	    eval q(((( &ushort_t *)($X))[1]));
	}' unless defined(&loword);
	eval 'sub hiword {
	    my($X) = @_;
    	    eval q(((( &ushort_t *)($X))[0]));
	}' unless defined(&hiword);
    }
    eval 'sub SYSNAME () {9;}' unless defined(&SYSNAME);
    eval 'sub PREMOTE () {39;}' unless defined(&PREMOTE);
    eval 'sub MAXPATHLEN () {1024;}' unless defined(&MAXPATHLEN);
    eval 'sub TYPICALMAXPATHLEN () {64;}' unless defined(&TYPICALMAXPATHLEN);
    eval 'sub MAXSYMLINKS () {20;}' unless defined(&MAXSYMLINKS);
    eval 'sub MAXNAMELEN () {256;}' unless defined(&MAXNAMELEN);
    unless(defined(&MIN)) {
	eval 'sub MIN {
	    my($a,$b) = @_;
    	    eval q(((($a)<($b))?($a):($b)));
	}' unless defined(&MIN);
    }
    unless(defined(&MAX)) {
	eval 'sub MAX {
	    my($a,$b) = @_;
    	    eval q(((($a)>($b))?($a):($b)));
	}' unless defined(&MAX);
    }
    eval 'sub howmany {
        my($x, $y) = @_;
	    eval q(((($x)+(($y)-1))/($y)));
    }' unless defined(&howmany);
    eval 'sub roundup {
        my($x, $y) = @_;
	    eval q((((($x)+(($y)-1))/($y))*($y)));
    }' unless defined(&roundup);
    eval 'sub powerof2 {
        my($x) = @_;
	    eval q(((($x) & (($x) - 1)) == 0));
    }' unless defined(&powerof2);
    eval 'sub MAXLINKNAMELEN () {32;}' unless defined(&MAXLINKNAMELEN);
    unless(defined(&NADDR)) {
	eval 'sub NADDR () {13;}' unless defined(&NADDR);
    }
    unless(defined(&PIPE_BUF)) {
	eval 'sub PIPE_BUF () {5120;}' unless defined(&PIPE_BUF);
    }
    unless(defined(&PIPE_MAX)) {
	eval 'sub PIPE_MAX () {5120;}' unless defined(&PIPE_MAX);
    }
    unless(defined(&NBBY)) {
	eval 'sub NBBY () {8;}' unless defined(&NBBY);
    }
    eval 'sub dkblock {
        my($bp) = @_;
	    eval q((($bp)-> &b_blkno));
    }' unless defined(&dkblock);
    eval 'sub dkunit {
        my($bp) = @_;
	    eval q(( &minor(($bp)-> &b_dev) >> 3));
    }' unless defined(&dkunit);
    eval 'sub MAXBSIZE () {8192;}' unless defined(&MAXBSIZE);
    eval 'sub DEV_BSIZE () {512;}' unless defined(&DEV_BSIZE);
    eval 'sub DEV_BSHIFT () {9;}' unless defined(&DEV_BSHIFT);
    eval 'sub MAXFRAG () {8;}' unless defined(&MAXFRAG);
    if(defined(&_SYSCALL32)) {
	eval 'sub MAXOFF32_T () {0x7fffffff;}' unless defined(&MAXOFF32_T);
    }
    if(defined(&_LP64)) {
	eval 'sub MAXOFF_T () {0x7fffffffffffffff;}' unless defined(&MAXOFF_T);
	eval 'sub MAXOFFSET_T () {0x7fffffffffffffff;}' unless defined(&MAXOFFSET_T);
    } else {
	eval 'sub MAXOFF_T () {0x7fffffff;}' unless defined(&MAXOFF_T);
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub MAXOFFSET_T () {0x7fffffffffffffff;}' unless defined(&MAXOFFSET_T);
	} else {
	    eval 'sub MAXOFFSET_T () {0x7fffffff;}' unless defined(&MAXOFFSET_T);
	}
    }
    eval 'sub btodb {
        my($bytes) = @_;
	    eval q((($bytes) >>  &DEV_BSHIFT));
    }' unless defined(&btodb);
    eval 'sub dbtob {
        my($db) = @_;
	    eval q((($db) <<  &DEV_BSHIFT));
    }' unless defined(&dbtob);
    eval 'sub lbtodb {
        my($bytes) = @_;
	    eval q((( &u_offset_t)($bytes) >>  &DEV_BSHIFT));
    }' unless defined(&lbtodb);
    eval 'sub ldbtob {
        my($db) = @_;
	    eval q((( &u_offset_t)($db) <<  &DEV_BSHIFT));
    }' unless defined(&ldbtob);
    unless(defined(&_ASM)) {
	unless(defined(&NODEV)) {
	    eval 'sub NODEV () {( &dev_t)(-1);}' unless defined(&NODEV);
	    if(defined(&_SYSCALL32)) {
		eval 'sub NODEV32 () {( &dev32_t)(-1);}' unless defined(&NODEV32);
	    }
	}
    }
    eval 'sub NCARGS32 () {0x100000;}' unless defined(&NCARGS32);
    eval 'sub NCARGS64 () {0x200000;}' unless defined(&NCARGS64);
    if(defined(&_LP64)) {
	eval 'sub NCARGS () { &NCARGS64;}' unless defined(&NCARGS);
    } else {
	eval 'sub NCARGS () { &NCARGS32;}' unless defined(&NCARGS);
    }
    eval 'sub FSHIFT () {8;}' unless defined(&FSHIFT);
    eval 'sub FSCALE () {(1<< &FSHIFT);}' unless defined(&FSCALE);
    if(defined(&_KERNEL)  && !defined(&_ASM)) {
	eval 'sub DELAY {
	    my($n) = @_;
    	    eval q( &drv_usecwait($n));
	}' unless defined(&DELAY);
	eval 'sub CDELAY {
	    my($c, $n) = @_;
    	    eval q({  &register \'int\'  &N = $n;  &while (-- &N > 0) {  &if ($c)  &break;  &drv_usecwait(1); } });
	}' unless defined(&CDELAY);
    }
    if(defined(&__cplusplus)) {
    }
    if((defined(&_KERNEL) || defined(&_KMEMUSER))) {
	if(defined(&_MACHDEP)) {
	    require 'sys/machparam.ph';
	}
	if(defined(&__cplusplus)) {
	}
	if(defined(&_KERNEL)  && !defined(&_ASM)) {
	}
	if(defined(&lint)) {
	}
	if(!defined(&_MACHDEP)) {
	    if(defined(&_KERNEL)  && !defined(&_ASM)) {
	    }
	    eval 'sub PAGESIZE () { &_pagesize;}' unless defined(&PAGESIZE);
	    eval 'sub PAGESHIFT () { &_pageshift;}' unless defined(&PAGESHIFT);
	    eval 'sub PAGEOFFSET () { &_pageoffset;}' unless defined(&PAGEOFFSET);
	    eval 'sub PAGEMASK () { &_pagemask;}' unless defined(&PAGEMASK);
	    eval 'sub MMU_PAGESIZE () { &_mmu_pagesize;}' unless defined(&MMU_PAGESIZE);
	    eval 'sub MMU_PAGESHIFT () { &_mmu_pageshift;}' unless defined(&MMU_PAGESHIFT);
	    eval 'sub MMU_PAGEOFFSET () { &_mmu_pageoffset;}' unless defined(&MMU_PAGEOFFSET);
	    eval 'sub MMU_PAGEMASK () { &_mmu_pagemask;}' unless defined(&MMU_PAGEMASK);
	    eval 'sub KERNELBASE () { &_kernelbase;}' unless defined(&KERNELBASE);
	    eval 'sub USERLIMIT () { &_userlimit;}' unless defined(&USERLIMIT);
	    eval 'sub USERLIMIT32 () { &_userlimit32;}' unless defined(&USERLIMIT32);
	    eval 'sub ARGSBASE () { &_argsbase;}' unless defined(&ARGSBASE);
	    eval 'sub DEFAULTSTKSZ () { &_defaultstksz;}' unless defined(&DEFAULTSTKSZ);
	    eval 'sub NCPU () { &_ncpu;}' unless defined(&NCPU);
	    eval 'sub NCPU_LOG2 () { &_ncpu_log2;}' unless defined(&NCPU_LOG2);
	    eval 'sub NCPU_P2 () { &_ncpu_p2;}' unless defined(&NCPU_P2);
	}
	eval 'sub mmu_ptob {
	    my($x) = @_;
    	    eval q((($x) <<  &MMU_PAGESHIFT));
	}' unless defined(&mmu_ptob);
	eval 'sub mmu_btop {
	    my($x) = @_;
    	    eval q(((($x)) >>  &MMU_PAGESHIFT));
	}' unless defined(&mmu_btop);
	eval 'sub mmu_btopr {
	    my($x) = @_;
    	    eval q((((($x) +  &MMU_PAGEOFFSET) >>  &MMU_PAGESHIFT)));
	}' unless defined(&mmu_btopr);
	eval 'sub mmu_ptod {
	    my($x) = @_;
    	    eval q((($x) << ( &MMU_PAGESHIFT -  &DEV_BSHIFT)));
	}' unless defined(&mmu_ptod);
	eval 'sub ptod {
	    my($x) = @_;
    	    eval q((($x) << ( &PAGESHIFT -  &DEV_BSHIFT)));
	}' unless defined(&ptod);
	if(defined(&_LP64)) {
	    eval 'sub ptob {
	        my($x) = @_;
    		eval q(((( &pgcnt_t)($x)) <<  &PAGESHIFT));
	    }' unless defined(&ptob);
	} else {
	    eval 'sub ptob {
	        my($x) = @_;
    		eval q((($x) <<  &PAGESHIFT));
	    }' unless defined(&ptob);
	}
	eval 'sub btop {
	    my($x) = @_;
    	    eval q(((($x) >>  &PAGESHIFT)));
	}' unless defined(&btop);
	eval 'sub btopr {
	    my($x) = @_;
    	    eval q((((($x) +  &PAGEOFFSET) >>  &PAGESHIFT)));
	}' unless defined(&btopr);
	eval 'sub NDPP () {( &PAGESIZE/ &DEV_BSIZE);}' unless defined(&NDPP);
	eval 'sub dtop {
	    my($DD) = @_;
    	    eval q(((($DD) +  &NDPP - 1) >> ( &PAGESHIFT -  &DEV_BSHIFT)));
	}' unless defined(&dtop);
	eval 'sub dtopt {
	    my($DD) = @_;
    	    eval q((($DD) >> ( &PAGESHIFT -  &DEV_BSHIFT)));
	}' unless defined(&dtopt);
	eval 'sub kbtop {
	    my($x) = @_;
    	    eval q((($x) >> ( &PAGESHIFT - 10)));
	}' unless defined(&kbtop);
	eval 'sub ptokb {
	    my($x) = @_;
    	    eval q((($x) << ( &PAGESHIFT - 10)));
	}' unless defined(&ptokb);
	eval 'sub _AIO_LISTIO_MAX () {(4096);}' unless defined(&_AIO_LISTIO_MAX);
	eval 'sub _AIO_MAX () {(-1);}' unless defined(&_AIO_MAX);
	eval 'sub _MQ_OPEN_MAX () {(-1);}' unless defined(&_MQ_OPEN_MAX);
	eval 'sub _MQ_PRIO_MAX () {(32);}' unless defined(&_MQ_PRIO_MAX);
	eval 'sub _SEM_NSEMS_MAX () { &INT_MAX;}' unless defined(&_SEM_NSEMS_MAX);
	eval 'sub _SEM_VALUE_MAX () { &INT_MAX;}' unless defined(&_SEM_VALUE_MAX);
	if(defined(&__cplusplus)) {
	}
    } else {
	require 'sys/unistd.ph';
	if(defined(&__cplusplus)) {
	}
	if(!defined(&_ASM)) {
	}
	eval 'sub HZ () {(( &clock_t) &_sysconf( &_SC_CLK_TCK));}' unless defined(&HZ);
	eval 'sub TICK () {(1000000000/(( &clock_t) &_sysconf( &_SC_CLK_TCK)));}' unless defined(&TICK);
	eval 'sub PAGESIZE () {( &_sysconf( &_SC_PAGESIZE));}' unless defined(&PAGESIZE);
	eval 'sub PAGEOFFSET () {( &PAGESIZE - 1);}' unless defined(&PAGEOFFSET);
	eval 'sub PAGEMASK () {(~ &PAGEOFFSET);}' unless defined(&PAGEMASK);
	eval 'sub MAXPID () {(( &pid_t) &_sysconf( &_SC_MAXPID));}' unless defined(&MAXPID);
	eval 'sub MAXEPHUID () {(( &uid_t) &_sysconf( &_SC_EPHID_MAX));}' unless defined(&MAXEPHUID);
	if(defined(&__cplusplus)) {
	}
    }
}
1;
