require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_PROCESSOR_H)) {
    eval 'sub _SYS_PROCESSOR_H () {1;}' unless defined(&_SYS_PROCESSOR_H);
    require 'sys/types.ph';
    require 'sys/procset.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub P_OFFLINE () {0x1;}' unless defined(&P_OFFLINE);
    eval 'sub P_ONLINE () {0x2;}' unless defined(&P_ONLINE);
    eval 'sub P_STATUS () {0x3;}' unless defined(&P_STATUS);
    eval 'sub P_FAULTED () {0x4;}' unless defined(&P_FAULTED);
    eval 'sub P_POWEROFF () {0x5;}' unless defined(&P_POWEROFF);
    eval 'sub P_NOINTR () {0x6;}' unless defined(&P_NOINTR);
    eval 'sub P_SPARE () {0x7;}' unless defined(&P_SPARE);
    eval 'sub P_BAD () { &P_FAULTED;}' unless defined(&P_BAD);
    eval 'sub P_FORCED () {0x10000000;}' unless defined(&P_FORCED);
    eval 'sub PS_OFFLINE () {"off-line";}' unless defined(&PS_OFFLINE);
    eval 'sub PS_ONLINE () {"on-line";}' unless defined(&PS_ONLINE);
    eval 'sub PS_FAULTED () {"faulted";}' unless defined(&PS_FAULTED);
    eval 'sub PS_POWEROFF () {"powered-off";}' unless defined(&PS_POWEROFF);
    eval 'sub PS_NOINTR () {"no-intr";}' unless defined(&PS_NOINTR);
    eval 'sub PS_SPARE () {"spare";}' unless defined(&PS_SPARE);
    eval 'sub PI_TYPELEN () {16;}' unless defined(&PI_TYPELEN);
    eval 'sub PI_FPUTYPE () {32;}' unless defined(&PI_FPUTYPE);
    eval 'sub PBIND_NONE () {-1;}' unless defined(&PBIND_NONE);
    eval 'sub PBIND_QUERY () {-2;}' unless defined(&PBIND_QUERY);
    eval 'sub PBIND_HARD () {-3;}' unless defined(&PBIND_HARD);
    eval 'sub PBIND_SOFT () {-4;}' unless defined(&PBIND_SOFT);
    eval 'sub PBIND_QUERY_TYPE () {-5;}' unless defined(&PBIND_QUERY_TYPE);
    unless(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
