require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_PROCSET_H)) {
    eval 'sub _SYS_PROCSET_H () {1;}' unless defined(&_SYS_PROCSET_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    require 'sys/signal.ph';
    eval 'sub P_INITPID () {1;}' unless defined(&P_INITPID);
    eval 'sub P_INITUID () {0;}' unless defined(&P_INITUID);
    eval 'sub P_INITPGID () {0;}' unless defined(&P_INITPGID);
    eval("sub P_PID () { 0; }") unless defined(&P_PID);
    eval("sub P_PPID () { 1; }") unless defined(&P_PPID);
    eval("sub P_PGID () { 2; }") unless defined(&P_PGID);
    eval("sub P_SID () { 3; }") unless defined(&P_SID);
    eval("sub P_CID () { 4; }") unless defined(&P_CID);
    eval("sub P_UID () { 5; }") unless defined(&P_UID);
    eval("sub P_GID () { 6; }") unless defined(&P_GID);
    eval("sub P_ALL () { 7; }") unless defined(&P_ALL);
    eval("sub P_LWPID () { 8; }") unless defined(&P_LWPID);
    eval("sub P_TASKID () { 9; }") unless defined(&P_TASKID);
    eval("sub P_PROJID () { 10; }") unless defined(&P_PROJID);
    eval("sub P_POOLID () { 11; }") unless defined(&P_POOLID);
    eval("sub P_ZONEID () { 12; }") unless defined(&P_ZONEID);
    eval("sub P_CTID () { 13; }") unless defined(&P_CTID);
    eval("sub P_CPUID () { 14; }") unless defined(&P_CPUID);
    eval("sub P_PSETID () { 15; }") unless defined(&P_PSETID);
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval("sub POP_DIFF () { 0; }") unless defined(&POP_DIFF);
	eval("sub POP_AND () { 1; }") unless defined(&POP_AND);
	eval("sub POP_OR () { 2; }") unless defined(&POP_OR);
	eval("sub POP_XOR () { 3; }") unless defined(&POP_XOR);
	eval 'sub setprocset {
	    my($psp, $op, $ltype, $lid, $rtype, $rid) = @_;
    	    eval q(($psp)-> &p_op = ($op); ($psp)-> &p_lidtype = ($ltype); ($psp)-> &p_lid = ($lid); ($psp)-> &p_ridtype = ($rtype); ($psp)-> &p_rid = ($rid););
	}' unless defined(&setprocset);
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
