require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_RCTL_H)) {
    eval 'sub _SYS_RCTL_H () {1;}' unless defined(&_SYS_RCTL_H);
    require 'sys/kmem.ph';
    require 'sys/resource.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub RCTL_LOCAL_NOACTION () {0x;}' unless defined(&RCTL_LOCAL_NOACTION);
    eval 'sub RCTL_LOCAL_SIGNAL () {0x1;}' unless defined(&RCTL_LOCAL_SIGNAL);
    eval 'sub RCTL_LOCAL_DENY () {0x2;}' unless defined(&RCTL_LOCAL_DENY);
    eval 'sub RCTL_LOCAL_MAXIMAL () {0x80000000;}' unless defined(&RCTL_LOCAL_MAXIMAL);
    eval 'sub RCTL_LOCAL_PROJDB () {0x40000000;}' unless defined(&RCTL_LOCAL_PROJDB);
    eval 'sub RCTL_LOCAL_ACTION_MASK () {0xffff0000;}' unless defined(&RCTL_LOCAL_ACTION_MASK);
    eval 'sub RCTL_LOCAL_MASK () {0xc0000003;}' unless defined(&RCTL_LOCAL_MASK);
    eval 'sub RCTL_GLOBAL_NOACTION () {0x;}' unless defined(&RCTL_GLOBAL_NOACTION);
    eval 'sub RCTL_GLOBAL_SYSLOG () {0x1;}' unless defined(&RCTL_GLOBAL_SYSLOG);
    eval 'sub RCTL_GLOBAL_NOBASIC () {0x80000000;}' unless defined(&RCTL_GLOBAL_NOBASIC);
    eval 'sub RCTL_GLOBAL_LOWERABLE () {0x40000000;}' unless defined(&RCTL_GLOBAL_LOWERABLE);
    eval 'sub RCTL_GLOBAL_DENY_ALWAYS () {0x20000000;}' unless defined(&RCTL_GLOBAL_DENY_ALWAYS);
    eval 'sub RCTL_GLOBAL_DENY_NEVER () {0x10000000;}' unless defined(&RCTL_GLOBAL_DENY_NEVER);
    eval 'sub RCTL_GLOBAL_FILE_SIZE () {0x8000000;}' unless defined(&RCTL_GLOBAL_FILE_SIZE);
    eval 'sub RCTL_GLOBAL_CPU_TIME () {0x4000000;}' unless defined(&RCTL_GLOBAL_CPU_TIME);
    eval 'sub RCTL_GLOBAL_SIGNAL_NEVER () {0x2000000;}' unless defined(&RCTL_GLOBAL_SIGNAL_NEVER);
    eval 'sub RCTL_GLOBAL_NOLOCALACTION () { &RCTL_GLOBAL_SIGNAL_NEVER;}' unless defined(&RCTL_GLOBAL_NOLOCALACTION);
    eval 'sub RCTL_GLOBAL_INFINITE () {0x1000000;}' unless defined(&RCTL_GLOBAL_INFINITE);
    eval 'sub RCTL_GLOBAL_UNOBSERVABLE () {0x800000;}' unless defined(&RCTL_GLOBAL_UNOBSERVABLE);
    eval 'sub RCTL_GLOBAL_SYSLOG_NEVER () {0x80000;}' unless defined(&RCTL_GLOBAL_SYSLOG_NEVER);
    eval 'sub RCTL_GLOBAL_BYTES () {0x400000;}' unless defined(&RCTL_GLOBAL_BYTES);
    eval 'sub RCTL_GLOBAL_SECONDS () {0x200000;}' unless defined(&RCTL_GLOBAL_SECONDS);
    eval 'sub RCTL_GLOBAL_COUNT () {0x100000;}' unless defined(&RCTL_GLOBAL_COUNT);
    eval 'sub RCTL_GLOBAL_ACTION_MASK () {0xffff0000;}' unless defined(&RCTL_GLOBAL_ACTION_MASK);
    eval 'sub RCTL_GLOBAL_MASK () {0xfff80001;}' unless defined(&RCTL_GLOBAL_MASK);
    eval 'sub RCTL_FIRST () {0x;}' unless defined(&RCTL_FIRST);
    eval 'sub RCTL_NEXT () {0x1;}' unless defined(&RCTL_NEXT);
    eval 'sub RCTL_USAGE () {0x2;}' unless defined(&RCTL_USAGE);
    eval 'sub RCTL_INSERT () {0x;}' unless defined(&RCTL_INSERT);
    eval 'sub RCTL_DELETE () {0x1;}' unless defined(&RCTL_DELETE);
    eval 'sub RCTL_REPLACE () {0x2;}' unless defined(&RCTL_REPLACE);
    eval 'sub RCTL_USE_RECIPIENT_PID () {0x10000000;}' unless defined(&RCTL_USE_RECIPIENT_PID);
    eval 'sub RCTLSYS_ACTION_MASK () {0xffff0000;}' unless defined(&RCTLSYS_ACTION_MASK);
    eval 'sub RCTLSYS_MASK () {0x10000003;}' unless defined(&RCTLSYS_MASK);
    eval 'sub RCPRIV_BASIC () {0x1000000;}' unless defined(&RCPRIV_BASIC);
    eval 'sub RCPRIV_PRIVILEGED () {0x4000000;}' unless defined(&RCPRIV_PRIVILEGED);
    eval 'sub RCPRIV_SYSTEM () {0x7000000;}' unless defined(&RCPRIV_SYSTEM);
    eval("sub RCENTITY_PROCESS () { 0; }") unless defined(&RCENTITY_PROCESS);
    eval("sub RCENTITY_TASK () { 1; }") unless defined(&RCENTITY_TASK);
    eval("sub RCENTITY_PROJECT () { 2; }") unless defined(&RCENTITY_PROJECT);
    eval("sub RCENTITY_ZONE () { 3; }") unless defined(&RCENTITY_ZONE);
    eval 'sub RC_MAX_ENTITY () { &RCENTITY_ZONE;}' unless defined(&RC_MAX_ENTITY);
    unless(defined(&_KERNEL)) {
    } else {
	require 'sys/mutex.ph';
	eval 'sub RCT_NONE () {0x;}' unless defined(&RCT_NONE);
	eval 'sub RCT_DENY () {0x1;}' unless defined(&RCT_DENY);
	eval 'sub RCT_SIGNAL () {0x2;}' unless defined(&RCT_SIGNAL);
	eval 'sub RCT_STRLOG () {0x4;}' unless defined(&RCT_STRLOG);
	eval 'sub RCT_LK_ABANDONED () {0x80000000;}' unless defined(&RCT_LK_ABANDONED);
	eval 'sub RCD_DUP () {0x1;}' unless defined(&RCD_DUP);
	eval 'sub RCD_CALLBACK () {0x2;}' unless defined(&RCD_CALLBACK);
	eval 'sub RCA_SAFE () {0x;}' unless defined(&RCA_SAFE);
	eval 'sub RCA_UNSAFE_SIGINFO () {0x1;}' unless defined(&RCA_UNSAFE_SIGINFO);
	eval 'sub RCA_UNSAFE_ALL () {0x2;}' unless defined(&RCA_UNSAFE_ALL);
	eval 'sub RCTLOP_ACTION {
	    my($r, $p, $e) = @_;
    	    eval q(( ($r->{rc_dict_entry}->{rcd_ops}->{rco_action})($r, $p, $e)));
	}' unless defined(&RCTLOP_ACTION);
	eval 'sub RCTLOP_GET_USAGE {
	    my($r, $p) = @_;
    	    eval q(( ($r->{rc_dict_entry}->{rcd_ops}->{rco_get_usage})($r, $p)));
	}' unless defined(&RCTLOP_GET_USAGE);
	eval 'sub RCTLOP_SET {
	    my($r, $p, $e, $v) = @_;
    	    eval q(( ($r->{rc_dict_entry}->{rcd_ops}->{rco_set})($r, $p, $e, $v)));
	}' unless defined(&RCTLOP_SET);
	eval 'sub RCTLOP_TEST {
	    my($r, $p, $e, $v, $i, $f) = @_;
    	    eval q(( ($r->{rc_dict_entry}->{rcd_ops}->{rco_test})($r, $p, $e, $v, $i, $f)));
	}' unless defined(&RCTLOP_TEST);
	eval 'sub RCTLOP_NO_USAGE {
	    my($r) = @_;
    	    eval q(( ($r->{rc_dict_entry}->{rcd_ops}->{rco_get_usage}) ==  &rcop_no_usage));
	}' unless defined(&RCTLOP_NO_USAGE);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
