require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_REGSET_H)) {
    eval 'sub _SYS_REGSET_H () {1;}' unless defined(&_SYS_REGSET_H);
    require 'sys/feature_tests.ph';
    if(!defined(&_ASM)) {
	require 'sys/types.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval 'sub REG_GSBASE () {27;}' unless defined(&REG_GSBASE);
	eval 'sub REG_FSBASE () {26;}' unless defined(&REG_FSBASE);
	eval 'sub REG_DS () {25;}' unless defined(&REG_DS);
	eval 'sub REG_ES () {24;}' unless defined(&REG_ES);
	eval 'sub REG_GS () {23;}' unless defined(&REG_GS);
	eval 'sub REG_FS () {22;}' unless defined(&REG_FS);
	eval 'sub REG_SS () {21;}' unless defined(&REG_SS);
	eval 'sub REG_RSP () {20;}' unless defined(&REG_RSP);
	eval 'sub REG_RFL () {19;}' unless defined(&REG_RFL);
	eval 'sub REG_CS () {18;}' unless defined(&REG_CS);
	eval 'sub REG_RIP () {17;}' unless defined(&REG_RIP);
	eval 'sub REG_ERR () {16;}' unless defined(&REG_ERR);
	eval 'sub REG_TRAPNO () {15;}' unless defined(&REG_TRAPNO);
	eval 'sub REG_RAX () {14;}' unless defined(&REG_RAX);
	eval 'sub REG_RCX () {13;}' unless defined(&REG_RCX);
	eval 'sub REG_RDX () {12;}' unless defined(&REG_RDX);
	eval 'sub REG_RBX () {11;}' unless defined(&REG_RBX);
	eval 'sub REG_RBP () {10;}' unless defined(&REG_RBP);
	eval 'sub REG_RSI () {9;}' unless defined(&REG_RSI);
	eval 'sub REG_RDI () {8;}' unless defined(&REG_RDI);
	eval 'sub REG_R8 () {7;}' unless defined(&REG_R8);
	eval 'sub REG_R9 () {6;}' unless defined(&REG_R9);
	eval 'sub REG_R10 () {5;}' unless defined(&REG_R10);
	eval 'sub REG_R11 () {4;}' unless defined(&REG_R11);
	eval 'sub REG_R12 () {3;}' unless defined(&REG_R12);
	eval 'sub REG_R13 () {2;}' unless defined(&REG_R13);
	eval 'sub REG_R14 () {1;}' unless defined(&REG_R14);
	eval 'sub REG_R15 () {0;}' unless defined(&REG_R15);
	if(defined(&_I386_REGS) || (defined(&_KERNEL)  && defined(&_SYSCALL32_IMPL))) {
	    eval 'sub SS () {18;}' unless defined(&SS);
	    eval 'sub UESP () {17;}' unless defined(&UESP);
	    eval 'sub EFL () {16;}' unless defined(&EFL);
	    eval 'sub CS () {15;}' unless defined(&CS);
	    eval 'sub EIP () {14;}' unless defined(&EIP);
	    eval 'sub ERR () {13;}' unless defined(&ERR);
	    eval 'sub TRAPNO () {12;}' unless defined(&TRAPNO);
	    eval 'sub EAX () {11;}' unless defined(&EAX);
	    eval 'sub ECX () {10;}' unless defined(&ECX);
	    eval 'sub EDX () {9;}' unless defined(&EDX);
	    eval 'sub EBX () {8;}' unless defined(&EBX);
	    eval 'sub ESP () {7;}' unless defined(&ESP);
	    eval 'sub EBP () {6;}' unless defined(&EBP);
	    eval 'sub ESI () {5;}' unless defined(&ESI);
	    eval 'sub EDI () {4;}' unless defined(&EDI);
	    eval 'sub DS () {3;}' unless defined(&DS);
	    eval 'sub ES () {2;}' unless defined(&ES);
	    eval 'sub FS () {1;}' unless defined(&FS);
	    eval 'sub GS () {0;}' unless defined(&GS);
	}
	if(defined(&__amd64)) {
	    eval 'sub REG_PC () { &REG_RIP;}' unless defined(&REG_PC);
	    eval 'sub REG_FP () { &REG_RBP;}' unless defined(&REG_FP);
	    eval 'sub REG_SP () { &REG_RSP;}' unless defined(&REG_SP);
	    eval 'sub REG_PS () { &REG_RFL;}' unless defined(&REG_PS);
	    eval 'sub REG_R0 () { &REG_RAX;}' unless defined(&REG_R0);
	    eval 'sub REG_R1 () { &REG_RDX;}' unless defined(&REG_R1);
	} else {
	    eval 'sub REG_PC () { &EIP;}' unless defined(&REG_PC);
	    eval 'sub REG_FP () { &EBP;}' unless defined(&REG_FP);
	    eval 'sub REG_SP () { &UESP;}' unless defined(&REG_SP);
	    eval 'sub REG_PS () { &EFL;}' unless defined(&REG_PS);
	    eval 'sub REG_R0 () { &EAX;}' unless defined(&REG_R0);
	    eval 'sub REG_R1 () { &EDX;}' unless defined(&REG_R1);
	}
    }
    if(defined(&__amd64)) {
	eval 'sub _NGREG () {28;}' unless defined(&_NGREG);
    } else {
	eval 'sub _NGREG () {19;}' unless defined(&_NGREG);
    }
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval 'sub NGREG () { &_NGREG;}' unless defined(&NGREG);
    }
    if(!defined(&_ASM)) {
	if(defined(&_LP64) || defined(&_I32LPx)) {
	} else {
	}
	if(defined(&_SYSCALL32)) {
	}
	if(defined(&_SYSCALL32)) {
	    eval 'sub _NGREG32 () {19;}' unless defined(&_NGREG32);
	    eval 'sub _NGREG64 () {28;}' unless defined(&_NGREG64);
	}
	if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	    if(defined(&__amd64)) {
	    } else {
	    }
	    if(defined(&__amd64)) {
	    } else {
	    }
	    if(defined(&__amd64)) {
	    } else {
	    }
	    if(defined(&_SYSCALL32)) {
	    }
	    if(defined(&__i386)) {
	    }
	    if(defined(&__amd64)) {
		eval 'sub NDEBUGREG () {16;}' unless defined(&NDEBUGREG);
	    } else {
		eval 'sub NDEBUGREG () {8;}' unless defined(&NDEBUGREG);
	    }
	    if(defined(&_SYSCALL32)) {
	    }
	}
    }
    if(defined(&__i386)  && (!defined(&_KERNEL)  && !defined(&_XPG4_2) || defined(&__EXTENSIONS__))) {
	require 'sys/privregs.ph';
    }
    if(defined(&_XPG4_2)  && !defined(&__EXTENSIONS__)  && !defined(&_ASM)) {
	if(defined(&__amd64)) {
	} else {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
