require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SELECT_H)) {
    eval 'sub _SYS_SELECT_H () {1;}' unless defined(&_SYS_SELECT_H);
    require 'sys/feature_tests.ph';
    if(!defined(&_KERNEL)  && !defined(&_FAKE_KERNEL)) {
	if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	    require 'sys/time_impl.ph';
	}
	require 'sys/time.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	unless(defined(&_SIGSET_T)) {
	    eval 'sub _SIGSET_T () {1;}' unless defined(&_SIGSET_T);
	}
    }
    unless(defined(&FD_SETSIZE)) {
	if(defined(&_LP64)) {
	    eval 'sub FD_SETSIZE () {65536;}' unless defined(&FD_SETSIZE);
	} else {
	    eval 'sub FD_SETSIZE () {1024;}' unless defined(&FD_SETSIZE);
	}
    }
 elsif((defined(&FD_SETSIZE) ? &FD_SETSIZE : undef) > 1024 && !defined(&_LP64)) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	    }
	} else {
	    eval 'sub select () { &select_large_fdset;}' unless defined(&select);
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
		eval 'sub pselect () { &pselect_large_fdset;}' unless defined(&pselect);
	    }
	}
    }
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
    }
    eval 'sub _NBBY () {8;}' unless defined(&_NBBY);
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	unless(defined(&NBBY)) {
	    eval 'sub NBBY () { &_NBBY;}' unless defined(&NBBY);
	}
    }
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval 'sub NFDBITS () {($sizeof{ &fd_mask} *  &NBBY);}' unless defined(&NFDBITS);
    }
    eval 'sub FD_NFDBITS () {($sizeof{ &fds_mask} *  &_NBBY);}' unless defined(&FD_NFDBITS);
    eval 'sub __howmany {
        my($__x, $__y) = @_;
	    eval q(((($__x)+(($__y)-1))/($__y)));
    }' unless defined(&__howmany);
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	unless(defined(&howmany)) {
	    eval 'sub howmany {
	        my($x, $y) = @_;
    		eval q(((($x)+(($y)-1))/($y)));
	    }' unless defined(&howmany);
	}
    }
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
    } else {
    }
    eval 'sub FD_SET {
        my($__n, $__p) = @_;
	    eval q((($__p)-> $fds_bits[($__n)/ &FD_NFDBITS] |= (1 << (($__n) %  &FD_NFDBITS))));
    }' unless defined(&FD_SET);
    eval 'sub FD_CLR {
        my($__n, $__p) = @_;
	    eval q((($__p)-> $fds_bits[($__n)/ &FD_NFDBITS] &= ~(1 << (($__n) %  &FD_NFDBITS))));
    }' unless defined(&FD_CLR);
    eval 'sub FD_ISSET {
        my($__n, $__p) = @_;
	    eval q(((($__p)-> $fds_bits[($__n)/ &FD_NFDBITS] & (1 << (($__n) %  &FD_NFDBITS))) != 0));
    }' unless defined(&FD_ISSET);
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	eval 'sub FD_ZERO {
	    my($p) = @_;
    	    eval q( &bzero(($p), $sizeof{($p)}));
	}' unless defined(&FD_ZERO);
    } else {
	eval 'sub FD_ZERO {
	    my($__p) = @_;
    	    eval q(( &void)  &memset(($__p), 0, $sizeof{($__p)}));
	}' unless defined(&FD_ZERO);
    }
    if(!defined(&_KERNEL)  && !defined(&_FAKE_KERNEL)) {
	if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
