require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SIGINFO_H)) {
    eval 'sub _SYS_SIGINFO_H () {1;}' unless defined(&_SYS_SIGINFO_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined(&__XOPEN_OR_POSIX) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) > 2) || defined(&__EXTENSIONS__)) {
	unless(defined(&_SIGVAL)) {
	    eval 'sub _SIGVAL () {1;}' unless defined(&_SIGVAL);
	}
	if(defined(&_SYSCALL32)) {
	}
    } else {
    }
    if(!defined(&__XOPEN_OR_POSIX) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) > 2) || defined(&__EXTENSIONS__)) {
	unless(defined(&_SIGEVENT)) {
	    eval 'sub _SIGEVENT () {1;}' unless defined(&_SIGEVENT);
	}
	eval 'sub SIGEV_NONE () {1;}' unless defined(&SIGEV_NONE);
	eval 'sub SIGEV_SIGNAL () {2;}' unless defined(&SIGEV_SIGNAL);
	eval 'sub SIGEV_THREAD () {3;}' unless defined(&SIGEV_THREAD);
	eval 'sub SIGEV_PORT () {4;}' unless defined(&SIGEV_PORT);
	if(defined(&_SYSCALL32)) {
	}
    }
    if(!defined(&_POSIX_C_SOURCE) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) > 2) || defined(&__EXTENSIONS__)) {
	eval 'sub SI_FROMUSER {
	    my($sip) = @_;
    	    eval q((($sip)-> &si_code <= 0));
	}' unless defined(&SI_FROMUSER);
	eval 'sub SI_FROMKERNEL {
	    my($sip) = @_;
    	    eval q((($sip)-> &si_code > 0));
	}' unless defined(&SI_FROMKERNEL);
	eval 'sub SI_NOINFO () {32767;}' unless defined(&SI_NOINFO);
	eval 'sub SI_DTRACE () {2050;}' unless defined(&SI_DTRACE);
	eval 'sub SI_RCTL () {2049;}' unless defined(&SI_RCTL);
	eval 'sub SI_USER () {0;}' unless defined(&SI_USER);
	eval 'sub SI_LWP () {(-1);}' unless defined(&SI_LWP);
	eval 'sub SI_QUEUE () {(-2);}' unless defined(&SI_QUEUE);
	eval 'sub SI_TIMER () {(-3);}' unless defined(&SI_TIMER);
	eval 'sub SI_ASYNCIO () {(-4);}' unless defined(&SI_ASYNCIO);
	eval 'sub SI_MESGQ () {(-5);}' unless defined(&SI_MESGQ);
    }
    if(!defined(&_POSIX_C_SOURCE) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	require 'sys/machsig.ph';
	eval 'sub TRAP_BRKPT () {1;}' unless defined(&TRAP_BRKPT);
	eval 'sub TRAP_TRACE () {2;}' unless defined(&TRAP_TRACE);
	eval 'sub TRAP_RWATCH () {3;}' unless defined(&TRAP_RWATCH);
	eval 'sub TRAP_WWATCH () {4;}' unless defined(&TRAP_WWATCH);
	eval 'sub TRAP_XWATCH () {5;}' unless defined(&TRAP_XWATCH);
	eval 'sub TRAP_DTRACE () {6;}' unless defined(&TRAP_DTRACE);
	if(!defined(&_XOPEN_SOURCE) || defined(&__EXTENSIONS__)) {
	    eval 'sub NSIGTRAP () {6;}' unless defined(&NSIGTRAP);
	}
	eval 'sub CLD_EXITED () {1;}' unless defined(&CLD_EXITED);
	eval 'sub CLD_KILLED () {2;}' unless defined(&CLD_KILLED);
	eval 'sub CLD_DUMPED () {3;}' unless defined(&CLD_DUMPED);
	eval 'sub CLD_TRAPPED () {4;}' unless defined(&CLD_TRAPPED);
	eval 'sub CLD_STOPPED () {5;}' unless defined(&CLD_STOPPED);
	eval 'sub CLD_CONTINUED () {6;}' unless defined(&CLD_CONTINUED);
	if(!defined(&_XOPEN_SOURCE) || defined(&__EXTENSIONS__)) {
	    eval 'sub NSIGCLD () {6;}' unless defined(&NSIGCLD);
	}
	eval 'sub POLL_IN () {1;}' unless defined(&POLL_IN);
	eval 'sub POLL_OUT () {2;}' unless defined(&POLL_OUT);
	eval 'sub POLL_MSG () {3;}' unless defined(&POLL_MSG);
	eval 'sub POLL_ERR () {4;}' unless defined(&POLL_ERR);
	eval 'sub POLL_PRI () {5;}' unless defined(&POLL_PRI);
	eval 'sub POLL_HUP () {6;}' unless defined(&POLL_HUP);
	if(!defined(&_XOPEN_SOURCE) || defined(&__EXTENSIONS__)) {
	    eval 'sub NSIGPOLL () {6;}' unless defined(&NSIGPOLL);
	}
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	eval 'sub PROF_SIG () {1;}' unless defined(&PROF_SIG);
	eval 'sub NSIGPROF () {1;}' unless defined(&NSIGPROF);
    }
    if(!defined(&_POSIX_C_SOURCE) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) > 2) || defined(&__EXTENSIONS__)) {
	if(defined(&_LP64)) {
	    eval 'sub SI_MAXSZ () {256;}' unless defined(&SI_MAXSZ);
	    eval 'sub SI_PAD () {(( &SI_MAXSZ / $sizeof{\'int\'}) - 4);}' unless defined(&SI_PAD);
	} else {
	    eval 'sub SI_MAXSZ () {128;}' unless defined(&SI_MAXSZ);
	    eval 'sub SI_PAD () {(( &SI_MAXSZ / $sizeof{\'int\'}) - 3);}' unless defined(&SI_PAD);
	}
	if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    require 'sys/time_impl.ph';
	} else {
	    require 'sys/time_std_impl.ph';
	}
	require 'sys/types.ph';
	if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	} else {
	}
	if(defined(&_LP64)) {
	}
	if(!defined(&__XOPEN_OR_POSIX) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) > 2) || defined(&__EXTENSIONS__)) {
	} else {
	}
	if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	} else {
	}
	if(defined(&_SYSCALL32)) {
	    eval 'sub SI32_MAXSZ () {128;}' unless defined(&SI32_MAXSZ);
	    eval 'sub SI32_PAD () {(( &SI32_MAXSZ / $sizeof{ &int32_t}) - 3);}' unless defined(&SI32_PAD);
	}
	if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    if(defined(&_LP64)) {
	    }
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    } else {
	    }
	    eval 'sub SI_CANQUEUE {
	        my($c) = @_;
    		eval q((($c) <=  &SI_QUEUE));
	    }' unless defined(&SI_CANQUEUE);
	}
	eval 'sub si_pid () { ($__data->{__proc}->{__pid});}' unless defined(&si_pid);
	eval 'sub si_ctid () { ($__data->{__proc}->{__ctid});}' unless defined(&si_ctid);
	eval 'sub si_zoneid () { ($__data->{__proc}->{__zoneid});}' unless defined(&si_zoneid);
	eval 'sub si_status () { ($__data->{__proc}->{__pdata}->{__cld}->{__status});}' unless defined(&si_status);
	eval 'sub si_stime () { ($__data->{__proc}->{__pdata}->{__cld}->{__stime});}' unless defined(&si_stime);
	eval 'sub si_utime () { ($__data->{__proc}->{__pdata}->{__cld}->{__utime});}' unless defined(&si_utime);
	eval 'sub si_uid () { ($__data->{__proc}->{__pdata}->{__kill}->{__uid});}' unless defined(&si_uid);
	eval 'sub si_value () { ($__data->{__proc}->{__pdata}->{__kill}->{__value});}' unless defined(&si_value);
	eval 'sub si_addr () { ($__data->{__fault}->{__addr});}' unless defined(&si_addr);
	eval 'sub si_trapno () { ($__data->{__fault}->{__trapno});}' unless defined(&si_trapno);
	eval 'sub si_trapafter () { ($__data->{__fault}->{__trapno});}' unless defined(&si_trapafter);
	eval 'sub si_pc () { ($__data->{__fault}->{__pc});}' unless defined(&si_pc);
	eval 'sub si_fd () { ($__data->{__file}->{__fd});}' unless defined(&si_fd);
	eval 'sub si_band () { ($__data->{__file}->{__band});}' unless defined(&si_band);
	eval 'sub si_tstamp () { ($__data->{__prof}->{__tstamp});}' unless defined(&si_tstamp);
	eval 'sub si_syscall () { ($__data->{__prof}->{__syscall});}' unless defined(&si_syscall);
	eval 'sub si_nsysarg () { ($__data->{__prof}->{__nsysarg});}' unless defined(&si_nsysarg);
	eval 'sub si_sysarg () { ($__data->{__prof}->{__sysarg});}' unless defined(&si_sysarg);
	eval 'sub si_fault () { ($__data->{__prof}->{__fault});}' unless defined(&si_fault);
	eval 'sub si_faddr () { ($__data->{__prof}->{__faddr});}' unless defined(&si_faddr);
	eval 'sub si_mstate () { ($__data->{__prof}->{__mstate});}' unless defined(&si_mstate);
	eval 'sub si_entity () { ($__data->{__rctl}->{__entity});}' unless defined(&si_entity);
    }
    if(defined(&_SYSCALL32_IMPL)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
