require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SOCKET_H)) {
    eval 'sub _SYS_SOCKET_H () {1;}' unless defined(&_SYS_SOCKET_H);
    require 'sys/types.ph';
    require 'sys/uio.ph';
    require 'sys/feature_tests.ph';
    require 'sys/socket_impl.ph';
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	unless(defined(&_KERNEL)) {
	    require 'sys/netconfig.ph';
	}
	require 'netinet/in.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_SOCKLEN_T)) {
	eval 'sub _SOCKLEN_T () {1;}' unless defined(&_SOCKLEN_T);
	if(defined(&_XPG4_2)  && !defined(&_XPG5)  && !defined(&_LP64)) {
	} else {
	}
	if(defined(&_XPG4_2) || defined(&_BOOT)) {
	} else {
	}
    }
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	unless(defined(&NC_TPI_CLTS)) {
	    eval 'sub NC_TPI_CLTS () {1;}' unless defined(&NC_TPI_CLTS);
	    eval 'sub NC_TPI_COTS () {2;}' unless defined(&NC_TPI_COTS);
	    eval 'sub NC_TPI_COTS_ORD () {3;}' unless defined(&NC_TPI_COTS_ORD);
	    eval 'sub NC_TPI_RAW () {4;}' unless defined(&NC_TPI_RAW);
	}
    }
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval 'sub SOCK_STREAM () { &NC_TPI_COTS;}' unless defined(&SOCK_STREAM);
	eval 'sub SOCK_DGRAM () { &NC_TPI_CLTS;}' unless defined(&SOCK_DGRAM);
	eval 'sub SOCK_RAW () { &NC_TPI_RAW;}' unless defined(&SOCK_RAW);
    } else {
	eval 'sub SOCK_STREAM () {2;}' unless defined(&SOCK_STREAM);
	eval 'sub SOCK_DGRAM () {1;}' unless defined(&SOCK_DGRAM);
	eval 'sub SOCK_RAW () {4;}' unless defined(&SOCK_RAW);
    }
    eval 'sub SOCK_RDM () {5;}' unless defined(&SOCK_RDM);
    eval 'sub SOCK_SEQPACKET () {6;}' unless defined(&SOCK_SEQPACKET);
    eval 'sub SOCK_TYPE_MASK () {0xffff;}' unless defined(&SOCK_TYPE_MASK);
    eval 'sub SOCK_CLOEXEC () {0x80000;}' unless defined(&SOCK_CLOEXEC);
    eval 'sub SOCK_NONBLOCK () {0x100000;}' unless defined(&SOCK_NONBLOCK);
    eval 'sub SOCK_NDELAY () {0x200000;}' unless defined(&SOCK_NDELAY);
    eval 'sub SO_DEBUG () {0x1;}' unless defined(&SO_DEBUG);
    eval 'sub SO_ACCEPTCONN () {0x2;}' unless defined(&SO_ACCEPTCONN);
    eval 'sub SO_REUSEADDR () {0x4;}' unless defined(&SO_REUSEADDR);
    eval 'sub SO_KEEPALIVE () {0x8;}' unless defined(&SO_KEEPALIVE);
    eval 'sub SO_DONTROUTE () {0x10;}' unless defined(&SO_DONTROUTE);
    eval 'sub SO_BROADCAST () {0x20;}' unless defined(&SO_BROADCAST);
    eval 'sub SO_USELOOPBACK () {0x40;}' unless defined(&SO_USELOOPBACK);
    eval 'sub SO_LINGER () {0x80;}' unless defined(&SO_LINGER);
    eval 'sub SO_OOBINLINE () {0x100;}' unless defined(&SO_OOBINLINE);
    eval 'sub SO_DGRAM_ERRIND () {0x200;}' unless defined(&SO_DGRAM_ERRIND);
    eval 'sub SO_RECVUCRED () {0x400;}' unless defined(&SO_RECVUCRED);
    eval 'sub SO_ATTACH_FILTER () {0x40000001;}' unless defined(&SO_ATTACH_FILTER);
    eval 'sub SO_DETACH_FILTER () {0x40000002;}' unless defined(&SO_DETACH_FILTER);
    if(defined(&_KERNEL)) {
	eval 'sub SO_SND_COPYAVOID () {0x800;}' unless defined(&SO_SND_COPYAVOID);
	eval 'sub SO_SND_BUFINFO () {0x1000;}' unless defined(&SO_SND_BUFINFO);
    }
    eval 'sub SO_DONTLINGER () {(~ &SO_LINGER);}' unless defined(&SO_DONTLINGER);
    eval 'sub SO_SNDBUF () {0x1001;}' unless defined(&SO_SNDBUF);
    eval 'sub SO_RCVBUF () {0x1002;}' unless defined(&SO_RCVBUF);
    eval 'sub SO_SNDLOWAT () {0x1003;}' unless defined(&SO_SNDLOWAT);
    eval 'sub SO_RCVLOWAT () {0x1004;}' unless defined(&SO_RCVLOWAT);
    eval 'sub SO_SNDTIMEO () {0x1005;}' unless defined(&SO_SNDTIMEO);
    eval 'sub SO_RCVTIMEO () {0x1006;}' unless defined(&SO_RCVTIMEO);
    eval 'sub SO_ERROR () {0x1007;}' unless defined(&SO_ERROR);
    eval 'sub SO_TYPE () {0x1008;}' unless defined(&SO_TYPE);
    eval 'sub SO_PROTOTYPE () {0x1009;}' unless defined(&SO_PROTOTYPE);
    eval 'sub SO_ANON_MLP () {0x100a;}' unless defined(&SO_ANON_MLP);
    eval 'sub SO_MAC_EXEMPT () {0x100b;}' unless defined(&SO_MAC_EXEMPT);
    eval 'sub SO_DOMAIN () {0x100c;}' unless defined(&SO_DOMAIN);
    eval 'sub SO_RCVPSH () {0x100d;}' unless defined(&SO_RCVPSH);
    eval 'sub SCM_RIGHTS () {0x1010;}' unless defined(&SCM_RIGHTS);
    eval 'sub SO_SECATTR () {0x1011;}' unless defined(&SO_SECATTR);
    eval 'sub SCM_UCRED () {0x1012;}' unless defined(&SCM_UCRED);
    eval 'sub SO_TIMESTAMP () {0x1013;}' unless defined(&SO_TIMESTAMP);
    eval 'sub SCM_TIMESTAMP () { &SO_TIMESTAMP;}' unless defined(&SCM_TIMESTAMP);
    eval 'sub SO_ALLZONES () {0x1014;}' unless defined(&SO_ALLZONES);
    eval 'sub SO_EXCLBIND () {0x1015;}' unless defined(&SO_EXCLBIND);
    eval 'sub SO_MAC_IMPLICIT () {0x1016;}' unless defined(&SO_MAC_IMPLICIT);
    eval 'sub SO_VRRP () {0x1017;}' unless defined(&SO_VRRP);
    if(defined(&_KERNEL)) {
	eval 'sub SO_SRCADDR () {0x2001;}' unless defined(&SO_SRCADDR);
	eval 'sub SO_FILEP () {0x2002;}' unless defined(&SO_FILEP);
	eval 'sub SO_UNIX_CLOSE () {0x2003;}' unless defined(&SO_UNIX_CLOSE);
    }
    eval 'sub FIL_ATTACH () {0x1;}' unless defined(&FIL_ATTACH);
    eval 'sub FIL_DETACH () {0x2;}' unless defined(&FIL_DETACH);
    eval 'sub FIL_LIST () {0x3;}' unless defined(&FIL_LIST);
    eval 'sub FILNAME_MAX () {32;}' unless defined(&FILNAME_MAX);
    eval 'sub FILF_PROG () {0x1;}' unless defined(&FILF_PROG);
    eval 'sub FILF_AUTO () {0x2;}' unless defined(&FILF_AUTO);
    eval 'sub FILF_BYPASS () {0x4;}' unless defined(&FILF_BYPASS);
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	eval 'sub SO_ACCEPTOR () {0x20000;}' unless defined(&SO_ACCEPTOR);
	eval 'sub SO_SOCKSTR () {0x40000;}' unless defined(&SO_SOCKSTR);
	eval 'sub SO_FALLBACK () {0x80000;}' unless defined(&SO_FALLBACK);
	eval 'sub SOCKET_SLEEP () { &KM_SLEEP;}' unless defined(&SOCKET_SLEEP);
	eval 'sub SOCKET_NOSLEEP () { &KM_NOSLEEP;}' unless defined(&SOCKET_NOSLEEP);
    }
    eval 'sub SOL_SOCKET () {0xffff;}' unless defined(&SOL_SOCKET);
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval 'sub SOL_ROUTE () {0xfffe;}' unless defined(&SOL_ROUTE);
    }
    eval 'sub SOL_PACKET () {0xfffd;}' unless defined(&SOL_PACKET);
    eval 'sub SOL_FILTER () {0xfffc;}' unless defined(&SOL_FILTER);
    eval 'sub AF_UNSPEC () {0;}' unless defined(&AF_UNSPEC);
    eval 'sub AF_UNIX () {1;}' unless defined(&AF_UNIX);
    eval 'sub AF_LOCAL () { &AF_UNIX;}' unless defined(&AF_LOCAL);
    eval 'sub AF_FILE () { &AF_UNIX;}' unless defined(&AF_FILE);
    eval 'sub AF_INET () {2;}' unless defined(&AF_INET);
    eval 'sub AF_IMPLINK () {3;}' unless defined(&AF_IMPLINK);
    eval 'sub AF_PUP () {4;}' unless defined(&AF_PUP);
    eval 'sub AF_CHAOS () {5;}' unless defined(&AF_CHAOS);
    eval 'sub AF_NS () {6;}' unless defined(&AF_NS);
    eval 'sub AF_NBS () {7;}' unless defined(&AF_NBS);
    eval 'sub AF_ECMA () {8;}' unless defined(&AF_ECMA);
    eval 'sub AF_DATAKIT () {9;}' unless defined(&AF_DATAKIT);
    eval 'sub AF_CCITT () {10;}' unless defined(&AF_CCITT);
    eval 'sub AF_SNA () {11;}' unless defined(&AF_SNA);
    eval 'sub AF_DECnet () {12;}' unless defined(&AF_DECnet);
    eval 'sub AF_DLI () {13;}' unless defined(&AF_DLI);
    eval 'sub AF_LAT () {14;}' unless defined(&AF_LAT);
    eval 'sub AF_HYLINK () {15;}' unless defined(&AF_HYLINK);
    eval 'sub AF_APPLETALK () {16;}' unless defined(&AF_APPLETALK);
    eval 'sub AF_NIT () {17;}' unless defined(&AF_NIT);
    eval 'sub AF_802 () {18;}' unless defined(&AF_802);
    eval 'sub AF_OSI () {19;}' unless defined(&AF_OSI);
    eval 'sub AF_X25 () {20;}' unless defined(&AF_X25);
    eval 'sub AF_OSINET () {21;}' unless defined(&AF_OSINET);
    eval 'sub AF_GOSIP () {22;}' unless defined(&AF_GOSIP);
    eval 'sub AF_IPX () {23;}' unless defined(&AF_IPX);
    eval 'sub AF_ROUTE () {24;}' unless defined(&AF_ROUTE);
    eval 'sub AF_LINK () {25;}' unless defined(&AF_LINK);
    eval 'sub AF_INET6 () {26;}' unless defined(&AF_INET6);
    eval 'sub AF_KEY () {27;}' unless defined(&AF_KEY);
    eval 'sub AF_NCA () {28;}' unless defined(&AF_NCA);
    eval 'sub AF_POLICY () {29;}' unless defined(&AF_POLICY);
    eval 'sub AF_INET_OFFLOAD () {30;}' unless defined(&AF_INET_OFFLOAD);
    eval 'sub AF_TRILL () {31;}' unless defined(&AF_TRILL);
    eval 'sub AF_PACKET () {32;}' unless defined(&AF_PACKET);
    eval 'sub AF_MAX () {32;}' unless defined(&AF_MAX);
    eval 'sub PF_UNSPEC () { &AF_UNSPEC;}' unless defined(&PF_UNSPEC);
    eval 'sub PF_UNIX () { &AF_UNIX;}' unless defined(&PF_UNIX);
    eval 'sub PF_LOCAL () { &PF_UNIX;}' unless defined(&PF_LOCAL);
    eval 'sub PF_FILE () { &PF_UNIX;}' unless defined(&PF_FILE);
    eval 'sub PF_INET () { &AF_INET;}' unless defined(&PF_INET);
    eval 'sub PF_IMPLINK () { &AF_IMPLINK;}' unless defined(&PF_IMPLINK);
    eval 'sub PF_PUP () { &AF_PUP;}' unless defined(&PF_PUP);
    eval 'sub PF_CHAOS () { &AF_CHAOS;}' unless defined(&PF_CHAOS);
    eval 'sub PF_NS () { &AF_NS;}' unless defined(&PF_NS);
    eval 'sub PF_NBS () { &AF_NBS;}' unless defined(&PF_NBS);
    eval 'sub PF_ECMA () { &AF_ECMA;}' unless defined(&PF_ECMA);
    eval 'sub PF_DATAKIT () { &AF_DATAKIT;}' unless defined(&PF_DATAKIT);
    eval 'sub PF_CCITT () { &AF_CCITT;}' unless defined(&PF_CCITT);
    eval 'sub PF_SNA () { &AF_SNA;}' unless defined(&PF_SNA);
    eval 'sub PF_DECnet () { &AF_DECnet;}' unless defined(&PF_DECnet);
    eval 'sub PF_DLI () { &AF_DLI;}' unless defined(&PF_DLI);
    eval 'sub PF_LAT () { &AF_LAT;}' unless defined(&PF_LAT);
    eval 'sub PF_HYLINK () { &AF_HYLINK;}' unless defined(&PF_HYLINK);
    eval 'sub PF_APPLETALK () { &AF_APPLETALK;}' unless defined(&PF_APPLETALK);
    eval 'sub PF_NIT () { &AF_NIT;}' unless defined(&PF_NIT);
    eval 'sub PF_802 () { &AF_802;}' unless defined(&PF_802);
    eval 'sub PF_OSI () { &AF_OSI;}' unless defined(&PF_OSI);
    eval 'sub PF_X25 () { &AF_X25;}' unless defined(&PF_X25);
    eval 'sub PF_OSINET () { &AF_OSINET;}' unless defined(&PF_OSINET);
    eval 'sub PF_GOSIP () { &AF_GOSIP;}' unless defined(&PF_GOSIP);
    eval 'sub PF_IPX () { &AF_IPX;}' unless defined(&PF_IPX);
    eval 'sub PF_ROUTE () { &AF_ROUTE;}' unless defined(&PF_ROUTE);
    eval 'sub PF_LINK () { &AF_LINK;}' unless defined(&PF_LINK);
    eval 'sub PF_INET6 () { &AF_INET6;}' unless defined(&PF_INET6);
    eval 'sub PF_KEY () { &AF_KEY;}' unless defined(&PF_KEY);
    eval 'sub PF_NCA () { &AF_NCA;}' unless defined(&PF_NCA);
    eval 'sub PF_POLICY () { &AF_POLICY;}' unless defined(&PF_POLICY);
    eval 'sub PF_INET_OFFLOAD () { &AF_INET_OFFLOAD;}' unless defined(&PF_INET_OFFLOAD);
    eval 'sub PF_TRILL () { &AF_TRILL;}' unless defined(&PF_TRILL);
    eval 'sub PF_PACKET () { &AF_PACKET;}' unless defined(&PF_PACKET);
    eval 'sub PF_MAX () { &AF_MAX;}' unless defined(&PF_MAX);
    eval 'sub SOMAXCONN () {128;}' unless defined(&SOMAXCONN);
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	eval 'sub nmsghdr () { &msghdr;}' unless defined(&nmsghdr);
	if(defined(&_SYSCALL32)) {
	    eval 'sub nmsghdr32 () { &msghdr32;}' unless defined(&nmsghdr32);
	}
    }
    eval 'sub MSG_OOB () {0x1;}' unless defined(&MSG_OOB);
    eval 'sub MSG_PEEK () {0x2;}' unless defined(&MSG_PEEK);
    eval 'sub MSG_DONTROUTE () {0x4;}' unless defined(&MSG_DONTROUTE);
    eval 'sub MSG_EOR () {0x8;}' unless defined(&MSG_EOR);
    eval 'sub MSG_CTRUNC () {0x10;}' unless defined(&MSG_CTRUNC);
    eval 'sub MSG_TRUNC () {0x20;}' unless defined(&MSG_TRUNC);
    eval 'sub MSG_WAITALL () {0x40;}' unless defined(&MSG_WAITALL);
    eval 'sub MSG_DUPCTRL () {0x800;}' unless defined(&MSG_DUPCTRL);
    eval 'sub MSG_DONTWAIT () {0x80;}' unless defined(&MSG_DONTWAIT);
    eval 'sub MSG_NOTIFICATION () {0x100;}' unless defined(&MSG_NOTIFICATION);
    eval 'sub MSG_XPG4_2 () {0x8000;}' unless defined(&MSG_XPG4_2);
    eval 'sub MSG_MAXIOVLEN () {16;}' unless defined(&MSG_MAXIOVLEN);
    if(defined(&_KERNEL)) {
	eval 'sub MSG_MBLK_QUICKRELE () {0x10000000;}' unless defined(&MSG_MBLK_QUICKRELE);
	eval 'sub MSG_USERSPACE () {0x20000000;}' unless defined(&MSG_USERSPACE);
    }
    eval 'sub SHUT_RD () {0;}' unless defined(&SHUT_RD);
    eval 'sub SHUT_WR () {1;}' unless defined(&SHUT_WR);
    eval 'sub SHUT_RDWR () {2;}' unless defined(&SHUT_RDWR);
    if(defined(&__sparc)) {
	eval 'sub _CMSG_HDR_ALIGNMENT () {8;}' unless defined(&_CMSG_HDR_ALIGNMENT);
    } else {
	eval 'sub _CMSG_HDR_ALIGNMENT () {4;}' unless defined(&_CMSG_HDR_ALIGNMENT);
    }
    eval 'sub _CMSG_DATA_ALIGNMENT () {($sizeof{\'int\'});}' unless defined(&_CMSG_DATA_ALIGNMENT);
    eval 'sub _CMSG_HDR_ALIGN {
        my($x) = @_;
	    eval q(((( &uintptr_t)($x) +  &_CMSG_HDR_ALIGNMENT - 1) & ~( &_CMSG_HDR_ALIGNMENT - 1)));
    }' unless defined(&_CMSG_HDR_ALIGN);
    eval 'sub _CMSG_DATA_ALIGN {
        my($x) = @_;
	    eval q(((( &uintptr_t)($x) +  &_CMSG_DATA_ALIGNMENT - 1) & ~( &_CMSG_DATA_ALIGNMENT - 1)));
    }' unless defined(&_CMSG_DATA_ALIGN);
    eval 'sub CMSG_DATA {
        my($c) = @_;
	    eval q(( &_CMSG_DATA_ALIGN(($c) + 1)));
    }' unless defined(&CMSG_DATA);
    eval 'sub CMSG_FIRSTHDR {
        my($m) = @_;
	    eval q(((($m)-> &msg_controllen < $sizeof{\'struct cmsghdr\'}) ? 0: (($m)-> &msg_control)));
    }' unless defined(&CMSG_FIRSTHDR);
    eval 'sub CMSG_NXTHDR {
        my($m, $c) = @_;
	    eval q(((($c) == 0) ?  &CMSG_FIRSTHDR($m) : (((( &uintptr_t) &_CMSG_HDR_ALIGN(($c) + (($c))-> &cmsg_len) + $sizeof{\'struct cmsghdr\'}) > ((( &uintptr_t)(($m))-> &msg_control) + (( &uintptr_t)(($m))-> &msg_controllen))) ? (0) : ( &_CMSG_HDR_ALIGN(($c) + (($c))-> &cmsg_len)))));
    }' unless defined(&CMSG_NXTHDR);
    eval 'sub CMSG_SPACE {
        my($l) = @_;
	    eval q(( &_CMSG_HDR_ALIGN($sizeof{\'struct cmsghdr\'} + ($l))));
    }' unless defined(&CMSG_SPACE);
    eval 'sub CMSG_LEN {
        my($l) = @_;
	    eval q(( &_CMSG_DATA_ALIGN($sizeof{\'struct cmsghdr\'}) + ($l)));
    }' unless defined(&CMSG_LEN);
    if(!defined(&_KERNEL)) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	} else {
	    eval 'sub bind () { &__xnet_bind;}' unless defined(&bind);
	    eval 'sub connect () { &__xnet_connect;}' unless defined(&connect);
	    eval 'sub recvmsg () { &__xnet_recvmsg;}' unless defined(&recvmsg);
	    eval 'sub sendmsg () { &__xnet_sendmsg;}' unless defined(&sendmsg);
	    eval 'sub sendto () { &__xnet_sendto;}' unless defined(&sendto);
	    eval 'sub socket () { &__xnet_socket;}' unless defined(&socket);
	    eval 'sub socketpair () { &__xnet_socketpair;}' unless defined(&socketpair);
	    eval 'sub getsockopt () { &__xnet_getsockopt;}' unless defined(&getsockopt);
	}
	if(defined(&_XPG4_2)  && !defined(&_XPG5)) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub listen () { &__xnet_listen;}' unless defined(&listen);
	    }
	}
    }
    if(!defined(&_KERNEL) || defined(&_BOOT)) {
	if(!defined(&_XPG4_2) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
