require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_STREAM_H)) {
    eval 'sub _SYS_STREAM_H () {1;}' unless defined(&_SYS_STREAM_H);
    require 'sys/isa_defs.ph';
    if(defined(&_KERNEL)) {
	require 'sys/kmem.ph';
	require 'sys/uio.ph';
    }
    require 'sys/poll.ph';
    require 'sys/strmdep.ph';
    require 'sys/cred.ph';
    require 'sys/t_lock.ph';
    require 'sys/model.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub QENAB () {0x1;}' unless defined(&QENAB);
    eval 'sub QWANTR () {0x2;}' unless defined(&QWANTR);
    eval 'sub QWANTW () {0x4;}' unless defined(&QWANTW);
    eval 'sub QFULL () {0x8;}' unless defined(&QFULL);
    eval 'sub QREADR () {0x10;}' unless defined(&QREADR);
    eval 'sub QUSE () {0x20;}' unless defined(&QUSE);
    eval 'sub QNOENB () {0x40;}' unless defined(&QNOENB);
    eval 'sub QWANTRMQSYNC () {0x80;}' unless defined(&QWANTRMQSYNC);
    eval 'sub QBACK () {0x100;}' unless defined(&QBACK);
    eval 'sub QPAIR () {0x800;}' unless defined(&QPAIR);
    eval 'sub QPERQ () {0x1000;}' unless defined(&QPERQ);
    eval 'sub QPERMOD () {0x2000;}' unless defined(&QPERMOD);
    eval 'sub QMTSAFE () {0x4000;}' unless defined(&QMTSAFE);
    eval 'sub QMTOUTPERIM () {0x8000;}' unless defined(&QMTOUTPERIM);
    eval 'sub QMT_TYPEMASK () {( &QPAIR| &QPERQ| &QPERMOD| &QMTSAFE| &QMTOUTPERIM);}' unless defined(&QMT_TYPEMASK);
    eval 'sub QINSERVICE () {0x10000;}' unless defined(&QINSERVICE);
    eval 'sub QWCLOSE () {0x20000;}' unless defined(&QWCLOSE);
    eval 'sub QEND () {0x40000;}' unless defined(&QEND);
    eval 'sub QWANTWSYNC () {0x80000;}' unless defined(&QWANTWSYNC);
    eval 'sub QSYNCSTR () {0x100000;}' unless defined(&QSYNCSTR);
    eval 'sub QISDRV () {0x200000;}' unless defined(&QISDRV);
    eval 'sub _QINSERTING () {0x4000000;}' unless defined(&_QINSERTING);
    eval 'sub _QREMOVING () {0x8000000;}' unless defined(&_QREMOVING);
    eval 'sub _QASSOCIATED () {0x10000000;}' unless defined(&_QASSOCIATED);
    eval 'sub _QDIRECT () {0x20000000;}' unless defined(&_QDIRECT);
    eval 'sub Q_SQQUEUED () {0x1;}' unless defined(&Q_SQQUEUED);
    eval 'sub Q_SQDRAINING () {0x2;}' unless defined(&Q_SQDRAINING);
    eval 'sub QB_FULL () {0x1;}' unless defined(&QB_FULL);
    eval 'sub QB_WANTW () {0x2;}' unless defined(&QB_WANTW);
    eval 'sub QB_BACK () {0x4;}' unless defined(&QB_BACK);
    eval 'sub NBAND () {256;}' unless defined(&NBAND);
    eval("sub QHIWAT () { 0; }") unless defined(&QHIWAT);
    eval("sub QLOWAT () { 1; }") unless defined(&QLOWAT);
    eval("sub QMAXPSZ () { 2; }") unless defined(&QMAXPSZ);
    eval("sub QMINPSZ () { 3; }") unless defined(&QMINPSZ);
    eval("sub QCOUNT () { 4; }") unless defined(&QCOUNT);
    eval("sub QFIRST () { 5; }") unless defined(&QFIRST);
    eval("sub QLAST () { 6; }") unless defined(&QLAST);
    eval("sub QFLAG () { 7; }") unless defined(&QFLAG);
    eval("sub QSTRUIOT () { 8; }") unless defined(&QSTRUIOT);
    eval("sub QBAD () { 9; }") unless defined(&QBAD);
    eval 'sub STRUIOT_NONE () {-1;}' unless defined(&STRUIOT_NONE);
    eval 'sub STRUIOT_DONTCARE () {0;}' unless defined(&STRUIOT_DONTCARE);
    eval 'sub STRUIOT_STANDARD () {1;}' unless defined(&STRUIOT_STANDARD);
    eval 'sub DBLK_REFMAX () {255;}' unless defined(&DBLK_REFMAX);
    eval 'sub db_cksum16 () { ($db_struioun->{cksum}->{cksum_val}->{u16});}' unless defined(&db_cksum16);
    eval 'sub db_cksum32 () { ($db_struioun->{cksum}->{cksum_val}->{u32});}' unless defined(&db_cksum32);
    eval 'sub DB_CPID {
        my($mp) = @_;
	    eval q((($mp)-> ($b_datap->{db_cpid})));
    }' unless defined(&DB_CPID);
    eval 'sub DB_CRED {
        my($mp) = @_;
	    eval q((($mp)-> ($b_datap->{db_credp})));
    }' unless defined(&DB_CRED);
    eval 'sub DB_FTHDR {
        my($mp) = @_;
	    eval q((($mp)-> ($b_datap->{db_fthdr})));
    }' unless defined(&DB_FTHDR);
    eval 'sub DB_TCI {
        my($mp) = @_;
	    eval q((($mp)-> ($b_datap->{db_struioun}->{cksum}->{pad})));
    }' unless defined(&DB_TCI);
    eval 'sub DBLK_REFMIN () {0x1;}' unless defined(&DBLK_REFMIN);
    eval 'sub DBLK_COOKED () {0x2;}' unless defined(&DBLK_COOKED);
    eval 'sub DBLK_UIOA () {0x4;}' unless defined(&DBLK_UIOA);
    eval 'sub STRUIO_SPEC () {0x1;}' unless defined(&STRUIO_SPEC);
    eval 'sub STRUIO_DONE () {0x2;}' unless defined(&STRUIO_DONE);
    eval 'sub STRUIO_IP () {0x4;}' unless defined(&STRUIO_IP);
    eval 'sub STRUIO_ZC () {0x8;}' unless defined(&STRUIO_ZC);
    eval 'sub STRUIO_ZCNOTIFY () {0x10;}' unless defined(&STRUIO_ZCNOTIFY);
    eval 'sub MSGMARK () {0x1;}' unless defined(&MSGMARK);
    eval 'sub MSGNOLOOP () {0x2;}' unless defined(&MSGNOLOOP);
    eval 'sub MSGDELIM () {0x4;}' unless defined(&MSGDELIM);
    eval 'sub MSGMARKNEXT () {0x10;}' unless defined(&MSGMARKNEXT);
    eval 'sub MSGNOTMARKNEXT () {0x20;}' unless defined(&MSGNOTMARKNEXT);
    eval 'sub MSGWAITSYNC () {0x40;}' unless defined(&MSGWAITSYNC);
    eval 'sub M_DATA () {0x;}' unless defined(&M_DATA);
    eval 'sub M_PROTO () {0x1;}' unless defined(&M_PROTO);
    eval 'sub M_MULTIDATA () {0x2;}' unless defined(&M_MULTIDATA);
    eval 'sub M_BREAK () {0x8;}' unless defined(&M_BREAK);
    eval 'sub M_PASSFP () {0x9;}' unless defined(&M_PASSFP);
    eval 'sub M_EVENT () {0xa;}' unless defined(&M_EVENT);
    eval 'sub M_SIG () {0xb;}' unless defined(&M_SIG);
    eval 'sub M_DELAY () {0xc;}' unless defined(&M_DELAY);
    eval 'sub M_CTL () {0xd;}' unless defined(&M_CTL);
    eval 'sub M_IOCTL () {0xe;}' unless defined(&M_IOCTL);
    eval 'sub M_SETOPTS () {0x10;}' unless defined(&M_SETOPTS);
    eval 'sub M_RSE () {0x11;}' unless defined(&M_RSE);
    eval 'sub M_IOCACK () {0x81;}' unless defined(&M_IOCACK);
    eval 'sub M_IOCNAK () {0x82;}' unless defined(&M_IOCNAK);
    eval 'sub M_PCPROTO () {0x83;}' unless defined(&M_PCPROTO);
    eval 'sub M_PCSIG () {0x84;}' unless defined(&M_PCSIG);
    eval 'sub M_READ () {0x85;}' unless defined(&M_READ);
    eval 'sub M_FLUSH () {0x86;}' unless defined(&M_FLUSH);
    eval 'sub M_STOP () {0x87;}' unless defined(&M_STOP);
    eval 'sub M_START () {0x88;}' unless defined(&M_START);
    eval 'sub M_HANGUP () {0x89;}' unless defined(&M_HANGUP);
    eval 'sub M_ERROR () {0x8a;}' unless defined(&M_ERROR);
    eval 'sub M_COPYIN () {0x8b;}' unless defined(&M_COPYIN);
    eval 'sub M_COPYOUT () {0x8c;}' unless defined(&M_COPYOUT);
    eval 'sub M_IOCDATA () {0x8d;}' unless defined(&M_IOCDATA);
    eval 'sub M_PCRSE () {0x8e;}' unless defined(&M_PCRSE);
    eval 'sub M_STOPI () {0x8f;}' unless defined(&M_STOPI);
    eval 'sub M_STARTI () {0x90;}' unless defined(&M_STARTI);
    eval 'sub M_PCEVENT () {0x91;}' unless defined(&M_PCEVENT);
    eval 'sub M_UNHANGUP () {0x92;}' unless defined(&M_UNHANGUP);
    eval 'sub M_CMD () {0x93;}' unless defined(&M_CMD);
    eval 'sub QNORM () {0x;}' unless defined(&QNORM);
    eval 'sub QPCTL () {0x80;}' unless defined(&QPCTL);
    if(defined(&_LP64)) {
    } else {
    }
    eval 'sub IOC_MODELS () { &DATAMODEL_MASK;}' unless defined(&IOC_MODELS);
    eval 'sub IOC_ILP32 () { &DATAMODEL_ILP32;}' unless defined(&IOC_ILP32);
    eval 'sub IOC_LP64 () { &DATAMODEL_LP64;}' unless defined(&IOC_LP64);
    eval 'sub IOC_NATIVE () { &DATAMODEL_NATIVE;}' unless defined(&IOC_NATIVE);
    eval 'sub IOC_NONE () { &DATAMODEL_NONE;}' unless defined(&IOC_NONE);
    eval 'sub IOC_CONVERT_FROM {
        my($iocp) = @_;
	    eval q( &ddi_model_convert_from( ($iocp)-> &ioc_flag));
    }' unless defined(&IOC_CONVERT_FROM);
    if(defined(&_LP64)) {
    } else {
    }
    if(defined(&_LP64)) {
    } else {
    }
    eval 'sub SO_ALL () {0x3f;}' unless defined(&SO_ALL);
    eval 'sub SO_READOPT () {0x1;}' unless defined(&SO_READOPT);
    eval 'sub SO_WROFF () {0x2;}' unless defined(&SO_WROFF);
    eval 'sub SO_MINPSZ () {0x4;}' unless defined(&SO_MINPSZ);
    eval 'sub SO_MAXPSZ () {0x8;}' unless defined(&SO_MAXPSZ);
    eval 'sub SO_HIWAT () {0x10;}' unless defined(&SO_HIWAT);
    eval 'sub SO_LOWAT () {0x20;}' unless defined(&SO_LOWAT);
    eval 'sub SO_MREADON () {0x40;}' unless defined(&SO_MREADON);
    eval 'sub SO_MREADOFF () {0x80;}' unless defined(&SO_MREADOFF);
    eval 'sub SO_NDELON () {0x100;}' unless defined(&SO_NDELON);
    eval 'sub SO_NDELOFF () {0x200;}' unless defined(&SO_NDELOFF);
    eval 'sub SO_ISTTY () {0x400;}' unless defined(&SO_ISTTY);
    eval 'sub SO_ISNTTY () {0x800;}' unless defined(&SO_ISNTTY);
    eval 'sub SO_TOSTOP () {0x1000;}' unless defined(&SO_TOSTOP);
    eval 'sub SO_TONSTOP () {0x2000;}' unless defined(&SO_TONSTOP);
    eval 'sub SO_BAND () {0x4000;}' unless defined(&SO_BAND);
    eval 'sub SO_DELIM () {0x8000;}' unless defined(&SO_DELIM);
    eval 'sub SO_NODELIM () {0x10000;}' unless defined(&SO_NODELIM);
    eval 'sub SO_STRHOLD () {0x20000;}' unless defined(&SO_STRHOLD);
    eval 'sub SO_ERROPT () {0x40000;}' unless defined(&SO_ERROPT);
    eval 'sub SO_COPYOPT () {0x80000;}' unless defined(&SO_COPYOPT);
    eval 'sub SO_MAXBLK () {0x100000;}' unless defined(&SO_MAXBLK);
    eval 'sub SO_TAIL () {0x200000;}' unless defined(&SO_TAIL);
    if(defined(&_KERNEL)) {
	eval 'sub DEF_IOV_MAX () {16;}' unless defined(&DEF_IOV_MAX);
	eval 'sub INFOD_FIRSTBYTES () {0x2;}' unless defined(&INFOD_FIRSTBYTES);
	eval 'sub INFOD_BYTES () {0x4;}' unless defined(&INFOD_BYTES);
	eval 'sub INFOD_COUNT () {0x8;}' unless defined(&INFOD_COUNT);
	eval 'sub INFOD_COPYOUT () {0x10;}' unless defined(&INFOD_COPYOUT);
    }
    eval 'sub MODOPEN () {0x1;}' unless defined(&MODOPEN);
    eval 'sub CLONEOPEN () {0x2;}' unless defined(&CLONEOPEN);
    eval 'sub OPENFAIL () {-1;}' unless defined(&OPENFAIL);
    eval 'sub BPRI_LO () {1;}' unless defined(&BPRI_LO);
    eval 'sub BPRI_MED () {2;}' unless defined(&BPRI_MED);
    eval 'sub BPRI_HI () {3;}' unless defined(&BPRI_HI);
    eval 'sub INFPSZ () {-1;}' unless defined(&INFPSZ);
    eval 'sub FLUSHALL () {1;}' unless defined(&FLUSHALL);
    eval 'sub FLUSHDATA () {0;}' unless defined(&FLUSHDATA);
    eval 'sub TRANSPARENT () {(-1);}' unless defined(&TRANSPARENT);
    eval 'sub STRHIGH () {5120;}' unless defined(&STRHIGH);
    eval 'sub STRLOW () {1024;}' unless defined(&STRLOW);
    eval 'sub PERIM_INNER () {1;}' unless defined(&PERIM_INNER);
    eval 'sub PERIM_OUTER () {2;}' unless defined(&PERIM_OUTER);
    eval 'sub canenable {
        my($q) = @_;
	    eval q(!(($q)-> &q_flag &  &QNOENB));
    }' unless defined(&canenable);
    eval 'sub datamsg {
        my($type) = @_;
	    eval q((($type) ==  &M_DATA || ($type) ==  &M_MULTIDATA || ($type) ==  &M_PROTO || ($type) ==  &M_PCPROTO || ($type) ==  &M_DELAY));
    }' unless defined(&datamsg);
    eval 'sub queclass {
        my($bp) = @_;
	    eval q(((($bp)-> ($b_datap->{db_type}) >=  &QPCTL) ?  &QPCTL :  &QNORM));
    }' unless defined(&queclass);
    eval 'sub straln {
        my($a) = @_;
	    eval q((( &intptr_t)($a) & -($sizeof{\'int\'}-1)));
    }' unless defined(&straln);
    eval 'sub bpsize {
        my($bp) = @_;
	    eval q((( ($bp->{b_datap}->{db_lim}) -  ($bp->{b_datap}->{db_base}))));
    }' unless defined(&bpsize);
    if(defined(&_KERNEL)) {
	eval 'sub NOERROR () {(-1);}' unless defined(&NOERROR);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
