require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_THREAD_H)) {
    eval 'sub _SYS_THREAD_H () {1;}' unless defined(&_SYS_THREAD_H);
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/klwp.ph';
    require 'sys/time.ph';
    require 'sys/signal.ph';
    require 'sys/kcpc.ph';
    if(defined(&__GNUC__)  && defined(&_ASM_INLINES)  && defined(&_KERNEL)) {
	require 'asm/thread.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub TS_FREE () {0x;}' unless defined(&TS_FREE);
    eval 'sub TS_SLEEP () {0x1;}' unless defined(&TS_SLEEP);
    eval 'sub TS_RUN () {0x2;}' unless defined(&TS_RUN);
    eval 'sub TS_ONPROC () {0x4;}' unless defined(&TS_ONPROC);
    eval 'sub TS_ZOMB () {0x8;}' unless defined(&TS_ZOMB);
    eval 'sub TS_STOPPED () {0x10;}' unless defined(&TS_STOPPED);
    eval 'sub TS_WAIT () {0x20;}' unless defined(&TS_WAIT);
    eval 'sub t_wchan0 () { ($t_lwpchan->{lc_wchan0});}' unless defined(&t_wchan0);
    eval 'sub t_wchan () { ($t_lwpchan->{lc_wchan});}' unless defined(&t_wchan);
    eval 'sub t_astflag () { ($_tu->{_ts}->{_t_astflag});}' unless defined(&t_astflag);
    eval 'sub t_sig_check () { ($_tu->{_ts}->{_t_sig_check});}' unless defined(&t_sig_check);
    eval 'sub t_post_sys () { ($_tu->{_ts}->{_t_post_sys});}' unless defined(&t_post_sys);
    eval 'sub t_trapret () { ($_tu->{_ts}->{_t_trapret});}' unless defined(&t_trapret);
    eval 'sub t_post_sys_ast () { ($_tu->{_t_post_sys_ast});}' unless defined(&t_post_sys_ast);
    if(defined(&__amd64)) {
    }
    eval 'sub t_dtrace_ft () { ($_tdu->{_t_dtrace_ft});}' unless defined(&t_dtrace_ft);
    eval 'sub t_dtrace_on () { ($_tdu->{_tds}->{_t_dtrace_on});}' unless defined(&t_dtrace_on);
    eval 'sub t_dtrace_step () { ($_tdu->{_tds}->{_t_dtrace_step});}' unless defined(&t_dtrace_step);
    eval 'sub t_dtrace_ret () { ($_tdu->{_tds}->{_t_dtrace_ret});}' unless defined(&t_dtrace_ret);
    eval 'sub t_dtrace_ast () { ($_tdu->{_tds}->{_t_dtrace_ast});}' unless defined(&t_dtrace_ast);
    if(defined(&__amd64)) {
	eval 'sub t_dtrace_reg () { ($_tdu->{_tds}->{_t_dtrace_reg});}' unless defined(&t_dtrace_reg);
    }
    if(defined(&__amd64)) {
    }
    eval 'sub T_INTR_THREAD () {0x1;}' unless defined(&T_INTR_THREAD);
    eval 'sub T_WAKEABLE () {0x2;}' unless defined(&T_WAKEABLE);
    eval 'sub T_TOMASK () {0x4;}' unless defined(&T_TOMASK);
    eval 'sub T_TALLOCSTK () {0x8;}' unless defined(&T_TALLOCSTK);
    eval 'sub T_FORKALL () {0x10;}' unless defined(&T_FORKALL);
    eval 'sub T_WOULDBLOCK () {0x20;}' unless defined(&T_WOULDBLOCK);
    eval 'sub T_DONTBLOCK () {0x40;}' unless defined(&T_DONTBLOCK);
    eval 'sub T_DONTPEND () {0x80;}' unless defined(&T_DONTPEND);
    eval 'sub T_SYS_PROF () {0x100;}' unless defined(&T_SYS_PROF);
    eval 'sub T_WAITCVSEM () {0x200;}' unless defined(&T_WAITCVSEM);
    eval 'sub T_WATCHPT () {0x400;}' unless defined(&T_WATCHPT);
    eval 'sub T_PANIC () {0x800;}' unless defined(&T_PANIC);
    eval 'sub T_LWPREUSE () {0x1000;}' unless defined(&T_LWPREUSE);
    eval 'sub T_CAPTURING () {0x2000;}' unless defined(&T_CAPTURING);
    eval 'sub T_VFPARENT () {0x4000;}' unless defined(&T_VFPARENT);
    eval 'sub T_DONTDTRACE () {0x8000;}' unless defined(&T_DONTDTRACE);
    eval 'sub TP_DAEMON () {0x1;}' unless defined(&TP_DAEMON);
    eval 'sub TP_HOLDLWP () {0x2;}' unless defined(&TP_HOLDLWP);
    eval 'sub TP_TWAIT () {0x4;}' unless defined(&TP_TWAIT);
    eval 'sub TP_LWPEXIT () {0x8;}' unless defined(&TP_LWPEXIT);
    eval 'sub TP_PRSTOP () {0x10;}' unless defined(&TP_PRSTOP);
    eval 'sub TP_CHKPT () {0x20;}' unless defined(&TP_CHKPT);
    eval 'sub TP_EXITLWP () {0x40;}' unless defined(&TP_EXITLWP);
    eval 'sub TP_PRVSTOP () {0x80;}' unless defined(&TP_PRVSTOP);
    eval 'sub TP_MSACCT () {0x100;}' unless defined(&TP_MSACCT);
    eval 'sub TP_STOPPING () {0x200;}' unless defined(&TP_STOPPING);
    eval 'sub TP_WATCHPT () {0x400;}' unless defined(&TP_WATCHPT);
    eval 'sub TP_PAUSE () {0x800;}' unless defined(&TP_PAUSE);
    eval 'sub TP_CHANGEBIND () {0x1000;}' unless defined(&TP_CHANGEBIND);
    eval 'sub TP_ZTHREAD () {0x2000;}' unless defined(&TP_ZTHREAD);
    eval 'sub TP_WATCHSTOP () {0x4000;}' unless defined(&TP_WATCHSTOP);
    eval 'sub TS_LOAD () {0x1;}' unless defined(&TS_LOAD);
    eval 'sub TS_DONT_SWAP () {0x2;}' unless defined(&TS_DONT_SWAP);
    eval 'sub TS_SWAPENQ () {0x4;}' unless defined(&TS_SWAPENQ);
    eval 'sub TS_ON_SWAPQ () {0x8;}' unless defined(&TS_ON_SWAPQ);
    eval 'sub TS_SIGNALLED () {0x10;}' unless defined(&TS_SIGNALLED);
    eval 'sub TS_PROJWAITQ () {0x20;}' unless defined(&TS_PROJWAITQ);
    eval 'sub TS_ZONEWAITQ () {0x40;}' unless defined(&TS_ZONEWAITQ);
    eval 'sub TS_CSTART () {0x100;}' unless defined(&TS_CSTART);
    eval 'sub TS_UNPAUSE () {0x200;}' unless defined(&TS_UNPAUSE);
    eval 'sub TS_XSTART () {0x400;}' unless defined(&TS_XSTART);
    eval 'sub TS_PSTART () {0x800;}' unless defined(&TS_PSTART);
    eval 'sub TS_RESUME () {0x1000;}' unless defined(&TS_RESUME);
    eval 'sub TS_CREATE () {0x2000;}' unless defined(&TS_CREATE);
    eval 'sub TS_RUNQMATCH () {0x4000;}' unless defined(&TS_RUNQMATCH);
    eval 'sub TS_ALLSTART () {( &TS_CSTART| &TS_UNPAUSE| &TS_XSTART| &TS_PSTART| &TS_RESUME| &TS_CREATE);}' unless defined(&TS_ALLSTART);
    eval 'sub TS_ANYWAITQ () {( &TS_PROJWAITQ| &TS_ZONEWAITQ);}' unless defined(&TS_ANYWAITQ);
    eval 'sub TB_ALLHARD () {0;}' unless defined(&TB_ALLHARD);
    eval 'sub TB_CPU_SOFT () {0x1;}' unless defined(&TB_CPU_SOFT);
    eval 'sub TB_PSET_SOFT () {0x2;}' unless defined(&TB_PSET_SOFT);
    eval 'sub TB_CPU_SOFT_SET {
        my($t) = @_;
	    eval q((($t)-> &t_bindflag |=  &TB_CPU_SOFT));
    }' unless defined(&TB_CPU_SOFT_SET);
    eval 'sub TB_CPU_HARD_SET {
        my($t) = @_;
	    eval q((($t)-> &t_bindflag &= ~ &TB_CPU_SOFT));
    }' unless defined(&TB_CPU_HARD_SET);
    eval 'sub TB_PSET_SOFT_SET {
        my($t) = @_;
	    eval q((($t)-> &t_bindflag |=  &TB_PSET_SOFT));
    }' unless defined(&TB_PSET_SOFT_SET);
    eval 'sub TB_PSET_HARD_SET {
        my($t) = @_;
	    eval q((($t)-> &t_bindflag &= ~ &TB_PSET_SOFT));
    }' unless defined(&TB_PSET_HARD_SET);
    eval 'sub TB_CPU_IS_SOFT {
        my($t) = @_;
	    eval q((($t)-> &t_bindflag &  &TB_CPU_SOFT));
    }' unless defined(&TB_CPU_IS_SOFT);
    eval 'sub TB_CPU_IS_HARD {
        my($t) = @_;
	    eval q((! &TB_CPU_IS_SOFT($t)));
    }' unless defined(&TB_CPU_IS_HARD);
    eval 'sub TB_PSET_IS_SOFT {
        my($t) = @_;
	    eval q((($t)-> &t_bindflag &  &TB_PSET_SOFT));
    }' unless defined(&TB_PSET_IS_SOFT);
    eval 'sub aston {
        my($t) = @_;
	    eval q((($t)-> &t_astflag = 1));
    }' unless defined(&aston);
    eval 'sub astoff {
        my($t) = @_;
	    eval q((($t)-> &t_astflag = 0));
    }' unless defined(&astoff);
    eval 'sub ISTOPPED {
        my($t) = @_;
	    eval q((($t)-> &t_state ==  &TS_STOPPED  && !(($t)-> &t_schedflag &  &TS_PSTART)));
    }' unless defined(&ISTOPPED);
    eval 'sub ISWAKEABLE {
        my($t) = @_;
	    eval q(((($t)-> &t_state ==  &TS_SLEEP  && (($t)-> &t_flag &  &T_WAKEABLE))));
    }' unless defined(&ISWAKEABLE);
    eval 'sub ISWAITING {
        my($t) = @_;
	    eval q((($t)-> &t_state ==  &TS_WAIT));
    }' unless defined(&ISWAITING);
    eval 'sub CPR_ISTOPPED {
        my($t) = @_;
	    eval q((($t)-> &t_state ==  &TS_STOPPED  && !(($t)-> &t_schedflag &  &TS_RESUME)));
    }' unless defined(&CPR_ISTOPPED);
    eval 'sub VSTOPPED {
        my($t) = @_;
	    eval q((($t)-> &t_proc_flag &  &TP_PRVSTOP));
    }' unless defined(&VSTOPPED);
    eval 'sub CPR_VSTOPPED {
        my($t) = @_;
	    eval q((($t)-> &t_state ==  &TS_SLEEP  && ($t)-> &t_wchan0 !=  &NULL  && (($t)-> &t_flag &  &T_WAKEABLE)  && (($t)-> &t_proc_flag &  &TP_CHKPT)));
    }' unless defined(&CPR_VSTOPPED);
    eval 'sub SUSPENDED {
        my($t) = @_;
	    eval q((($t)-> &t_state ==  &TS_STOPPED  && (($t)-> &t_schedflag & ( &TS_CSTART| &TS_UNPAUSE)) != ( &TS_CSTART| &TS_UNPAUSE)));
    }' unless defined(&SUSPENDED);
    eval 'sub INHERITED {
        my($t) = @_;
	    eval q((($t)-> &t_epri != 0));
    }' unless defined(&INHERITED);
    eval 'sub DISP_PRIO {
        my($t) = @_;
	    eval q((($t)-> &t_epri > ($t)-> &t_pri ? ($t)-> &t_epri : ($t)-> &t_pri));
    }' unless defined(&DISP_PRIO);
    eval 'sub ASSIGNED_PRIO {
        my($t) = @_;
	    eval q((($t)-> &t_pri));
    }' unless defined(&ASSIGNED_PRIO);
    eval 'sub SWAP_OK {
        my($t) = @_;
	    eval q((! &LOCK_HELD(($t)-> &t_lock)));
    }' unless defined(&SWAP_OK);
    eval 'sub proctot {
        my($x) = @_;
	    eval q((($x)-> &p_tlist));
    }' unless defined(&proctot);
    eval 'sub proctolwp {
        my($x) = @_;
	    eval q((($x)-> ($p_tlist->{t_lwp})));
    }' unless defined(&proctolwp);
    eval 'sub ttolwp {
        my($x) = @_;
	    eval q((($x)-> &t_lwp));
    }' unless defined(&ttolwp);
    eval 'sub ttoproc {
        my($x) = @_;
	    eval q((($x)-> &t_procp));
    }' unless defined(&ttoproc);
    eval 'sub ttoproj {
        my($x) = @_;
	    eval q((($x)-> &t_proj));
    }' unless defined(&ttoproj);
    eval 'sub ttozone {
        my($x) = @_;
	    eval q((($x)-> ($t_procp->{p_zone})));
    }' unless defined(&ttozone);
    eval 'sub lwptot {
        my($x) = @_;
	    eval q((($x)-> &lwp_thread));
    }' unless defined(&lwptot);
    eval 'sub lwptoproc {
        my($x) = @_;
	    eval q((($x)-> &lwp_procp));
    }' unless defined(&lwptoproc);
    eval 'sub t_pc () { ($t_pcb->{val[0]});}' unless defined(&t_pc);
    eval 'sub t_sp () { ($t_pcb->{val[1]});}' unless defined(&t_sp);
    if(defined(&_KERNEL)) {
	eval 'sub curthread () {( &threadp());}' unless defined(&curthread);
	eval 'sub curproc () {( &ttoproc( &curthread));}' unless defined(&curproc);
	eval 'sub curproj () {( &ttoproj( &curthread));}' unless defined(&curproj);
	eval 'sub curzone () {( ($curproc->{p_zone}));}' unless defined(&curzone);
	eval 'sub THREAD_FREE_BITS () {10;}' unless defined(&THREAD_FREE_BITS);
	eval 'sub THREAD_FREE_NUM () {(1<<  &THREAD_FREE_BITS);}' unless defined(&THREAD_FREE_NUM);
	eval 'sub THREAD_FREE_MASK () {( &THREAD_FREE_NUM - 1);}' unless defined(&THREAD_FREE_MASK);
	eval 'sub THREAD_FREE_1 () { &PTR24_LSB;}' unless defined(&THREAD_FREE_1);
	eval 'sub THREAD_FREE_2 () {( &PTR24_LSB +  &THREAD_FREE_BITS);}' unless defined(&THREAD_FREE_2);
	eval 'sub THREAD_FREE_SHIFT {
	    my($t) = @_;
    	    eval q((( >>  &THREAD_FREE_1) ^ (($t) >>  &THREAD_FREE_2)));
	}' unless defined(&THREAD_FREE_SHIFT);
	eval 'sub THREAD_FREE_HASH {
	    my($t) = @_;
    	    eval q(( &THREAD_FREE_SHIFT($t) &  &THREAD_FREE_MASK));
	}' unless defined(&THREAD_FREE_HASH);
	eval 'sub thread_unlock {
	    my($t) = @_;
    	    eval q( &disp_lock_exit(($t)-> &t_lockp));
	}' unless defined(&thread_unlock);
	eval 'sub thread_unlock_high {
	    my($t) = @_;
    	    eval q( &disp_lock_exit_high(($t)-> &t_lockp));
	}' unless defined(&thread_unlock_high);
	eval 'sub thread_unlock_nopreempt {
	    my($t) = @_;
    	    eval q( &disp_lock_exit_nopreempt(($t)-> &t_lockp));
	}' unless defined(&thread_unlock_nopreempt);
	eval 'sub THREAD_LOCK_HELD {
	    my($t) = @_;
    	    eval q(( &DISP_LOCK_HELD(($t)-> &t_lockp)));
	}' unless defined(&THREAD_LOCK_HELD);
    }
    eval 'sub THREAD_KPRI_REQUEST () {
        eval q(( ($curthread->{t_kpri_req})++));
    }' unless defined(&THREAD_KPRI_REQUEST);
    eval 'sub THREAD_KPRI_RELEASE () {
        eval q(( ($curthread->{t_kpri_req})--));
    }' unless defined(&THREAD_KPRI_RELEASE);
    eval 'sub THREAD_KPRI_RELEASE_N {
        my($n) = @_;
	    eval q(( ($curthread->{t_kpri_req}) -= ($n)));
    }' unless defined(&THREAD_KPRI_RELEASE_N);
    eval 'sub THREAD_CHANGE_PRI {
        my($t, $pri) = @_;
	    eval q({  &pri_t  &__new_pri = ($pri);  &DTRACE_SCHED2( &change__pri,  &kthread_t *, ($t),  &pri_t,  &__new_pri); ($t)-> &t_pri =  &__new_pri;  &schedctl_set_cidpri($t); });
    }' unless defined(&THREAD_CHANGE_PRI);
    eval 'sub THREAD_WILLCHANGE_PRI {
        my($t, $pri) = @_;
	    eval q({  &DTRACE_SCHED2( &change__pri,  &kthread_t *, ($t),  &pri_t, ($pri)); });
    }' unless defined(&THREAD_WILLCHANGE_PRI);
    eval 'sub THREAD_SET_STATE {
        my($tp, $state, $lp) = @_;
	    eval q((($tp)-> &t_state = $state, ($tp)-> &t_lockp = $lp));
    }' unless defined(&THREAD_SET_STATE);
    eval 'sub THREAD_TRANSITION {
        my($tp) = @_;
	    eval q( &thread_transition($tp););
    }' unless defined(&THREAD_TRANSITION);
    eval 'sub THREAD_TRANSITION_NOLOCK {
        my($tp) = @_;
	    eval q((($tp)-> &t_lockp =  &transition_lock));
    }' unless defined(&THREAD_TRANSITION_NOLOCK);
    eval 'sub THREAD_RUN {
        my($tp, $lp) = @_;
	    eval q( &THREAD_SET_STATE($tp,  &TS_RUN, $lp));
    }' unless defined(&THREAD_RUN);
    eval 'sub THREAD_WAIT {
        my($tp, $lp) = @_;
	    eval q( &THREAD_SET_STATE($tp,  &TS_WAIT, $lp));
    }' unless defined(&THREAD_WAIT);
    eval 'sub THREAD_SWAP {
        my($tp, $lp) = @_;
	    eval q( &THREAD_SET_STATE($tp,  &TS_RUN, $lp));
    }' unless defined(&THREAD_SWAP);
    eval 'sub THREAD_ZOMB {
        my($tp) = @_;
	    eval q( &THREAD_SET_STATE($tp,  &TS_ZOMB,  &NULL));
    }' unless defined(&THREAD_ZOMB);
    eval 'sub THREAD_ONPROC {
        my($tp, $cpu) = @_;
	    eval q( &THREAD_SET_STATE($tp,  &TS_ONPROC, ($cpu)-> &cpu_thread_lock));
    }' unless defined(&THREAD_ONPROC);
    eval 'sub THREAD_SLEEP {
        my($tp, $lp) = @_;
	    eval q({  &disp_lock_t * &tlp;  &tlp = ($tp)-> &t_lockp;  &THREAD_SET_STATE($tp,  &TS_SLEEP, $lp);  &disp_lock_exit_high( &tlp); });
    }' unless defined(&THREAD_SLEEP);
    eval 'sub THREAD_FREEINTR {
        my($tp, $cpu) = @_;
	    eval q( &THREAD_SET_STATE($tp,  &TS_FREE, ($cpu)-> &cpu_thread_lock));
    }' unless defined(&THREAD_FREEINTR);
    eval 'sub KMEM_STKINFO_PATTERN () {0xbadcbadcbadcbadc;}' unless defined(&KMEM_STKINFO_PATTERN);
    eval 'sub KMEM_STKINFO_LOG_SIZE () {16;}' unless defined(&KMEM_STKINFO_LOG_SIZE);
    eval 'sub KMEM_STKINFO_STR_SIZE () {64;}' unless defined(&KMEM_STKINFO_STR_SIZE);
    if(defined(&__cplusplus)) {
    }
}
1;
