require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_TIMER_H)) {
    eval 'sub _SYS_TIMER_H () {1;}' unless defined(&_SYS_TIMER_H);
    require 'sys/types.ph';
    require 'sys/proc.ph';
    require 'sys/thread.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub _TIMER_MAX () {32;}' unless defined(&_TIMER_MAX);
	eval 'sub ITLK_LOCKED () {0x1;}' unless defined(&ITLK_LOCKED);
	eval 'sub ITLK_WANTED () {0x2;}' unless defined(&ITLK_WANTED);
	eval 'sub ITLK_REMOVE () {0x4;}' unless defined(&ITLK_REMOVE);
	eval 'sub IT_SIGNAL () {0x1;}' unless defined(&IT_SIGNAL);
	eval 'sub IT_PORT () {0x2;}' unless defined(&IT_PORT);
	eval 'sub it_sigq () { ($__data->{__proc}->{__it_sigq});}' unless defined(&it_sigq);
	eval 'sub it_lwp () { ($__data->{__proc}->{__it_lwp});}' unless defined(&it_lwp);
	eval 'sub it_frontend () { ($__data->{__it_frontend});}' unless defined(&it_frontend);
	eval 'sub timerspecisset {
	    my($tvp) = @_;
    	    eval q((($tvp)-> &tv_sec || ($tvp)-> &tv_nsec));
	}' unless defined(&timerspecisset);
	eval 'sub timerspeccmp {
	    my($tvp, $uvp) = @_;
    	    eval q(((($tvp)-> &tv_sec - ($uvp)-> &tv_sec) ? (($tvp)-> &tv_sec - ($uvp)-> &tv_sec):(($tvp)-> &tv_nsec - ($uvp)-> &tv_nsec)));
	}' unless defined(&timerspeccmp);
	eval 'sub timerspecclear {
	    my($tvp) = @_;
    	    eval q((($tvp)-> &tv_sec = ($tvp)-> &tv_nsec = 0));
	}' unless defined(&timerspecclear);
	if(defined(&_SYSCALL32)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
