require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_UIO_H)) {
    eval 'sub _SYS_UIO_H () {1;}' unless defined(&_SYS_UIO_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    require 'sys/types.ph';
    if(defined(&_XPG4_2)) {
    } else {
	if(defined(&_LP64)) {
	} else {
	}
    }
    if(defined(&_SYSCALL32)) {
    }
    if(!defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval("sub UIO_USERSPACE () { 0; }") unless defined(&UIO_USERSPACE);
	eval("sub UIO_SYSSPACE () { 1; }") unless defined(&UIO_SYSSPACE);
	eval("sub UIO_USERISPACE () { 2; }") unless defined(&UIO_USERISPACE);
	eval 'sub UIOA_IOV_MAX () {16;}' unless defined(&UIOA_IOV_MAX);
	eval("sub UIOTYPE_ASYNCIO () { 0; }") unless defined(&UIOTYPE_ASYNCIO);
	eval("sub UIOTYPE_ZEROCOPY () { 1; }") unless defined(&UIOTYPE_ZEROCOPY);
	eval 'sub XUIO_XUZC_PRIV {
	    my($xuio) = @_;
    	    eval q( ($xuio->{xu_ext}->{xu_zc}->{xu_zc_priv}));
	}' unless defined(&XUIO_XUZC_PRIV);
	eval 'sub XUIO_XUZC_RW {
	    my($xuio) = @_;
    	    eval q( ($xuio->{xu_ext}->{xu_zc}->{xu_zc_rw}));
	}' unless defined(&XUIO_XUZC_RW);
	eval 'sub UIOA_ALLOC () {0x1;}' unless defined(&UIOA_ALLOC);
	eval 'sub UIOA_INIT () {0x2;}' unless defined(&UIOA_INIT);
	eval 'sub UIOA_ENABLED () {0x4;}' unless defined(&UIOA_ENABLED);
	eval 'sub UIOA_FINI () {0x8;}' unless defined(&UIOA_FINI);
	eval 'sub UIOA_CLR () {(~0xf);}' unless defined(&UIOA_CLR);
	eval 'sub UIOA_POLL () {0x10;}' unless defined(&UIOA_POLL);
	eval 'sub uio_loffset () { ($_uio_offset->{_f});}' unless defined(&uio_loffset);
	if(!defined(&_LP64)) {
	    eval 'sub uio_offset () { ($_uio_offset->{_p}->{_l});}' unless defined(&uio_offset);
	} else {
	    eval 'sub uio_offset () { &uio_loffset;}' unless defined(&uio_offset);
	}
	eval 'sub uio_llimit () { ($_uio_limit->{_f});}' unless defined(&uio_llimit);
	if(!defined(&_LP64)) {
	    eval 'sub uio_limit () { ($_uio_limit->{_p}->{_l});}' unless defined(&uio_limit);
	} else {
	    eval 'sub uio_limit () { &uio_llimit;}' unless defined(&uio_limit);
	}
	eval("sub UIO_READ () { 0; }") unless defined(&UIO_READ);
	eval("sub UIO_WRITE () { 1; }") unless defined(&UIO_WRITE);
	eval 'sub UIO_COPY_DEFAULT () {0x;}' unless defined(&UIO_COPY_DEFAULT);
	eval 'sub UIO_COPY_CACHED () {0x1;}' unless defined(&UIO_COPY_CACHED);
	eval 'sub UIO_ASYNC () {0x2;}' unless defined(&UIO_ASYNC);
	eval 'sub UIO_XUIO () {0x4;}' unless defined(&UIO_XUIO);
    }
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
    } else {
	if(!defined(&_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub preadv () { &preadv64;}' unless defined(&preadv);
		eval 'sub pwritev () { &pwritev64;}' unless defined(&pwritev);
	    }
	}
	if(defined(&_LP64)  && defined(&_LARGEFILE64_SOURCE)) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    } else {
		eval 'sub preadv64 () { &preadv;}' unless defined(&preadv64);
		eval 'sub pwritev64 () { &pwritev;}' unless defined(&pwritev64);
	    }
	}
	if(defined(&_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64)  && !defined(&__PRAGMA_REDEFINE_EXTNAME))) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
