require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_USER_H)) {
    eval 'sub _SYS_USER_H () {1;}' unless defined(&_SYS_USER_H);
    require 'sys/types.ph';
    require 'sys/signal.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
	require 'sys/param.ph';
	require 'sys/pcb.ph';
	require 'sys/siginfo.ph';
	require 'sys/resource.ph';
	require 'sys/time.ph';
	require 'sys/auxv.ph';
	require 'sys/errno.ph';
	require 'sys/t_lock.ph';
	require 'sys/refstr.ph';
	if(defined(&__cplusplus)) {
	}
	eval 'sub UF_ENTER {
	    my($ufp, $fip, $fd) = @_;
    	    eval q( &for (;;) {  &uf_entry_t * &_flist = ($fip)-> &fi_list; $ufp = & $_flist[$fd];  &ASSERT(($fd) < ($fip)-> &fi_nfiles);  &mutex_enter( ($ufp->{uf_lock}));  &if ( &_flist == ($fip)-> &fi_list)  &break;  &mutex_exit( ($ufp->{uf_lock})); });
	}' unless defined(&UF_ENTER);
	eval 'sub UF_EXIT {
	    my($ufp) = @_;
    	    eval q( &mutex_exit( ($ufp->{uf_lock})));
	}' unless defined(&UF_EXIT);
	eval 'sub PSARGSZ () {80;}' unless defined(&PSARGSZ);
	eval 'sub MAXCOMLEN () {16;}' unless defined(&MAXCOMLEN);
	if(defined(&__sparc)) {
	    eval 'sub __KERN_NAUXV_IMPL () {20;}' unless defined(&__KERN_NAUXV_IMPL);
	}
 elsif(defined(&__i386) || defined(&__amd64)) {
	    eval 'sub __KERN_NAUXV_IMPL () {22;}' unless defined(&__KERN_NAUXV_IMPL);
	}
	require 'sys/proc.ph';
	if(defined(&_KERNEL)) {
	    eval 'sub P_FINFO {
	        my($p) = @_;
    		eval q((($p)-> ($p_user->{u_finfo})));
	    }' unless defined(&P_FINFO);
	}
	if(defined(&__cplusplus)) {
	}
    } else {
	require 'sys/regset.ph';
	if(defined(&__cplusplus)) {
	}
	eval 'sub PSARGSZ () {80;}' unless defined(&PSARGSZ);
	if(defined(&__cplusplus)) {
	}
    }
}
1;
