require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FCNTL_H)) {
    eval 'sub _FCNTL_H () {1;}' unless defined(&_FCNTL_H);
    require 'features.ph';
    if(defined(&__EXTENSIONS__) || defined(&_XPG4)) {
	require 'sys/stat.ph';
    }
    require 'sys/types.ph';
    require 'sys/fcntl.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&__EXTENSIONS__) || defined(&_XPG4)) {
	unless(defined(&SEEK_SET)) {
	    eval 'sub SEEK_SET () {0;}' unless defined(&SEEK_SET);
	}
	unless(defined(&SEEK_CUR)) {
	    eval 'sub SEEK_CUR () {1;}' unless defined(&SEEK_CUR);
	}
	unless(defined(&SEEK_END)) {
	    eval 'sub SEEK_END () {2;}' unless defined(&SEEK_END);
	}
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	unless(defined(&SEEK_DATA)) {
	    eval 'sub SEEK_DATA () {3;}' unless defined(&SEEK_DATA);
	}
	unless(defined(&SEEK_HOLE)) {
	    eval 'sub SEEK_HOLE () {4;}' unless defined(&SEEK_HOLE);
	}
    }
    if(!defined(&_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	    }
	    if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE)) {
	    }
	} else {
	    eval 'sub open () { &open64;}' unless defined(&open);
	    eval 'sub creat () { &creat64;}' unless defined(&creat);
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
		eval 'sub posix_fadvise () { &posix_fadvise64;}' unless defined(&posix_fadvise);
		eval 'sub posix_fallocate () { &posix_fallocate64;}' unless defined(&posix_fallocate);
	    }
	    if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE)) {
		eval 'sub openat () { &openat64;}' unless defined(&openat);
		eval 'sub attropen () { &attropen64;}' unless defined(&attropen);
	    }
	}
    }
    if(defined(&_LP64)  && defined(&_LARGEFILE64_SOURCE)) {
	if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	    }
	    if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE)) {
	    }
	} else {
	    eval 'sub open64 () { &open;}' unless defined(&open64);
	    eval 'sub creat64 () { &creat;}' unless defined(&creat64);
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
		eval 'sub posix_fadvise64 () { &posix_fadvise;}' unless defined(&posix_fadvise64);
		eval 'sub posix_fallocate64 () { &posix_fallocate;}' unless defined(&posix_fallocate64);
	    }
	    if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE)) {
		eval 'sub openat64 () { &openat;}' unless defined(&openat64);
		eval 'sub attropen64 () { &attropen;}' unless defined(&attropen64);
	    }
	}
    }
    if(defined(&__STDC__)) {
	if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	}
	if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE)) {
	}
	if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX)) {
	}
	if(defined(&_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64)  && !defined(&__PRAGMA_REDEFINE_EXTNAME))) {
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	    }
	    if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE)) {
	    }
	}
    } else {
	if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	}
	if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE)) {
	}
	if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX)) {
	}
	if(defined(&_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64)  && !defined(&__PRAGMA_REDEFINE_EXTNAME))) {
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	    }
	    if(defined(&__EXTENSIONS__) || !defined(&__XOPEN_OR_POSIX) || defined(&_ATFILE_SOURCE)) {
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
