require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FEATURES_H)) {
    eval 'sub _FEATURES_H () {1;}' unless defined(&_FEATURES_H);
    if(defined(&__EXTENSIONS__)) {
	undef(&_GNU_SOURCE) if defined(&_GNU_SOURCE);
	eval 'sub _GNU_SOURCE () {1;}' unless defined(&_GNU_SOURCE);
    }
    if(defined(&_GNU_SOURCE)) {
	undef(&__EXTENSIONS__) if defined(&__EXTENSIONS__);
	eval 'sub __EXTENSIONS__ () {1;}' unless defined(&__EXTENSIONS__);
	undef(&_ISOC95_SOURCE) if defined(&_ISOC95_SOURCE);
	eval 'sub _ISOC95_SOURCE () {1;}' unless defined(&_ISOC95_SOURCE);
	undef(&_ISOC99_SOURCE) if defined(&_ISOC99_SOURCE);
	eval 'sub _ISOC99_SOURCE () {1;}' unless defined(&_ISOC99_SOURCE);
	undef(&_POSIX_SOURCE) if defined(&_POSIX_SOURCE);
	eval 'sub _POSIX_SOURCE () {1;}' unless defined(&_POSIX_SOURCE);
	undef(&_POSIX_C_SOURCE) if defined(&_POSIX_C_SOURCE);
	eval 'sub _POSIX_C_SOURCE () {200112;}' unless defined(&_POSIX_C_SOURCE);
	undef(&_XOPEN_SOURCE) if defined(&_XOPEN_SOURCE);
	eval 'sub _XOPEN_SOURCE () {600;}' unless defined(&_XOPEN_SOURCE);
	undef(&_XOPEN_SOURCE_EXTENDED) if defined(&_XOPEN_SOURCE_EXTENDED);
	eval 'sub _XOPEN_SOURCE_EXTENDED () {0;}' unless defined(&_XOPEN_SOURCE_EXTENDED);
	undef(&_LARGEFILE_SOURCE) if defined(&_LARGEFILE_SOURCE);
	eval 'sub _LARGEFILE_SOURCE () {1;}' unless defined(&_LARGEFILE_SOURCE);
	undef(&_LARGEFILE64_SOURCE) if defined(&_LARGEFILE64_SOURCE);
	eval 'sub _LARGEFILE64_SOURCE () {1;}' unless defined(&_LARGEFILE64_SOURCE);
	undef(&_BSD_SOURCE) if defined(&_BSD_SOURCE);
	eval 'sub _BSD_SOURCE () {1;}' unless defined(&_BSD_SOURCE);
	undef(&_SVID_SOURCE) if defined(&_SVID_SOURCE);
	eval 'sub _SVID_SOURCE () {1;}' unless defined(&_SVID_SOURCE);
	undef(&_ATFILE_SOURCE) if defined(&_ATFILE_SOURCE);
	eval 'sub _ATFILE_SOURCE () {1;}' unless defined(&_ATFILE_SOURCE);
	undef(&_DEFAULT_SOURCE) if defined(&_DEFAULT_SOURCE);
	eval 'sub _DEFAULT_SOURCE () {1;}' unless defined(&_DEFAULT_SOURCE);
    }
    if((defined (&_DEFAULT_SOURCE) || (!defined (&__STRICT_ANSI__)  && !defined (&_ISOC99_SOURCE)  && !defined (&_POSIX_SOURCE)  && !defined (&_POSIX_C_SOURCE)  && !defined (&_XOPEN_SOURCE)  && !defined (&_BSD_SOURCE)  && !defined (&_SVID_SOURCE)))) {
	undef(&__EXTENSIONS__) if defined(&__EXTENSIONS__);
	eval 'sub __EXTENSIONS__ () {1;}' unless defined(&__EXTENSIONS__);
	undef(&_DEFAULT_SOURCE) if defined(&_DEFAULT_SOURCE);
	eval 'sub _DEFAULT_SOURCE () {1;}' unless defined(&_DEFAULT_SOURCE);
	undef(&_BSD_SOURCE) if defined(&_BSD_SOURCE);
	eval 'sub _BSD_SOURCE () {1;}' unless defined(&_BSD_SOURCE);
	undef(&_SVID_SOURCE) if defined(&_SVID_SOURCE);
	eval 'sub _SVID_SOURCE () {1;}' unless defined(&_SVID_SOURCE);
    }
    unless(defined(&_XOPEN_SOURCE)) {
	eval 'sub _XOPEN_SOURCE () {600;}' unless defined(&_XOPEN_SOURCE);
    }
    if(defined (&__GNUC__)) {
	eval 'sub __GNUC_PREREQ {
	    my($maj, $min) = @_;
    	    eval q((( &__GNUC__ << 16) +  &__GNUC_MINOR__ >= (($maj) << 16) + ($min)));
	}' unless defined(&__GNUC_PREREQ);
    } else {
	eval 'sub __GNUC_PREREQ {
	    my($maj, $min) = @_;
    	    eval q(0);
	}' unless defined(&__GNUC_PREREQ);
    }
    require 'sys/feature_tests.ph';
    if(!defined(&__ASSEMBLER__)  && !defined(&_ASM)) {
	unless(defined(&_SYS_CDEFS_H)) {
	    require 'sys/cdefs.ph';
	}
    }
}
1;
