require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CLASS_H)) {
    eval 'sub _SYS_CLASS_H () {1;}' unless defined(&_SYS_CLASS_H);
    require 'sys/t_lock.ph';
    require 'sys/cred.ph';
    require 'sys/thread.ph';
    require 'sys/priocntl.ph';
    require 'sys/mutex.ph';
    require 'sys/uio.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub STATIC_SCHED () {( &krwlock_t *)0xffffffff;}' unless defined(&STATIC_SCHED);
    eval 'sub LOADABLE_SCHED {
        my($s) = @_;
	    eval q((($s)-> &cl_lock !=  &STATIC_SCHED));
    }' unless defined(&LOADABLE_SCHED);
    eval 'sub SCHED_INSTALLED {
        my($s) = @_;
	    eval q((($s)-> &cl_funcs !=  &NULL));
    }' unless defined(&SCHED_INSTALLED);
    eval 'sub ALLOCATED_SCHED {
        my($s) = @_;
	    eval q((($s)-> &cl_lock !=  &NULL));
    }' unless defined(&ALLOCATED_SCHED);
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	eval 'sub CLASS_KERNEL {
	    my($cid) = @_;
    	    eval q((($cid) ==  &syscid || ($cid) ==  &sysdccid));
	}' unless defined(&CLASS_KERNEL);
    }
    eval 'sub CL_ADMIN {
        my($clp, $uaddr, $reqpcredp) = @_;
	    eval q((*($clp)-> ($cl_funcs->{sclass}->{cl_admin}))($uaddr, $reqpcredp));
    }' unless defined(&CL_ADMIN);
    eval 'sub CL_ENTERCLASS {
        my($t, $cid, $clparmsp, $credp, $bufp) = @_;
	    eval q(( ($sclass[$cid]->{cl_funcs}->{thread}->{cl_enterclass})) ($t, $cid, ( &void *)$clparmsp, $credp, $bufp));
    }' unless defined(&CL_ENTERCLASS);
    eval 'sub CL_EXITCLASS {
        my($cid, $clprocp) = @_;
	    eval q(( ($sclass[$cid]->{cl_funcs}->{thread}->{cl_exitclass})) (( &void *)$clprocp));
    }' unless defined(&CL_EXITCLASS);
    eval 'sub CL_CANEXIT {
        my($t, $cr) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_canexit}))($t, $cr));
    }' unless defined(&CL_CANEXIT);
    eval 'sub CL_FORK {
        my($tp, $ct, $bufp) = @_;
	    eval q((*($tp)-> ($t_clfuncs->{cl_fork}))($tp, $ct, $bufp));
    }' unless defined(&CL_FORK);
    eval 'sub CL_FORKRET {
        my($t, $ct) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_forkret}))($t, $ct));
    }' unless defined(&CL_FORKRET);
    eval 'sub CL_GETCLINFO {
        my($clp, $clinfop) = @_;
	    eval q((*($clp)-> ($cl_funcs->{sclass}->{cl_getclinfo}))(( &void *)$clinfop));
    }' unless defined(&CL_GETCLINFO);
    eval 'sub CL_GETCLPRI {
        my($clp, $clprip) = @_;
	    eval q((*($clp)-> ($cl_funcs->{sclass}->{cl_getclpri}))($clprip));
    }' unless defined(&CL_GETCLPRI);
    eval 'sub CL_PARMSGET {
        my($t, $clparmsp) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_parmsget}))($t, ( &void *)$clparmsp));
    }' unless defined(&CL_PARMSGET);
    eval 'sub CL_PARMSIN {
        my($clp, $clparmsp) = @_;
	    eval q(($clp)-> ($cl_funcs->{sclass}->{cl_parmsin})(( &void *)$clparmsp));
    }' unless defined(&CL_PARMSIN);
    eval 'sub CL_PARMSOUT {
        my($clp, $clparmsp, $vaparmsp) = @_;
	    eval q(($clp)-> ($cl_funcs->{sclass}->{cl_parmsout})(( &void *)$clparmsp, $vaparmsp));
    }' unless defined(&CL_PARMSOUT);
    eval 'sub CL_VAPARMSIN {
        my($clp, $clparmsp, $vaparmsp) = @_;
	    eval q(($clp)-> ($cl_funcs->{sclass}->{cl_vaparmsin})(( &void *)$clparmsp, $vaparmsp));
    }' unless defined(&CL_VAPARMSIN);
    eval 'sub CL_VAPARMSOUT {
        my($clp, $clparmsp, $vaparmsp) = @_;
	    eval q(($clp)-> ($cl_funcs->{sclass}->{cl_vaparmsout})(( &void *)$clparmsp, $vaparmsp));
    }' unless defined(&CL_VAPARMSOUT);
    eval 'sub CL_PARMSSET {
        my($t, $clparmsp, $cid, $curpcredp) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_parmsset}))($t, ( &void *)$clparmsp, $cid, $curpcredp));
    }' unless defined(&CL_PARMSSET);
    eval 'sub CL_PREEMPT {
        my($tp) = @_;
	    eval q((*($tp)-> ($t_clfuncs->{cl_preempt}))($tp));
    }' unless defined(&CL_PREEMPT);
    eval 'sub CL_SETRUN {
        my($tp) = @_;
	    eval q((*($tp)-> ($t_clfuncs->{cl_setrun}))($tp));
    }' unless defined(&CL_SETRUN);
    eval 'sub CL_SLEEP {
        my($tp) = @_;
	    eval q((*($tp)-> ($t_clfuncs->{cl_sleep}))($tp));
    }' unless defined(&CL_SLEEP);
    eval 'sub CL_STOP {
        my($t, $why, $what) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_stop}))($t, $why, $what));
    }' unless defined(&CL_STOP);
    eval 'sub CL_EXIT {
        my($t) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_exit}))($t));
    }' unless defined(&CL_EXIT);
    eval 'sub CL_ACTIVE {
        my($t) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_active}))($t));
    }' unless defined(&CL_ACTIVE);
    eval 'sub CL_INACTIVE {
        my($t) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_inactive}))($t));
    }' unless defined(&CL_INACTIVE);
    eval 'sub CL_SWAPIN {
        my($t, $flags) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_swapin}))($t, $flags));
    }' unless defined(&CL_SWAPIN);
    eval 'sub CL_SWAPOUT {
        my($t, $flags) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_swapout}))($t, $flags));
    }' unless defined(&CL_SWAPOUT);
    eval 'sub CL_TICK {
        my($t) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_tick}))($t));
    }' unless defined(&CL_TICK);
    eval 'sub CL_TRAPRET {
        my($t) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_trapret}))($t));
    }' unless defined(&CL_TRAPRET);
    eval 'sub CL_WAKEUP {
        my($t) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_wakeup}))($t));
    }' unless defined(&CL_WAKEUP);
    eval 'sub CL_DONICE {
        my($t, $cr, $inc, $ret) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_donice}))($t, $cr, $inc, $ret));
    }' unless defined(&CL_DONICE);
    eval 'sub CL_DOPRIO {
        my($t, $cr, $inc, $ret) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_doprio}))($t, $cr, $inc, $ret));
    }' unless defined(&CL_DOPRIO);
    eval 'sub CL_GLOBPRI {
        my($t) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_globpri}))($t));
    }' unless defined(&CL_GLOBPRI);
    eval 'sub CL_SET_PROCESS_GROUP {
        my($t, $s, $b, $f) = @_;
	    eval q((*($t)-> ($t_clfuncs->{cl_set_process_group}))($s, $b, $f));
    }' unless defined(&CL_SET_PROCESS_GROUP);
    eval 'sub CL_YIELD {
        my($tp) = @_;
	    eval q((*($tp)-> ($t_clfuncs->{cl_yield}))($tp));
    }' unless defined(&CL_YIELD);
    eval 'sub CL_ALLOC {
        my($pp, $cid, $flag) = @_;
	    eval q(( ($sclass[$cid]->{cl_funcs}->{sclass}->{cl_alloc})) ($pp, $flag));
    }' unless defined(&CL_ALLOC);
    eval 'sub CL_FREE {
        my($cid, $bufp) = @_;
	    eval q(( ($sclass[$cid]->{cl_funcs}->{sclass}->{cl_free})) ($bufp));
    }' unless defined(&CL_FREE);
    if(defined(&__cplusplus)) {
    }
}
1;
