require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CONTROLREGS_H)) {
    eval 'sub _SYS_CONTROLREGS_H () {1;}' unless defined(&_SYS_CONTROLREGS_H);
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub CR0_PG () {0x80000000;}' unless defined(&CR0_PG);
    eval 'sub CR0_CD () {0x40000000;}' unless defined(&CR0_CD);
    eval 'sub CR0_NW () {0x20000000;}' unless defined(&CR0_NW);
    eval 'sub CR0_AM () {0x40000;}' unless defined(&CR0_AM);
    eval 'sub CR0_WP () {0x10000;}' unless defined(&CR0_WP);
    eval 'sub CR0_NE () {0x20;}' unless defined(&CR0_NE);
    eval 'sub CR0_ET () {0x10;}' unless defined(&CR0_ET);
    eval 'sub CR0_TS () {0x8;}' unless defined(&CR0_TS);
    eval 'sub CR0_EM () {0x4;}' unless defined(&CR0_EM);
    eval 'sub CR0_MP () {0x2;}' unless defined(&CR0_MP);
    eval 'sub CR0_PE () {0x1;}' unless defined(&CR0_PE);
    eval 'sub CR0_CE () { &CR0_CD;}' unless defined(&CR0_CE);
    eval 'sub CR0_WT () { &CR0_NW;}' unless defined(&CR0_WT);
    eval 'sub FMT_CR0 () {"\\20\\40pg\\37cd\\36nw\\35am\\21wp\\6ne\\5et\\4ts\\3em\\2mp\\1pe";}' unless defined(&FMT_CR0);
    eval 'sub CR0_ENABLE_FPU_FLAGS {
        my($cr) = @_;
	    eval q(((($cr) |  &CR0_MP |  &CR0_NE |  &CR0_TS) & ( &uint32_t)~ &CR0_EM));
    }' unless defined(&CR0_ENABLE_FPU_FLAGS);
    eval 'sub CR0_DISABLE_FPU_FLAGS {
        my($cr) = @_;
	    eval q(((($cr) |  &CR0_EM) & ( &uint32_t)~ &CR0_MP));
    }' unless defined(&CR0_DISABLE_FPU_FLAGS);
    eval 'sub CR3_PCD () {0x10;}' unless defined(&CR3_PCD);
    eval 'sub CR3_PWT () {0x8;}' unless defined(&CR3_PWT);
    eval 'sub FMT_CR3 () {"\\20\\5pcd\\4pwt";}' unless defined(&FMT_CR3);
    eval 'sub CR4_VME () {0x1;}' unless defined(&CR4_VME);
    eval 'sub CR4_PVI () {0x2;}' unless defined(&CR4_PVI);
    eval 'sub CR4_TSD () {0x4;}' unless defined(&CR4_TSD);
    eval 'sub CR4_DE () {0x8;}' unless defined(&CR4_DE);
    eval 'sub CR4_PSE () {0x10;}' unless defined(&CR4_PSE);
    eval 'sub CR4_PAE () {0x20;}' unless defined(&CR4_PAE);
    eval 'sub CR4_MCE () {0x40;}' unless defined(&CR4_MCE);
    eval 'sub CR4_PGE () {0x80;}' unless defined(&CR4_PGE);
    eval 'sub CR4_PCE () {0x100;}' unless defined(&CR4_PCE);
    eval 'sub CR4_OSFXSR () {0x200;}' unless defined(&CR4_OSFXSR);
    eval 'sub CR4_OSXMMEXCPT () {0x400;}' unless defined(&CR4_OSXMMEXCPT);
    eval 'sub CR4_VMXE () {0x2000;}' unless defined(&CR4_VMXE);
    eval 'sub CR4_SMXE () {0x4000;}' unless defined(&CR4_SMXE);
    eval 'sub CR4_OSXSAVE () {0x40000;}' unless defined(&CR4_OSXSAVE);
    eval 'sub CR4_SMEP () {0x100000;}' unless defined(&CR4_SMEP);
    eval 'sub FMT_CR4 () {"\\20\\25smep\\23osxsav\\17smxe\\16vmxe\\13xmme\\12fxsr\\11pce\\10pge" "\\7mce\\6pae\\5pse\\4de\\3tsd\\2pvi\\1vme";}' unless defined(&FMT_CR4);
    eval 'sub CR4_ENABLE_SSE_FLAGS {
        my($cr) = @_;
	    eval q((($cr) |  &CR4_OSFXSR |  &CR4_OSXMMEXCPT));
    }' unless defined(&CR4_ENABLE_SSE_FLAGS);
    eval 'sub CR4_DISABLE_SSE_FLAGS {
        my($cr) = @_;
	    eval q((($cr) & ~( &uint32_t)( &CR4_OSFXSR |  &CR4_OSXMMEXCPT)));
    }' unless defined(&CR4_DISABLE_SSE_FLAGS);
    eval 'sub MSR_INTC_SEP_CS () {0x174;}' unless defined(&MSR_INTC_SEP_CS);
    eval 'sub MSR_INTC_SEP_ESP () {0x175;}' unless defined(&MSR_INTC_SEP_ESP);
    eval 'sub MSR_INTC_SEP_EIP () {0x176;}' unless defined(&MSR_INTC_SEP_EIP);
    eval 'sub MSR_INTC_UCODE_WRITE () {0x79;}' unless defined(&MSR_INTC_UCODE_WRITE);
    eval 'sub MSR_INTC_UCODE_REV () {0x8b;}' unless defined(&MSR_INTC_UCODE_REV);
    eval 'sub INTC_UCODE_REV_SHIFT () {32;}' unless defined(&INTC_UCODE_REV_SHIFT);
    eval 'sub MSR_INTC_PLATFORM_ID () {0x17;}' unless defined(&MSR_INTC_PLATFORM_ID);
    eval 'sub INTC_PLATFORM_ID_SHIFT () {50;}' unless defined(&INTC_PLATFORM_ID_SHIFT);
    eval 'sub INTC_PLATFORM_ID_MASK () {0x7;}' unless defined(&INTC_PLATFORM_ID_MASK);
    eval 'sub MSR_AMD_EFER () {0xc0000080;}' unless defined(&MSR_AMD_EFER);
    eval 'sub AMD_EFER_FFXSR () {0x4000;}' unless defined(&AMD_EFER_FFXSR);
    eval 'sub AMD_EFER_SVME () {0x1000;}' unless defined(&AMD_EFER_SVME);
    eval 'sub AMD_EFER_NXE () {0x800;}' unless defined(&AMD_EFER_NXE);
    eval 'sub AMD_EFER_LMA () {0x400;}' unless defined(&AMD_EFER_LMA);
    eval 'sub AMD_EFER_LME () {0x100;}' unless defined(&AMD_EFER_LME);
    eval 'sub AMD_EFER_SCE () {0x1;}' unless defined(&AMD_EFER_SCE);
    eval 'sub FMT_AMD_EFER () {"\\20\\17ffxsr\\15svme\\14nxe\\13lma\\11lme\\1sce";}' unless defined(&FMT_AMD_EFER);
    eval 'sub MSR_AMD_SYSCFG () {0xc0000010;}' unless defined(&MSR_AMD_SYSCFG);
    eval 'sub AMD_SYSCFG_TOM2 () {0x200000;}' unless defined(&AMD_SYSCFG_TOM2);
    eval 'sub AMD_SYSCFG_MVDM () {0x100000;}' unless defined(&AMD_SYSCFG_MVDM);
    eval 'sub AMD_SYSCFG_MFDM () {0x80000;}' unless defined(&AMD_SYSCFG_MFDM);
    eval 'sub AMD_SYSCFG_MFDE () {0x40000;}' unless defined(&AMD_SYSCFG_MFDE);
    eval 'sub FMT_AMD_SYSCFG () {"\\20\\26tom2\\25mvdm\\24mfdm\\23mfde";}' unless defined(&FMT_AMD_SYSCFG);
    eval 'sub MSR_AMD_STAR () {0xc0000081;}' unless defined(&MSR_AMD_STAR);
    eval 'sub MSR_AMD_LSTAR () {0xc0000082;}' unless defined(&MSR_AMD_LSTAR);
    eval 'sub MSR_AMD_CSTAR () {0xc0000083;}' unless defined(&MSR_AMD_CSTAR);
    eval 'sub MSR_AMD_SFMASK () {0xc0000084;}' unless defined(&MSR_AMD_SFMASK);
    eval 'sub MSR_AMD_FSBASE () {0xc0000100;}' unless defined(&MSR_AMD_FSBASE);
    eval 'sub MSR_AMD_GSBASE () {0xc0000101;}' unless defined(&MSR_AMD_GSBASE);
    eval 'sub MSR_AMD_KGSBASE () {0xc0000102;}' unless defined(&MSR_AMD_KGSBASE);
    eval 'sub MSR_AMD_TSCAUX () {0xc0000103;}' unless defined(&MSR_AMD_TSCAUX);
    eval 'sub MSR_AMD_DC_CFG () {0xc0011022;}' unless defined(&MSR_AMD_DC_CFG);
    eval 'sub AMD_DC_CFG_DIS_CNV_WC_SSO () {( &UINT64_C(1) << 3);}' unless defined(&AMD_DC_CFG_DIS_CNV_WC_SSO);
    eval 'sub AMD_DC_CFG_DIS_SMC_CHK_BUF () {( &UINT64_C(1) << 10);}' unless defined(&AMD_DC_CFG_DIS_SMC_CHK_BUF);
    eval 'sub MSR_AMD_HWCR () {0xc0010015;}' unless defined(&MSR_AMD_HWCR);
    eval 'sub AMD_HWCR_TLBCACHEDIS () {( &UINT64_C(1) << 3);}' unless defined(&AMD_HWCR_TLBCACHEDIS);
    eval 'sub AMD_HWCR_FFDIS () {0x40;}' unless defined(&AMD_HWCR_FFDIS);
    eval 'sub AMD_HWCR_MCI_STATUS_WREN () {0x40000;}' unless defined(&AMD_HWCR_MCI_STATUS_WREN);
    eval 'sub MSR_AMD_NB_CFG () {0xc001001f;}' unless defined(&MSR_AMD_NB_CFG);
    eval 'sub AMD_NB_CFG_SRQ_HEARTBEAT () {( &UINT64_C(1) << 20);}' unless defined(&AMD_NB_CFG_SRQ_HEARTBEAT);
    eval 'sub AMD_NB_CFG_SRQ_SPR () {( &UINT64_C(1) << 32);}' unless defined(&AMD_NB_CFG_SRQ_SPR);
    eval 'sub MSR_AMD_BU_CFG () {0xc0011023;}' unless defined(&MSR_AMD_BU_CFG);
    eval 'sub AMD_BU_CFG_E298 () {( &UINT64_C(1) << 1);}' unless defined(&AMD_BU_CFG_E298);
    eval 'sub MSR_AMD_DE_CFG () {0xc0011029;}' unless defined(&MSR_AMD_DE_CFG);
    eval 'sub AMD_DE_CFG_E721 () {( &UINT64_C(1));}' unless defined(&AMD_DE_CFG_E721);
    eval 'sub MSR_AMD_OSVW_ID_LEN () {0xc0010140;}' unless defined(&MSR_AMD_OSVW_ID_LEN);
    eval 'sub MSR_AMD_OSVW_STATUS () {0xc0010141;}' unless defined(&MSR_AMD_OSVW_STATUS);
    eval 'sub OSVW_ID_LEN_MASK () {0xffff;}' unless defined(&OSVW_ID_LEN_MASK);
    eval 'sub OSVW_ID_CNT_PER_MSR () {64;}' unless defined(&OSVW_ID_CNT_PER_MSR);
    eval 'sub AMD_GH_NB_CFG_EN_ECS () {( &UINT64_C(1) << 46);}' unless defined(&AMD_GH_NB_CFG_EN_ECS);
    eval 'sub MSR_AMD_PATCHLEVEL () {0x8b;}' unless defined(&MSR_AMD_PATCHLEVEL);
    eval 'sub MSR_AMD_PATCHLOADER () {0xc0010020;}' unless defined(&MSR_AMD_PATCHLOADER);
    if(defined(&__cplusplus)) {
    }
}
1;
