require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_DDIPROPDEFS_H)) {
    eval 'sub _SYS_DDIPROPDEFS_H () {1;}' unless defined(&_SYS_DDIPROPDEFS_H);
    if(defined(&__cplusplus)) {
    }
    eval("sub PROP_LEN () { 0; }") unless defined(&PROP_LEN);
    eval("sub PROP_LEN_AND_VAL_BUF () { 1; }") unless defined(&PROP_LEN_AND_VAL_BUF);
    eval("sub PROP_LEN_AND_VAL_ALLOC () { 2; }") unless defined(&PROP_LEN_AND_VAL_ALLOC);
    eval("sub PROP_EXISTS () { 3; }") unless defined(&PROP_EXISTS);
    eval 'sub DDI_PROP_INT {
        my($ph, $cmd, $data) = @_;
	    eval q((*($ph)-> ($ph_ops->{op_prop_int}))(($ph), ($cmd), ($data)));
    }' unless defined(&DDI_PROP_INT);
    eval 'sub DDI_PROP_STR {
        my($ph, $cmd, $data) = @_;
	    eval q((*($ph)-> ($ph_ops->{op_prop_str}))(($ph), ($cmd), ($data)));
    }' unless defined(&DDI_PROP_STR);
    eval 'sub DDI_PROP_BYTES {
        my($ph, $cmd, $data, $size) = @_;
	    eval q((*($ph)-> ($ph_ops->{op_prop_bytes}))(($ph), ($cmd), ($data), ($size)));
    }' unless defined(&DDI_PROP_BYTES);
    eval 'sub DDI_PROP_INT64 {
        my($ph, $cmd, $data) = @_;
	    eval q((*($ph)-> ($ph_ops->{op_prop_int64}))(($ph), ($cmd), ($data)));
    }' unless defined(&DDI_PROP_INT64);
    eval("sub DDI_PROP_CMD_GET_ESIZE () { 0; }") unless defined(&DDI_PROP_CMD_GET_ESIZE);
    eval("sub DDI_PROP_CMD_GET_DSIZE () { 1; }") unless defined(&DDI_PROP_CMD_GET_DSIZE);
    eval("sub DDI_PROP_CMD_DECODE () { 2; }") unless defined(&DDI_PROP_CMD_DECODE);
    eval("sub DDI_PROP_CMD_ENCODE () { 3; }") unless defined(&DDI_PROP_CMD_ENCODE);
    eval("sub DDI_PROP_CMD_SKIP () { 4; }") unless defined(&DDI_PROP_CMD_SKIP);
    eval("sub DDI_PROP_RESULT_ERROR () { -2; }") unless defined(&DDI_PROP_RESULT_ERROR);
    eval("sub DDI_PROP_RESULT_EOF () { -1; }") unless defined(&DDI_PROP_RESULT_EOF);
    eval("sub DDI_PROP_RESULT_OK () { 0; }") unless defined(&DDI_PROP_RESULT_OK);
    eval 'sub PROP_1275_CELL_SIZE () {$sizeof{ &prop_1275_cell_t};}' unless defined(&PROP_1275_CELL_SIZE);
    eval 'sub CELLS_1275_TO_BYTES {
        my($n) = @_;
	    eval q((($n) *  &PROP_1275_CELL_SIZE));
    }' unless defined(&CELLS_1275_TO_BYTES);
    eval 'sub BYTES_TO_1275_CELLS {
        my($n) = @_;
	    eval q((($n) /  &PROP_1275_CELL_SIZE));
    }' unless defined(&BYTES_TO_1275_CELLS);
    eval 'sub PH_FROM_PROM () {0x1;}' unless defined(&PH_FROM_PROM);
    eval 'sub DDI_PROP_SUCCESS () {0;}' unless defined(&DDI_PROP_SUCCESS);
    eval 'sub DDI_PROP_NOT_FOUND () {1;}' unless defined(&DDI_PROP_NOT_FOUND);
    eval 'sub DDI_PROP_UNDEFINED () {2;}' unless defined(&DDI_PROP_UNDEFINED);
    eval 'sub DDI_PROP_NO_MEMORY () {3;}' unless defined(&DDI_PROP_NO_MEMORY);
    eval 'sub DDI_PROP_INVAL_ARG () {4;}' unless defined(&DDI_PROP_INVAL_ARG);
    eval 'sub DDI_PROP_BUF_TOO_SMALL () {5;}' unless defined(&DDI_PROP_BUF_TOO_SMALL);
    eval 'sub DDI_PROP_CANNOT_DECODE () {6;}' unless defined(&DDI_PROP_CANNOT_DECODE);
    eval 'sub DDI_PROP_CANNOT_ENCODE () {7;}' unless defined(&DDI_PROP_CANNOT_ENCODE);
    eval 'sub DDI_PROP_END_OF_DATA () {8;}' unless defined(&DDI_PROP_END_OF_DATA);
    eval 'sub DDI_PROP_FOUND_1275 () {255;}' unless defined(&DDI_PROP_FOUND_1275);
    eval 'sub PROP_1275_INT_SIZE () {4;}' unless defined(&PROP_1275_INT_SIZE);
    eval 'sub DDI_PROP_DONTPASS () {0x1;}' unless defined(&DDI_PROP_DONTPASS);
    eval 'sub DDI_PROP_CANSLEEP () {0x2;}' unless defined(&DDI_PROP_CANSLEEP);
    eval 'sub DDI_PROP_SYSTEM_DEF () {0x4;}' unless defined(&DDI_PROP_SYSTEM_DEF);
    eval 'sub DDI_PROP_NOTPROM () {0x8;}' unless defined(&DDI_PROP_NOTPROM);
    eval 'sub DDI_PROP_DONTSLEEP () {0x10;}' unless defined(&DDI_PROP_DONTSLEEP);
    eval 'sub DDI_PROP_STACK_CREATE () {0x20;}' unless defined(&DDI_PROP_STACK_CREATE);
    eval 'sub DDI_PROP_UNDEF_IT () {0x40;}' unless defined(&DDI_PROP_UNDEF_IT);
    eval 'sub DDI_PROP_HW_DEF () {0x80;}' unless defined(&DDI_PROP_HW_DEF);
    eval 'sub DDI_PROP_TYPE_INT () {0x100;}' unless defined(&DDI_PROP_TYPE_INT);
    eval 'sub DDI_PROP_TYPE_STRING () {0x200;}' unless defined(&DDI_PROP_TYPE_STRING);
    eval 'sub DDI_PROP_TYPE_BYTE () {0x400;}' unless defined(&DDI_PROP_TYPE_BYTE);
    eval 'sub DDI_PROP_TYPE_COMPOSITE () {0x800;}' unless defined(&DDI_PROP_TYPE_COMPOSITE);
    eval 'sub DDI_PROP_TYPE_INT64 () {0x1000;}' unless defined(&DDI_PROP_TYPE_INT64);
    eval 'sub DDI_PROP_TYPE_ANY () {( &DDI_PROP_TYPE_INT |  &DDI_PROP_TYPE_STRING |  &DDI_PROP_TYPE_BYTE |  &DDI_PROP_TYPE_COMPOSITE);}' unless defined(&DDI_PROP_TYPE_ANY);
    eval 'sub DDI_PROP_TYPE_MASK () {( &DDI_PROP_TYPE_INT |  &DDI_PROP_TYPE_STRING |  &DDI_PROP_TYPE_BYTE |  &DDI_PROP_TYPE_COMPOSITE |  &DDI_PROP_TYPE_INT64);}' unless defined(&DDI_PROP_TYPE_MASK);
    eval 'sub LDI_DEV_T_ANY () {0x2000;}' unless defined(&LDI_DEV_T_ANY);
    eval 'sub DDI_UNBND_DLPI2 () {0x4000;}' unless defined(&DDI_UNBND_DLPI2);
    eval 'sub DDI_PROP_CONSUMER_TYPED () {0x8000;}' unless defined(&DDI_PROP_CONSUMER_TYPED);
    eval 'sub DDI_PROP_DYNAMIC () {0x10000;}' unless defined(&DDI_PROP_DYNAMIC);
    eval 'sub DDI_PROP_ROOTNEX_GLOBAL () {0x20000;}' unless defined(&DDI_PROP_ROOTNEX_GLOBAL);
    eval 'sub DDI_DEV_T_NONE () {(( &dev_t)-1);}' unless defined(&DDI_DEV_T_NONE);
    eval 'sub DDI_DEV_T_ANY () {(( &dev_t)-2);}' unless defined(&DDI_DEV_T_ANY);
    eval 'sub DDI_MAJOR_T_UNKNOWN () {(( &major_t)0);}' unless defined(&DDI_MAJOR_T_UNKNOWN);
    eval 'sub DDI_MAJOR_T_NONE () {(( &major_t)-1);}' unless defined(&DDI_MAJOR_T_NONE);
    eval 'sub DDI_RELATIVE_ADDRESSING () {"relative-addressing";}' unless defined(&DDI_RELATIVE_ADDRESSING);
    eval 'sub DDI_GENERIC_ADDRESSING () {"generic-addressing";}' unless defined(&DDI_GENERIC_ADDRESSING);
    if(defined(&DDI_PROP_DEBUG)) {
	eval 'sub ddi_prop_printf () { &if ( &ddi_prop_debug_flag != 0)  &printf;}' unless defined(&ddi_prop_printf);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
