require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_FEATURE_TESTS_H)) {
    eval 'sub _SYS_FEATURE_TESTS_H () {1;}' unless defined(&_SYS_FEATURE_TESTS_H);
    require 'sys/ccompile.ph';
    require 'sys/isa_defs.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_POSIX_SOURCE)  && !defined(&_POSIX_C_SOURCE)) {
	eval 'sub _POSIX_C_SOURCE () {1;}' unless defined(&_POSIX_C_SOURCE);
    }
    if(defined(&_XOPEN_SOURCE) || defined(&_POSIX_C_SOURCE)) {
	eval 'sub __XOPEN_OR_POSIX () {1;}' unless defined(&__XOPEN_OR_POSIX);
    }
    if(( defined(&__STRICT_ANSI__)  && !defined(&__GNUC__)) || (defined(&__GNUC__)  && defined(&__STRICT_ANSI__))) {
	eval 'sub _STRICT_STDC () {1;}' unless defined(&_STRICT_STDC);
    } else {
	undef(&_STRICT_STDC) if defined(&_STRICT_STDC);
    }
    if((defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) - 0>= 199901) {
	eval 'sub _STDC_C99 () {1;}' unless defined(&_STDC_C99);
    }
    if((!defined(&_STRICT_STDC)  && !defined(&__XOPEN_OR_POSIX)) || defined(&_KERNEL) || defined(&_KMEMUSER) || defined(&__EXTENSIONS__)) {
	undef(&_LARGEFILE64_SOURCE) if defined(&_LARGEFILE64_SOURCE);
	eval 'sub _LARGEFILE64_SOURCE () {1;}' unless defined(&_LARGEFILE64_SOURCE);
    }
    if((defined(&_LARGEFILE64_SOURCE) ? &_LARGEFILE64_SOURCE : undef) - 0== 1) {
	undef(&_LARGEFILE_SOURCE) if defined(&_LARGEFILE_SOURCE);
	eval 'sub _LARGEFILE_SOURCE () {1;}' unless defined(&_LARGEFILE_SOURCE);
    }
    if(defined(&_LP64)) {
	unless(defined(&_FILE_OFFSET_BITS)) {
	    eval 'sub _FILE_OFFSET_BITS () {64;}' unless defined(&_FILE_OFFSET_BITS);
	}
	if((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) - 0!= 64) {
	    die("invalid _FILE_OFFSET_BITS value specified");
	}
    } else {
	unless(defined(&_FILE_OFFSET_BITS)) {
	    eval 'sub _FILE_OFFSET_BITS () {32;}' unless defined(&_FILE_OFFSET_BITS);
	}
	if((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) - 0!= 32 && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) - 0!= 64) {
	    die("invalid _FILE_OFFSET_BITS value specified");
	}
    }
    if(defined(&_XOPEN_SOURCE)  && ((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : undef) - 0< 500)  && ((defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : undef) - 0< 4)  && !defined(&_XOPEN_SOURCE_EXTENDED)) {
	eval 'sub _XPG3 () {1;}' unless defined(&_XPG3);
    }
 elsif((defined(&_XOPEN_SOURCE)  && (defined(&_XOPEN_VERSION) ? &_XOPEN_VERSION : undef) - 0== 4)) {
	eval 'sub _XPG4 () {1;}' unless defined(&_XPG4);
	eval 'sub _XPG3 () {1;}' unless defined(&_XPG3);
    }
 elsif((defined(&_XOPEN_SOURCE)  && (defined(&_XOPEN_SOURCE_EXTENDED) ? &_XOPEN_SOURCE_EXTENDED : undef) - 0== 1)) {
	eval 'sub _XPG4_2 () {1;}' unless defined(&_XPG4_2);
	eval 'sub _XPG4 () {1;}' unless defined(&_XPG4);
	eval 'sub _XPG3 () {1;}' unless defined(&_XPG3);
    }
 elsif(((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : undef) - 0== 500)) {
	eval 'sub _XPG5 () {1;}' unless defined(&_XPG5);
	eval 'sub _XPG4_2 () {1;}' unless defined(&_XPG4_2);
	eval 'sub _XPG4 () {1;}' unless defined(&_XPG4);
	eval 'sub _XPG3 () {1;}' unless defined(&_XPG3);
	undef(&_POSIX_C_SOURCE) if defined(&_POSIX_C_SOURCE);
	eval 'sub _POSIX_C_SOURCE () {199506;}' unless defined(&_POSIX_C_SOURCE);
    }
 elsif(((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : undef) - 0== 600) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0== 200112)) {
	eval 'sub _XPG6 () {1;}' unless defined(&_XPG6);
	eval 'sub _XPG5 () {1;}' unless defined(&_XPG5);
	eval 'sub _XPG4_2 () {1;}' unless defined(&_XPG4_2);
	eval 'sub _XPG4 () {1;}' unless defined(&_XPG4);
	eval 'sub _XPG3 () {1;}' unless defined(&_XPG3);
	undef(&_POSIX_C_SOURCE) if defined(&_POSIX_C_SOURCE);
	eval 'sub _POSIX_C_SOURCE () {200112;}' unless defined(&_POSIX_C_SOURCE);
	undef(&_XOPEN_SOURCE) if defined(&_XOPEN_SOURCE);
	eval 'sub _XOPEN_SOURCE () {600;}' unless defined(&_XOPEN_SOURCE);
    }
    unless(defined(&_XOPEN_VERSION)) {
	if(defined(&_XPG6)) {
	    eval 'sub _XOPEN_VERSION () {600;}' unless defined(&_XOPEN_VERSION);
	}
 elsif(defined(&_XPG5)) {
	    eval 'sub _XOPEN_VERSION () {500;}' unless defined(&_XOPEN_VERSION);
	}
 elsif(defined(&_XPG4_2)) {
	    eval 'sub _XOPEN_VERSION () {4;}' unless defined(&_XOPEN_VERSION);
	} else {
	    eval 'sub _XOPEN_VERSION () {3;}' unless defined(&_XOPEN_VERSION);
	}
    }
    if(!defined(&_STDC_C99)  && defined(&_STRICT_STDC)  && !defined(&__GNUC__)) {
	if(defined(&_LONGLONG_TYPE)) {
	    die("No long long in strictly conforming ANSI C & 1990 ISO C environments");
	}
    } else {
	if(!defined(&_LONGLONG_TYPE)) {
	    eval 'sub _LONGLONG_TYPE () {1;}' unless defined(&_LONGLONG_TYPE);
	}
    }
    if((defined(&__STDC__)  && defined(&_STDC_C99))  && !defined(&__cplusplus)) {
	if(defined(&__cplusplus)) {
	    eval 'sub _RESTRICT_KYWD () { &__restrict;}' unless defined(&_RESTRICT_KYWD);
	} else {
	    eval 'sub _RESTRICT_KYWD () { &restrict;}' unless defined(&_RESTRICT_KYWD);
	}
    } else {
	eval 'sub _RESTRICT_KYWD () {1;}' unless defined(&_RESTRICT_KYWD);
    }
    eval 'sub _ISO_CPP_14882_1998 () {1;}' unless defined(&_ISO_CPP_14882_1998);
    eval 'sub _ISO_C_9899_1999 () {1;}' unless defined(&_ISO_C_9899_1999);
    eval 'sub _DTRACE_VERSION () {1;}' unless defined(&_DTRACE_VERSION);
    if(defined(&__cplusplus)) {
    }
}
1;
