require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_INT_FMTIO_H)) {
    eval 'sub _SYS_INT_FMTIO_H () {1;}' unless defined(&_SYS_INT_FMTIO_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub _MODF8 () {"";}' unless defined(&_MODF8);
	eval 'sub _MODF16 () {"";}' unless defined(&_MODF16);
    } else {
	eval 'sub _MODF8 () {"hh";}' unless defined(&_MODF8);
	eval 'sub _MODF16 () {"h";}' unless defined(&_MODF16);
    }
    eval 'sub _PRId () {"d";}' unless defined(&_PRId);
    eval 'sub _PRIi () {"i";}' unless defined(&_PRIi);
    eval 'sub _PRIo () {"o";}' unless defined(&_PRIo);
    eval 'sub _PRIu () {"u";}' unless defined(&_PRIu);
    eval 'sub _PRIx () {"x";}' unless defined(&_PRIx);
    eval 'sub _PRIX () {"X";}' unless defined(&_PRIX);
    eval 'sub PRId8 () { &_MODF8  &_PRId;}' unless defined(&PRId8);
    eval 'sub PRIdLEAST8 () { &PRId8;}' unless defined(&PRIdLEAST8);
    eval 'sub PRIdFAST8 () { &PRId8;}' unless defined(&PRIdFAST8);
    eval 'sub PRId16 () { &_MODF16  &_PRId;}' unless defined(&PRId16);
    eval 'sub PRIdLEAST16 () { &PRId16;}' unless defined(&PRIdLEAST16);
    eval 'sub PRId32 () {"d";}' unless defined(&PRId32);
    eval 'sub PRIdFAST16 () { &PRId32;}' unless defined(&PRIdFAST16);
    eval 'sub PRIdLEAST32 () { &PRId32;}' unless defined(&PRIdLEAST32);
    eval 'sub PRIdFAST32 () { &PRId32;}' unless defined(&PRIdFAST32);
    if(defined(&_LP64)) {
	eval 'sub PRId64 () {"ld";}' unless defined(&PRId64);
    } else {
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub PRId64 () {"lld";}' unless defined(&PRId64);
	}
    }
    if(defined(&PRId64)) {
	eval 'sub PRIdLEAST64 () { &PRId64;}' unless defined(&PRIdLEAST64);
	eval 'sub PRIdFAST64 () { &PRId64;}' unless defined(&PRIdFAST64);
    }
    eval 'sub PRIi8 () { &_MODF8  &_PRIi;}' unless defined(&PRIi8);
    eval 'sub PRIiLEAST8 () { &PRIi8;}' unless defined(&PRIiLEAST8);
    eval 'sub PRIiFAST8 () { &PRIi8;}' unless defined(&PRIiFAST8);
    eval 'sub PRIi16 () { &_MODF16  &_PRIi;}' unless defined(&PRIi16);
    eval 'sub PRIiLEAST16 () { &PRIi16;}' unless defined(&PRIiLEAST16);
    eval 'sub PRIi32 () {"i";}' unless defined(&PRIi32);
    eval 'sub PRIiFAST16 () { &PRIi32;}' unless defined(&PRIiFAST16);
    eval 'sub PRIiLEAST32 () { &PRIi32;}' unless defined(&PRIiLEAST32);
    eval 'sub PRIiFAST32 () { &PRIi32;}' unless defined(&PRIiFAST32);
    if(defined(&_LP64)) {
	eval 'sub PRIi64 () {"li";}' unless defined(&PRIi64);
    } else {
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub PRIi64 () {"lli";}' unless defined(&PRIi64);
	}
    }
    if(defined(&PRIi64)) {
	eval 'sub PRIiLEAST64 () { &PRIi64;}' unless defined(&PRIiLEAST64);
	eval 'sub PRIiFAST64 () { &PRIi64;}' unless defined(&PRIiFAST64);
    }
    eval 'sub PRIo8 () { &_MODF8  &_PRIo;}' unless defined(&PRIo8);
    eval 'sub PRIoLEAST8 () { &PRIo8;}' unless defined(&PRIoLEAST8);
    eval 'sub PRIoFAST8 () { &PRIo8;}' unless defined(&PRIoFAST8);
    eval 'sub PRIo16 () { &_MODF16  &_PRIo;}' unless defined(&PRIo16);
    eval 'sub PRIoLEAST16 () { &PRIo16;}' unless defined(&PRIoLEAST16);
    eval 'sub PRIo32 () {"o";}' unless defined(&PRIo32);
    eval 'sub PRIoFAST16 () { &PRIo32;}' unless defined(&PRIoFAST16);
    eval 'sub PRIoLEAST32 () { &PRIo32;}' unless defined(&PRIoLEAST32);
    eval 'sub PRIoFAST32 () { &PRIo32;}' unless defined(&PRIoFAST32);
    if(defined(&_LP64)) {
	eval 'sub PRIo64 () {"lo";}' unless defined(&PRIo64);
    } else {
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub PRIo64 () {"llo";}' unless defined(&PRIo64);
	}
    }
    if(defined(&PRIo64)) {
	eval 'sub PRIoLEAST64 () { &PRIo64;}' unless defined(&PRIoLEAST64);
	eval 'sub PRIoFAST64 () { &PRIo64;}' unless defined(&PRIoFAST64);
    }
    eval 'sub PRIu8 () { &_MODF8  &_PRIu;}' unless defined(&PRIu8);
    eval 'sub PRIuLEAST8 () { &PRIu8;}' unless defined(&PRIuLEAST8);
    eval 'sub PRIuFAST8 () { &PRIu8;}' unless defined(&PRIuFAST8);
    eval 'sub PRIu16 () { &_MODF16  &_PRIu;}' unless defined(&PRIu16);
    eval 'sub PRIuLEAST16 () { &PRIu16;}' unless defined(&PRIuLEAST16);
    eval 'sub PRIu32 () {"u";}' unless defined(&PRIu32);
    eval 'sub PRIuFAST16 () { &PRIu32;}' unless defined(&PRIuFAST16);
    eval 'sub PRIuLEAST32 () { &PRIu32;}' unless defined(&PRIuLEAST32);
    eval 'sub PRIuFAST32 () { &PRIu32;}' unless defined(&PRIuFAST32);
    if(defined(&_LP64)) {
	eval 'sub PRIu64 () {"lu";}' unless defined(&PRIu64);
    } else {
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub PRIu64 () {"llu";}' unless defined(&PRIu64);
	}
    }
    if(defined(&PRIu64)) {
	eval 'sub PRIuLEAST64 () { &PRIu64;}' unless defined(&PRIuLEAST64);
	eval 'sub PRIuFAST64 () { &PRIu64;}' unless defined(&PRIuFAST64);
    }
    eval 'sub PRIx8 () { &_MODF8  &_PRIx;}' unless defined(&PRIx8);
    eval 'sub PRIxLEAST8 () { &PRIx8;}' unless defined(&PRIxLEAST8);
    eval 'sub PRIxFAST8 () { &PRIx8;}' unless defined(&PRIxFAST8);
    eval 'sub PRIx16 () { &_MODF16  &_PRIx;}' unless defined(&PRIx16);
    eval 'sub PRIxLEAST16 () { &PRIx16;}' unless defined(&PRIxLEAST16);
    eval 'sub PRIx32 () {"x";}' unless defined(&PRIx32);
    eval 'sub PRIxFAST16 () { &PRIx32;}' unless defined(&PRIxFAST16);
    eval 'sub PRIxLEAST32 () { &PRIx32;}' unless defined(&PRIxLEAST32);
    eval 'sub PRIxFAST32 () { &PRIx32;}' unless defined(&PRIxFAST32);
    if(defined(&_LP64)) {
	eval 'sub PRIx64 () {"lx";}' unless defined(&PRIx64);
    } else {
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub PRIx64 () {"llx";}' unless defined(&PRIx64);
	}
    }
    if(defined(&PRIx64)) {
	eval 'sub PRIxLEAST64 () { &PRIx64;}' unless defined(&PRIxLEAST64);
	eval 'sub PRIxFAST64 () { &PRIx64;}' unless defined(&PRIxFAST64);
    }
    eval 'sub PRIX8 () { &_MODF8  &_PRIX;}' unless defined(&PRIX8);
    eval 'sub PRIXLEAST8 () { &PRIX8;}' unless defined(&PRIXLEAST8);
    eval 'sub PRIXFAST8 () { &PRIX8;}' unless defined(&PRIXFAST8);
    eval 'sub PRIX16 () { &_MODF16  &_PRIX;}' unless defined(&PRIX16);
    eval 'sub PRIXLEAST16 () { &PRIX16;}' unless defined(&PRIXLEAST16);
    eval 'sub PRIX32 () {"X";}' unless defined(&PRIX32);
    eval 'sub PRIXFAST16 () { &PRIX32;}' unless defined(&PRIXFAST16);
    eval 'sub PRIXLEAST32 () { &PRIX32;}' unless defined(&PRIXLEAST32);
    eval 'sub PRIXFAST32 () { &PRIX32;}' unless defined(&PRIXFAST32);
    if(defined(&_LP64)) {
	eval 'sub PRIX64 () {"lX";}' unless defined(&PRIX64);
    } else {
	if(defined(&_LONGLONG_TYPE)) {
	    eval 'sub PRIX64 () {"llX";}' unless defined(&PRIX64);
	}
    }
    if(defined(&PRIX64)) {
	eval 'sub PRIXLEAST64 () { &PRIX64;}' unless defined(&PRIXLEAST64);
	eval 'sub PRIXFAST64 () { &PRIX64;}' unless defined(&PRIXFAST64);
    }
    if(defined(&_LP64) || defined(&_I32LPx)) {
	eval 'sub PRIdPTR () {"ld";}' unless defined(&PRIdPTR);
	eval 'sub PRIiPTR () {"li";}' unless defined(&PRIiPTR);
	eval 'sub PRIoPTR () {"lo";}' unless defined(&PRIoPTR);
	eval 'sub PRIuPTR () {"lu";}' unless defined(&PRIuPTR);
	eval 'sub PRIxPTR () {"lx";}' unless defined(&PRIxPTR);
	eval 'sub PRIXPTR () {"lX";}' unless defined(&PRIXPTR);
    } else {
	eval 'sub PRIdPTR () {"d";}' unless defined(&PRIdPTR);
	eval 'sub PRIiPTR () {"i";}' unless defined(&PRIiPTR);
	eval 'sub PRIoPTR () {"o";}' unless defined(&PRIoPTR);
	eval 'sub PRIuPTR () {"u";}' unless defined(&PRIuPTR);
	eval 'sub PRIxPTR () {"x";}' unless defined(&PRIxPTR);
	eval 'sub PRIXPTR () {"X";}' unless defined(&PRIXPTR);
    }
    eval 'sub SCNd8 () {"hhd";}' unless defined(&SCNd8);
    eval 'sub SCNdLEAST8 () { &SCNd8;}' unless defined(&SCNdLEAST8);
    eval 'sub SCNdFAST8 () { &SCNd8;}' unless defined(&SCNdFAST8);
    eval 'sub SCNd16 () {"hd";}' unless defined(&SCNd16);
    eval 'sub SCNdLEAST16 () { &SCNd16;}' unless defined(&SCNdLEAST16);
    eval 'sub SCNd32 () {"d";}' unless defined(&SCNd32);
    eval 'sub SCNdFAST16 () { &SCNd32;}' unless defined(&SCNdFAST16);
    eval 'sub SCNdLEAST32 () { &SCNd32;}' unless defined(&SCNdLEAST32);
    eval 'sub SCNdFAST32 () { &SCNd32;}' unless defined(&SCNdFAST32);
    if(defined(&PRId64)) {
	eval 'sub SCNd64 () { &PRId64;}' unless defined(&SCNd64);
	eval 'sub SCNdLEAST64 () { &PRId64;}' unless defined(&SCNdLEAST64);
	eval 'sub SCNdFAST64 () { &PRId64;}' unless defined(&SCNdFAST64);
    }
    eval 'sub SCNdPTR () { &PRIdPTR;}' unless defined(&SCNdPTR);
    eval 'sub SCNi8 () {"hhi";}' unless defined(&SCNi8);
    eval 'sub SCNiLEAST8 () { &SCNi8;}' unless defined(&SCNiLEAST8);
    eval 'sub SCNiFAST8 () { &SCNi8;}' unless defined(&SCNiFAST8);
    eval 'sub SCNi16 () {"hi";}' unless defined(&SCNi16);
    eval 'sub SCNiLEAST16 () { &SCNi16;}' unless defined(&SCNiLEAST16);
    eval 'sub SCNi32 () {"i";}' unless defined(&SCNi32);
    eval 'sub SCNiFAST16 () { &SCNi32;}' unless defined(&SCNiFAST16);
    eval 'sub SCNiLEAST32 () { &SCNi32;}' unless defined(&SCNiLEAST32);
    eval 'sub SCNiFAST32 () { &SCNi32;}' unless defined(&SCNiFAST32);
    if(defined(&PRIi64)) {
	eval 'sub SCNi64 () { &PRIi64;}' unless defined(&SCNi64);
	eval 'sub SCNiLEAST64 () { &PRIi64;}' unless defined(&SCNiLEAST64);
	eval 'sub SCNiFAST64 () { &PRIi64;}' unless defined(&SCNiFAST64);
    }
    eval 'sub SCNiPTR () { &PRIiPTR;}' unless defined(&SCNiPTR);
    eval 'sub SCNo8 () {"hho";}' unless defined(&SCNo8);
    eval 'sub SCNoLEAST8 () { &SCNo8;}' unless defined(&SCNoLEAST8);
    eval 'sub SCNoFAST8 () { &SCNo8;}' unless defined(&SCNoFAST8);
    eval 'sub SCNo16 () {"ho";}' unless defined(&SCNo16);
    eval 'sub SCNoLEAST16 () { &SCNo16;}' unless defined(&SCNoLEAST16);
    eval 'sub SCNo32 () {"o";}' unless defined(&SCNo32);
    eval 'sub SCNoFAST16 () { &SCNo32;}' unless defined(&SCNoFAST16);
    eval 'sub SCNoLEAST32 () { &SCNo32;}' unless defined(&SCNoLEAST32);
    eval 'sub SCNoFAST32 () { &SCNo32;}' unless defined(&SCNoFAST32);
    if(defined(&PRIo64)) {
	eval 'sub SCNo64 () { &PRIo64;}' unless defined(&SCNo64);
	eval 'sub SCNoLEAST64 () { &PRIo64;}' unless defined(&SCNoLEAST64);
	eval 'sub SCNoFAST64 () { &PRIo64;}' unless defined(&SCNoFAST64);
    }
    eval 'sub SCNoPTR () { &PRIoPTR;}' unless defined(&SCNoPTR);
    eval 'sub SCNu8 () {"hhu";}' unless defined(&SCNu8);
    eval 'sub SCNuLEAST8 () { &SCNu8;}' unless defined(&SCNuLEAST8);
    eval 'sub SCNuFAST8 () { &SCNu8;}' unless defined(&SCNuFAST8);
    eval 'sub SCNu16 () {"hu";}' unless defined(&SCNu16);
    eval 'sub SCNuLEAST16 () { &SCNu16;}' unless defined(&SCNuLEAST16);
    eval 'sub SCNu32 () {"u";}' unless defined(&SCNu32);
    eval 'sub SCNuFAST16 () { &SCNu32;}' unless defined(&SCNuFAST16);
    eval 'sub SCNuLEAST32 () { &SCNu32;}' unless defined(&SCNuLEAST32);
    eval 'sub SCNuFAST32 () { &SCNu32;}' unless defined(&SCNuFAST32);
    if(defined(&PRIu64)) {
	eval 'sub SCNu64 () { &PRIu64;}' unless defined(&SCNu64);
	eval 'sub SCNuLEAST64 () { &PRIu64;}' unless defined(&SCNuLEAST64);
	eval 'sub SCNuFAST64 () { &PRIu64;}' unless defined(&SCNuFAST64);
    }
    eval 'sub SCNuPTR () { &PRIuPTR;}' unless defined(&SCNuPTR);
    eval 'sub SCNx8 () {"hhx";}' unless defined(&SCNx8);
    eval 'sub SCNxLEAST8 () { &SCNx8;}' unless defined(&SCNxLEAST8);
    eval 'sub SCNxFAST8 () { &SCNx8;}' unless defined(&SCNxFAST8);
    eval 'sub SCNx16 () {"hx";}' unless defined(&SCNx16);
    eval 'sub SCNxLEAST16 () { &SCNx16;}' unless defined(&SCNxLEAST16);
    eval 'sub SCNx32 () {"x";}' unless defined(&SCNx32);
    eval 'sub SCNxFAST16 () { &SCNx32;}' unless defined(&SCNxFAST16);
    eval 'sub SCNxLEAST32 () { &SCNx32;}' unless defined(&SCNxLEAST32);
    eval 'sub SCNxFAST32 () { &SCNx32;}' unless defined(&SCNxFAST32);
    if(defined(&PRIx64)) {
	eval 'sub SCNx64 () { &PRIx64;}' unless defined(&SCNx64);
	eval 'sub SCNxLEAST64 () { &PRIx64;}' unless defined(&SCNxLEAST64);
	eval 'sub SCNxFAST64 () { &PRIx64;}' unless defined(&SCNxFAST64);
    }
    eval 'sub SCNxPTR () { &PRIxPTR;}' unless defined(&SCNxPTR);
    eval 'sub SCNX8 () {"hhX";}' unless defined(&SCNX8);
    eval 'sub SCNXLEAST8 () { &SCNX8;}' unless defined(&SCNXLEAST8);
    eval 'sub SCNXFAST8 () { &SCNX8;}' unless defined(&SCNXFAST8);
    eval 'sub SCNX16 () {"hX";}' unless defined(&SCNX16);
    eval 'sub SCNXLEAST16 () { &SCNX16;}' unless defined(&SCNXLEAST16);
    eval 'sub SCNX32 () {"X";}' unless defined(&SCNX32);
    eval 'sub SCNXFAST16 () { &SCNX32;}' unless defined(&SCNXFAST16);
    eval 'sub SCNXLEAST32 () { &SCNX32;}' unless defined(&SCNXLEAST32);
    eval 'sub SCNXFAST32 () { &SCNX32;}' unless defined(&SCNXFAST32);
    if(defined(&PRIX64)) {
	eval 'sub SCNX64 () { &PRIX64;}' unless defined(&SCNX64);
	eval 'sub SCNXLEAST64 () { &PRIX64;}' unless defined(&SCNXLEAST64);
	eval 'sub SCNXFAST64 () { &PRIX64;}' unless defined(&SCNXFAST64);
    }
    eval 'sub SCNXPTR () { &PRIXPTR;}' unless defined(&SCNXPTR);
    if(!defined(&_LP64)  && defined(&_LONGLONG_TYPE)) {
	eval 'sub PRIdMAX () {"lld";}' unless defined(&PRIdMAX);
	eval 'sub PRIiMAX () {"lli";}' unless defined(&PRIiMAX);
	eval 'sub PRIoMAX () {"llo";}' unless defined(&PRIoMAX);
	eval 'sub PRIxMAX () {"llx";}' unless defined(&PRIxMAX);
	eval 'sub PRIuMAX () {"llu";}' unless defined(&PRIuMAX);
	eval 'sub PRIXMAX () {"llX";}' unless defined(&PRIXMAX);
    } else {
	eval 'sub PRIdMAX () {"ld";}' unless defined(&PRIdMAX);
	eval 'sub PRIiMAX () {"li";}' unless defined(&PRIiMAX);
	eval 'sub PRIoMAX () {"lo";}' unless defined(&PRIoMAX);
	eval 'sub PRIxMAX () {"lx";}' unless defined(&PRIxMAX);
	eval 'sub PRIuMAX () {"lu";}' unless defined(&PRIuMAX);
	eval 'sub PRIXMAX () {"lX";}' unless defined(&PRIXMAX);
    }
    eval 'sub SCNdMAX () { &PRIdMAX;}' unless defined(&SCNdMAX);
    eval 'sub SCNiMAX () { &PRIiMAX;}' unless defined(&SCNiMAX);
    eval 'sub SCNoMAX () { &PRIoMAX;}' unless defined(&SCNoMAX);
    eval 'sub SCNxMAX () { &PRIxMAX;}' unless defined(&SCNxMAX);
    eval 'sub SCNuMAX () { &PRIuMAX;}' unless defined(&SCNuMAX);
    eval 'sub SCNXMAX () { &PRIXMAX;}' unless defined(&SCNXMAX);
    if(defined(&__cplusplus)) {
    }
}
1;
