require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_IOCTL_H)) {
    eval 'sub _SYS_IOCTL_H () {1;}' unless defined(&_SYS_IOCTL_H);
    if(defined(&__cplusplus)) {
    }
    eval 'sub IOCTYPE () {0xff00;}' unless defined(&IOCTYPE);
    eval 'sub LIOC () {(ord(\'l\')<<8);}' unless defined(&LIOC);
    eval 'sub LIOCGETP () {( &LIOC|1);}' unless defined(&LIOCGETP);
    eval 'sub LIOCSETP () {( &LIOC|2);}' unless defined(&LIOCSETP);
    eval 'sub LIOCGETS () {( &LIOC|5);}' unless defined(&LIOCGETS);
    eval 'sub LIOCSETS () {( &LIOC|6);}' unless defined(&LIOCSETS);
    eval 'sub DIOC () {(ord(\'d\')<<8);}' unless defined(&DIOC);
    eval 'sub DIOCGETC () {( &DIOC|1);}' unless defined(&DIOCGETC);
    eval 'sub DIOCGETB () {( &DIOC|2);}' unless defined(&DIOCGETB);
    eval 'sub DIOCSETE () {( &DIOC|3);}' unless defined(&DIOCSETE);
    if(defined(&__cplusplus)) {
    }
    if(defined(&BSD_COMP)) {
	require 'sys/ttychars.ph';
	require 'sys/ttydev.ph';
	require 'sys/ttold.ph';
	if(defined(&__cplusplus)) {
	}
	eval 'sub TANDEM () { &O_TANDEM;}' unless defined(&TANDEM);
	eval 'sub CBREAK () { &O_CBREAK;}' unless defined(&CBREAK);
	unless(defined(&_SGTTY_H)) {
	    eval 'sub LCASE () { &O_LCASE;}' unless defined(&LCASE);
	    eval 'sub ECHO () { &O_ECHO;}' unless defined(&ECHO);
	    eval 'sub CRMOD () { &O_CRMOD;}' unless defined(&CRMOD);
	    eval 'sub RAW () { &O_RAW;}' unless defined(&RAW);
	    eval 'sub ODDP () { &O_ODDP;}' unless defined(&ODDP);
	    eval 'sub EVENP () { &O_EVENP;}' unless defined(&EVENP);
	    eval 'sub ANYP () { &O_ANYP;}' unless defined(&ANYP);
	    eval 'sub NLDELAY () { &O_NLDELAY;}' unless defined(&NLDELAY);
	    eval 'sub NL0 () { &O_NL0;}' unless defined(&NL0);
	    eval 'sub NL1 () { &O_NL1;}' unless defined(&NL1);
	    eval 'sub NL2 () { &O_NL2;}' unless defined(&NL2);
	    eval 'sub NL3 () { &O_NL3;}' unless defined(&NL3);
	    eval 'sub TBDELAY () { &O_TBDELAY;}' unless defined(&TBDELAY);
	    eval 'sub TAB0 () { &O_TAB0;}' unless defined(&TAB0);
	    eval 'sub TAB1 () { &O_TAB1;}' unless defined(&TAB1);
	    eval 'sub TAB2 () { &O_TAB2;}' unless defined(&TAB2);
	    eval 'sub XTABS () { &O_XTABS;}' unless defined(&XTABS);
	    eval 'sub CRDELAY () { &O_CRDELAY;}' unless defined(&CRDELAY);
	    eval 'sub CR0 () { &O_CR0;}' unless defined(&CR0);
	    eval 'sub CR1 () { &O_CR1;}' unless defined(&CR1);
	    eval 'sub CR2 () { &O_CR2;}' unless defined(&CR2);
	    eval 'sub CR3 () { &O_CR3;}' unless defined(&CR3);
	    eval 'sub VTDELAY () { &O_VTDELAY;}' unless defined(&VTDELAY);
	    eval 'sub FF0 () { &O_FF0;}' unless defined(&FF0);
	    eval 'sub FF1 () { &O_FF1;}' unless defined(&FF1);
	    eval 'sub BSDELAY () { &O_BSDELAY;}' unless defined(&BSDELAY);
	    eval 'sub BS0 () { &O_BS0;}' unless defined(&BS0);
	    eval 'sub BS1 () { &O_BS1;}' unless defined(&BS1);
	    eval 'sub ALLDELAY () { &O_ALLDELAY;}' unless defined(&ALLDELAY);
	}
	eval 'sub CRTBS () { &O_CRTBS;}' unless defined(&CRTBS);
	eval 'sub PRTERA () { &O_PRTERA;}' unless defined(&PRTERA);
	eval 'sub CRTERA () { &O_CRTERA;}' unless defined(&CRTERA);
	eval 'sub TILDE () { &O_TILDE;}' unless defined(&TILDE);
	eval 'sub MDMBUF () { &O_MDMBUF;}' unless defined(&MDMBUF);
	eval 'sub LITOUT () { &O_LITOUT;}' unless defined(&LITOUT);
	eval 'sub TOSTOP () { &O_TOSTOP;}' unless defined(&TOSTOP);
	eval 'sub FLUSHO () { &O_FLUSHO;}' unless defined(&FLUSHO);
	eval 'sub NOHANG () { &O_NOHANG;}' unless defined(&NOHANG);
	eval 'sub L001000 () { &O_L001000;}' unless defined(&L001000);
	eval 'sub CRTKIL () { &O_CRTKIL;}' unless defined(&CRTKIL);
	eval 'sub PASS8 () { &O_PASS8;}' unless defined(&PASS8);
	eval 'sub CTLECH () { &O_CTLECH;}' unless defined(&CTLECH);
	eval 'sub PENDIN () { &O_PENDIN;}' unless defined(&PENDIN);
	eval 'sub DECCTQ () { &O_DECCTQ;}' unless defined(&DECCTQ);
	eval 'sub NOFLSH () { &O_NOFLSH;}' unless defined(&NOFLSH);
	if(defined(&__cplusplus)) {
	}
    }
    require 'sys/filio.ph';
    require 'sys/sockio.ph';
    require 'sys/termios.ph';
}
1;
