require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_ISA_DEFS_H)) {
    eval 'sub _SYS_ISA_DEFS_H () {1;}' unless defined(&_SYS_ISA_DEFS_H);
    if(defined(&__cplusplus)) {
    }
    if(defined(&__x86_64) || defined(&__amd64)) {
	if(!defined(&__amd64)) {
	    eval 'sub __amd64 () {1;}' unless defined(&__amd64);
	}
	if(!defined(&__x86)) {
	    eval 'sub __x86 () {1;}' unless defined(&__x86);
	}
	eval 'sub _LITTLE_ENDIAN () {1;}' unless defined(&_LITTLE_ENDIAN);
	eval 'sub _STACK_GROWS_DOWNWARD () {1;}' unless defined(&_STACK_GROWS_DOWNWARD);
	eval 'sub _LONG_LONG_LTOH () {1;}' unless defined(&_LONG_LONG_LTOH);
	eval 'sub _BIT_FIELDS_LTOH () {1;}' unless defined(&_BIT_FIELDS_LTOH);
	eval 'sub _IEEE_754 () {1;}' unless defined(&_IEEE_754);
	eval 'sub _CHAR_IS_SIGNED () {1;}' unless defined(&_CHAR_IS_SIGNED);
	eval 'sub _BOOL_ALIGNMENT () {1;}' unless defined(&_BOOL_ALIGNMENT);
	eval 'sub _CHAR_ALIGNMENT () {1;}' unless defined(&_CHAR_ALIGNMENT);
	eval 'sub _SHORT_ALIGNMENT () {2;}' unless defined(&_SHORT_ALIGNMENT);
	eval 'sub _INT_ALIGNMENT () {4;}' unless defined(&_INT_ALIGNMENT);
	eval 'sub _FLOAT_ALIGNMENT () {4;}' unless defined(&_FLOAT_ALIGNMENT);
	eval 'sub _FLOAT_COMPLEX_ALIGNMENT () {4;}' unless defined(&_FLOAT_COMPLEX_ALIGNMENT);
	eval 'sub _LONG_ALIGNMENT () {8;}' unless defined(&_LONG_ALIGNMENT);
	eval 'sub _LONG_LONG_ALIGNMENT () {8;}' unless defined(&_LONG_LONG_ALIGNMENT);
	eval 'sub _DOUBLE_ALIGNMENT () {8;}' unless defined(&_DOUBLE_ALIGNMENT);
	eval 'sub _DOUBLE_COMPLEX_ALIGNMENT () {8;}' unless defined(&_DOUBLE_COMPLEX_ALIGNMENT);
	eval 'sub _LONG_DOUBLE_ALIGNMENT () {16;}' unless defined(&_LONG_DOUBLE_ALIGNMENT);
	eval 'sub _LONG_DOUBLE_COMPLEX_ALIGNMENT () {16;}' unless defined(&_LONG_DOUBLE_COMPLEX_ALIGNMENT);
	eval 'sub _POINTER_ALIGNMENT () {8;}' unless defined(&_POINTER_ALIGNMENT);
	eval 'sub _MAX_ALIGNMENT () {16;}' unless defined(&_MAX_ALIGNMENT);
	eval 'sub _ALIGNMENT_REQUIRED () {1;}' unless defined(&_ALIGNMENT_REQUIRED);
	eval 'sub _LONG_LONG_ALIGNMENT_32 () {4;}' unless defined(&_LONG_LONG_ALIGNMENT_32);
	if(!defined(&_LP64)) {
	    eval 'sub _LP64 () {1;}' unless defined(&_LP64);
	}
	if(!defined(&_I32LPx)  && defined(&_KERNEL)) {
	    eval 'sub _I32LPx () {1;}' unless defined(&_I32LPx);
	}
	eval 'sub _MULTI_DATAMODEL () {1;}' unless defined(&_MULTI_DATAMODEL);
	eval 'sub _SUNOS_VTOC_16 () {1;}' unless defined(&_SUNOS_VTOC_16);
	eval 'sub _DMA_USES_PHYSADDR () {1;}' unless defined(&_DMA_USES_PHYSADDR);
	eval 'sub _FIRMWARE_NEEDS_FDISK () {1;}' unless defined(&_FIRMWARE_NEEDS_FDISK);
	eval 'sub __i386_COMPAT () {1;}' unless defined(&__i386_COMPAT);
	eval 'sub _PSM_MODULES () {1;}' unless defined(&_PSM_MODULES);
	eval 'sub _RTC_CONFIG () {1;}' unless defined(&_RTC_CONFIG);
	eval 'sub _SOFT_HOSTID () {1;}' unless defined(&_SOFT_HOSTID);
	eval 'sub _DONT_USE_1275_GENERIC_NAMES () {1;}' unless defined(&_DONT_USE_1275_GENERIC_NAMES);
	eval 'sub _HAVE_CPUID_INSN () {1;}' unless defined(&_HAVE_CPUID_INSN);
    }
 elsif(defined(&__i386) || defined(&__i386__)) {
	if(!defined(&__i386)) {
	    eval 'sub __i386 () {1;}' unless defined(&__i386);
	}
	if(!defined(&__x86)) {
	    eval 'sub __x86 () {1;}' unless defined(&__x86);
	}
	eval 'sub _LITTLE_ENDIAN () {1;}' unless defined(&_LITTLE_ENDIAN);
	eval 'sub _STACK_GROWS_DOWNWARD () {1;}' unless defined(&_STACK_GROWS_DOWNWARD);
	eval 'sub _LONG_LONG_LTOH () {1;}' unless defined(&_LONG_LONG_LTOH);
	eval 'sub _BIT_FIELDS_LTOH () {1;}' unless defined(&_BIT_FIELDS_LTOH);
	eval 'sub _IEEE_754 () {1;}' unless defined(&_IEEE_754);
	eval 'sub _CHAR_IS_SIGNED () {1;}' unless defined(&_CHAR_IS_SIGNED);
	eval 'sub _BOOL_ALIGNMENT () {1;}' unless defined(&_BOOL_ALIGNMENT);
	eval 'sub _CHAR_ALIGNMENT () {1;}' unless defined(&_CHAR_ALIGNMENT);
	eval 'sub _SHORT_ALIGNMENT () {2;}' unless defined(&_SHORT_ALIGNMENT);
	eval 'sub _INT_ALIGNMENT () {4;}' unless defined(&_INT_ALIGNMENT);
	eval 'sub _FLOAT_ALIGNMENT () {4;}' unless defined(&_FLOAT_ALIGNMENT);
	eval 'sub _FLOAT_COMPLEX_ALIGNMENT () {4;}' unless defined(&_FLOAT_COMPLEX_ALIGNMENT);
	eval 'sub _LONG_ALIGNMENT () {4;}' unless defined(&_LONG_ALIGNMENT);
	eval 'sub _LONG_LONG_ALIGNMENT () {4;}' unless defined(&_LONG_LONG_ALIGNMENT);
	eval 'sub _DOUBLE_ALIGNMENT () {4;}' unless defined(&_DOUBLE_ALIGNMENT);
	eval 'sub _DOUBLE_COMPLEX_ALIGNMENT () {4;}' unless defined(&_DOUBLE_COMPLEX_ALIGNMENT);
	eval 'sub _LONG_DOUBLE_ALIGNMENT () {4;}' unless defined(&_LONG_DOUBLE_ALIGNMENT);
	eval 'sub _LONG_DOUBLE_COMPLEX_ALIGNMENT () {4;}' unless defined(&_LONG_DOUBLE_COMPLEX_ALIGNMENT);
	eval 'sub _POINTER_ALIGNMENT () {4;}' unless defined(&_POINTER_ALIGNMENT);
	eval 'sub _MAX_ALIGNMENT () {4;}' unless defined(&_MAX_ALIGNMENT);
	eval 'sub _ALIGNMENT_REQUIRED () {0;}' unless defined(&_ALIGNMENT_REQUIRED);
	eval 'sub _LONG_LONG_ALIGNMENT_32 () { &_LONG_LONG_ALIGNMENT;}' unless defined(&_LONG_LONG_ALIGNMENT_32);
	eval 'sub _ILP32 () {1;}' unless defined(&_ILP32);
	if(!defined(&_I32LPx)  && defined(&_KERNEL)) {
	    eval 'sub _I32LPx () {1;}' unless defined(&_I32LPx);
	}
	eval 'sub _SUNOS_VTOC_16 () {1;}' unless defined(&_SUNOS_VTOC_16);
	eval 'sub _DMA_USES_PHYSADDR () {1;}' unless defined(&_DMA_USES_PHYSADDR);
	eval 'sub _FIRMWARE_NEEDS_FDISK () {1;}' unless defined(&_FIRMWARE_NEEDS_FDISK);
	eval 'sub _PSM_MODULES () {1;}' unless defined(&_PSM_MODULES);
	eval 'sub _RTC_CONFIG () {1;}' unless defined(&_RTC_CONFIG);
	eval 'sub _SOFT_HOSTID () {1;}' unless defined(&_SOFT_HOSTID);
	eval 'sub _DONT_USE_1275_GENERIC_NAMES () {1;}' unless defined(&_DONT_USE_1275_GENERIC_NAMES);
	eval 'sub _HAVE_CPUID_INSN () {1;}' unless defined(&_HAVE_CPUID_INSN);
    }
 elsif(defined(&__sparc) || defined(&__sparcv9) || defined(&__sparc__)) {
	if(!defined(&__sparc)) {
	    eval 'sub __sparc () {1;}' unless defined(&__sparc);
	}
	if(defined(&__sparcv8)  && defined(&__sparcv9)) {
	    die("SPARC Versions 8 and 9 are mutually exclusive choices");
	}
	if(!defined(&__sparcv9)  && !defined(&__sparcv8)) {
	    eval 'sub __sparcv8 () {1;}' unless defined(&__sparcv8);
	}
	eval 'sub _BIG_ENDIAN () {1;}' unless defined(&_BIG_ENDIAN);
	eval 'sub _STACK_GROWS_DOWNWARD () {1;}' unless defined(&_STACK_GROWS_DOWNWARD);
	eval 'sub _LONG_LONG_HTOL () {1;}' unless defined(&_LONG_LONG_HTOL);
	eval 'sub _BIT_FIELDS_HTOL () {1;}' unless defined(&_BIT_FIELDS_HTOL);
	eval 'sub _IEEE_754 () {1;}' unless defined(&_IEEE_754);
	eval 'sub _CHAR_IS_SIGNED () {1;}' unless defined(&_CHAR_IS_SIGNED);
	eval 'sub _BOOL_ALIGNMENT () {1;}' unless defined(&_BOOL_ALIGNMENT);
	eval 'sub _CHAR_ALIGNMENT () {1;}' unless defined(&_CHAR_ALIGNMENT);
	eval 'sub _SHORT_ALIGNMENT () {2;}' unless defined(&_SHORT_ALIGNMENT);
	eval 'sub _INT_ALIGNMENT () {4;}' unless defined(&_INT_ALIGNMENT);
	eval 'sub _FLOAT_ALIGNMENT () {4;}' unless defined(&_FLOAT_ALIGNMENT);
	eval 'sub _FLOAT_COMPLEX_ALIGNMENT () {4;}' unless defined(&_FLOAT_COMPLEX_ALIGNMENT);
	eval 'sub _LONG_LONG_ALIGNMENT () {8;}' unless defined(&_LONG_LONG_ALIGNMENT);
	eval 'sub _DOUBLE_ALIGNMENT () {8;}' unless defined(&_DOUBLE_ALIGNMENT);
	eval 'sub _DOUBLE_COMPLEX_ALIGNMENT () {8;}' unless defined(&_DOUBLE_COMPLEX_ALIGNMENT);
	eval 'sub _ALIGNMENT_REQUIRED () {1;}' unless defined(&_ALIGNMENT_REQUIRED);
	eval 'sub _SUNOS_VTOC_8 () {1;}' unless defined(&_SUNOS_VTOC_8);
	eval 'sub _DMA_USES_VIRTADDR () {1;}' unless defined(&_DMA_USES_VIRTADDR);
	eval 'sub _NO_FDISK_PRESENT () {1;}' unless defined(&_NO_FDISK_PRESENT);
	eval 'sub _HAVE_TEM_FIRMWARE () {1;}' unless defined(&_HAVE_TEM_FIRMWARE);
	eval 'sub _OBP () {1;}' unless defined(&_OBP);
	if(defined(&__sparcv8)) {
	    eval 'sub _LONG_ALIGNMENT () {4;}' unless defined(&_LONG_ALIGNMENT);
	    eval 'sub _LONG_DOUBLE_ALIGNMENT () {8;}' unless defined(&_LONG_DOUBLE_ALIGNMENT);
	    eval 'sub _LONG_DOUBLE_COMPLEX_ALIGNMENT () {8;}' unless defined(&_LONG_DOUBLE_COMPLEX_ALIGNMENT);
	    eval 'sub _POINTER_ALIGNMENT () {4;}' unless defined(&_POINTER_ALIGNMENT);
	    eval 'sub _MAX_ALIGNMENT () {8;}' unless defined(&_MAX_ALIGNMENT);
	    eval 'sub _LONG_LONG_ALIGNMENT_32 () { &_LONG_LONG_ALIGNMENT;}' unless defined(&_LONG_LONG_ALIGNMENT_32);
	    eval 'sub _ILP32 () {1;}' unless defined(&_ILP32);
	    if(!defined(&_I32LPx)  && defined(&_KERNEL)) {
		eval 'sub _I32LPx () {1;}' unless defined(&_I32LPx);
	    }
	}
 elsif(defined(&__sparcv9)) {
	    eval 'sub _LONG_ALIGNMENT () {8;}' unless defined(&_LONG_ALIGNMENT);
	    eval 'sub _LONG_DOUBLE_ALIGNMENT () {16;}' unless defined(&_LONG_DOUBLE_ALIGNMENT);
	    eval 'sub _LONG_DOUBLE_COMPLEX_ALIGNMENT () {16;}' unless defined(&_LONG_DOUBLE_COMPLEX_ALIGNMENT);
	    eval 'sub _POINTER_ALIGNMENT () {8;}' unless defined(&_POINTER_ALIGNMENT);
	    eval 'sub _MAX_ALIGNMENT () {16;}' unless defined(&_MAX_ALIGNMENT);
	    eval 'sub _LONG_LONG_ALIGNMENT_32 () { &_LONG_LONG_ALIGNMENT;}' unless defined(&_LONG_LONG_ALIGNMENT_32);
	    if(!defined(&_LP64)) {
		eval 'sub _LP64 () {1;}' unless defined(&_LP64);
	    }
	    if(!defined(&_I32LPx)) {
		eval 'sub _I32LPx () {1;}' unless defined(&_I32LPx);
	    }
	    eval 'sub _MULTI_DATAMODEL () {1;}' unless defined(&_MULTI_DATAMODEL);
	} else {
	    die("unknown SPARC version");
	}
    } else {
	die("ISA not supported");
    }
    if(defined(&_ILP32)  && defined(&_LP64)) {
	die("Both _ILP32 and _LP64 are defined");
    }
    if(defined(&__cplusplus)) {
    }
}
1;
