require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_MACHCPUVAR_H)) {
    eval 'sub _SYS_MACHCPUVAR_H () {1;}' unless defined(&_SYS_MACHCPUVAR_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/inttypes.ph';
    require 'sys/x_call.ph';
    require 'sys/tss.ph';
    require 'sys/segments.ph';
    require 'sys/rm_platter.ph';
    require 'sys/avintr.ph';
    require 'sys/pte.ph';
    unless(defined(&_ASM)) {
	eval 'sub VCPU_STATE_UNKNOWN () {0;}' unless defined(&VCPU_STATE_UNKNOWN);
	eval 'sub VCPU_ON_PCPU () {1;}' unless defined(&VCPU_ON_PCPU);
	eval 'sub VCPU_NOT_ON_PCPU () {2;}' unless defined(&VCPU_NOT_ON_PCPU);
	if(defined(&__amd64)) {
	}
	eval 'sub NINTR_THREADS () {( &LOCK_LEVEL-1);}' unless defined(&NINTR_THREADS);
	eval 'sub MWAIT_HALTED () {(1);}' unless defined(&MWAIT_HALTED);
	eval 'sub MWAIT_RUNNING () {(0);}' unless defined(&MWAIT_RUNNING);
	eval 'sub MWAIT_WAKEUP_IPI () {(2);}' unless defined(&MWAIT_WAKEUP_IPI);
	eval 'sub MWAIT_WAKEUP {
	    my($cpu) = @_;
    	    eval q((*(($cpu)-> ($cpu_m->{m$cpu_mwait})) =  &MWAIT_RUNNING));
	}' unless defined(&MWAIT_WAKEUP);
    }
    eval 'sub cpu_nodeid () { ($cpu_m->{mcpu_nodeid});}' unless defined(&cpu_nodeid);
    eval 'sub cpu_pri () { ($cpu_m->{mcpu_pri});}' unless defined(&cpu_pri);
    eval 'sub cpu_current_hat () { ($cpu_m->{mcpu_current_hat});}' unless defined(&cpu_current_hat);
    eval 'sub cpu_hat_info () { ($cpu_m->{mcpu_hat_info});}' unless defined(&cpu_hat_info);
    eval 'sub cpu_ppaddr_mutex () { ($cpu_m->{mcpu_ppaddr_mutex});}' unless defined(&cpu_ppaddr_mutex);
    eval 'sub cpu_gdt () { ($cpu_m->{mcpu_gdt});}' unless defined(&cpu_gdt);
    eval 'sub cpu_idt () { ($cpu_m->{mcpu_idt});}' unless defined(&cpu_idt);
    eval 'sub cpu_tss () { ($cpu_m->{mcpu_tss});}' unless defined(&cpu_tss);
    eval 'sub cpu_ldt () { ($cpu_m->{mcpu_ldt});}' unless defined(&cpu_ldt);
    eval 'sub cpu_caddr1 () { ($cpu_m->{mcpu_caddr1});}' unless defined(&cpu_caddr1);
    eval 'sub cpu_caddr2 () { ($cpu_m->{mcpu_caddr2});}' unless defined(&cpu_caddr2);
    eval 'sub cpu_softinfo () { ($cpu_m->{mcpu_softinfo});}' unless defined(&cpu_softinfo);
    eval 'sub cpu_caddr1pte () { ($cpu_m->{mcpu_caddr1pte});}' unless defined(&cpu_caddr1pte);
    eval 'sub cpu_caddr2pte () { ($cpu_m->{mcpu_caddr2pte});}' unless defined(&cpu_caddr2pte);
    if(defined(&__cplusplus)) {
    }
}
1;
