require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_MACHLOCK_H)) {
    eval 'sub _SYS_MACHLOCK_H () {1;}' unless defined(&_SYS_MACHLOCK_H);
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
	require 'sys/time.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	if(defined(&_KERNEL)) {
	}
	eval 'sub LOCK_HELD_VALUE () {0xff;}' unless defined(&LOCK_HELD_VALUE);
	eval 'sub LOCK_INIT_CLEAR {
	    my($lp) = @_;
    	    eval q((*($lp) = 0));
	}' unless defined(&LOCK_INIT_CLEAR);
	eval 'sub LOCK_INIT_HELD {
	    my($lp) = @_;
    	    eval q((*($lp) =  &LOCK_HELD_VALUE));
	}' unless defined(&LOCK_INIT_HELD);
	eval 'sub LOCK_HELD {
	    my($lp) = @_;
    	    eval q((*( &volatile  &lock_t *)($lp) != 0));
	}' unless defined(&LOCK_HELD);
	eval 'sub SPIN_LOCK {
	    my($pl) = @_;
    	    eval q((($pl) >  &ipltospl( &LOCK_LEVEL)));
	}' unless defined(&SPIN_LOCK);
	eval 'sub LOCK_SAMPLE_INTERVAL {
	    my($i) = @_;
    	    eval q(((($i) & 0xff) == 0));
	}' unless defined(&LOCK_SAMPLE_INTERVAL);
    }
    eval 'sub PIL_MAX () {15;}' unless defined(&PIL_MAX);
    eval 'sub CLOCK_LEVEL () {10;}' unless defined(&CLOCK_LEVEL);
    eval 'sub LOCK_LEVEL () {10;}' unless defined(&LOCK_LEVEL);
    eval 'sub DISP_LEVEL () {( &LOCK_LEVEL + 1);}' unless defined(&DISP_LEVEL);
    eval 'sub HIGH_LEVELS () {( &PIL_MAX -  &LOCK_LEVEL);}' unless defined(&HIGH_LEVELS);
    eval 'sub CPU_INTR_ACTV_HIGH_LEVEL_MASK () {0xf800;}' unless defined(&CPU_INTR_ACTV_HIGH_LEVEL_MASK);
    eval 'sub PTR24_LSB () {5;}' unless defined(&PTR24_LSB);
    eval 'sub PTR24_MSB () {( &PTR24_LSB + 24);}' unless defined(&PTR24_MSB);
    eval 'sub PTR24_ALIGN () {32;}' unless defined(&PTR24_ALIGN);
    eval 'sub PTR24_BASE () {0xe0000000;}' unless defined(&PTR24_BASE);
    if(defined(&__cplusplus)) {
    }
}
1;
