require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SEGMENTS_H)) {
    eval 'sub _SYS_SEGMENTS_H () {1;}' unless defined(&_SYS_SEGMENTS_H);
    if(defined(&__cplusplus)) {
    }
    require 'sys/tss.ph';
    if(!defined(&_ASM) || defined(&__GNUC_AS__)) {
	eval 'sub IDXTOSEL {
	    my($s) = @_;
    	    eval q((($s) << 3));
	}' unless defined(&IDXTOSEL);
	eval 'sub SEL_GDT {
	    my($s, $r) = @_;
    	    eval q(( &IDXTOSEL($s) | $r));
	}' unless defined(&SEL_GDT);
    } else {
	eval 'sub IDXTOSEL {
	    my($s) = @_;
    	    eval q([$s << 3]);
	}' unless defined(&IDXTOSEL);
	eval 'sub SEL_GDT {
	    my($s, $r) = @_;
    	    eval q([ &IDXTOSEL($s) | $r]);
	}' unless defined(&SEL_GDT);
    }
    eval 'sub SELTOIDX {
        my($s) = @_;
	    eval q((($s) >> 3));
    }' unless defined(&SELTOIDX);
    if(defined(&__xpv)) {
	if(defined(&__amd64)) {
	    eval 'sub SEL_XPL () {0;}' unless defined(&SEL_XPL);
	    eval 'sub SEL_KPL () {3;}' unless defined(&SEL_KPL);
	    eval 'sub TRP_KPL () {1;}' unless defined(&TRP_KPL);
	}
 elsif(defined(&__i386)) {
	    eval 'sub SEL_XPL () {0;}' unless defined(&SEL_XPL);
	    eval 'sub SEL_KPL () {1;}' unless defined(&SEL_KPL);
	    eval 'sub TRP_KPL () { &SEL_KPL;}' unless defined(&TRP_KPL);
	}
	eval 'sub TRP_XPL () {0;}' unless defined(&TRP_XPL);
    } else {
	eval 'sub SEL_KPL () {0;}' unless defined(&SEL_KPL);
	eval 'sub TRP_KPL () { &SEL_KPL;}' unless defined(&TRP_KPL);
    }
    eval 'sub SEL_UPL () {3;}' unless defined(&SEL_UPL);
    eval 'sub TRP_UPL () {3;}' unless defined(&TRP_UPL);
    eval 'sub SEL_TI_LDT () {4;}' unless defined(&SEL_TI_LDT);
    eval 'sub SEL_LDT {
        my($s) = @_;
	    eval q(( &IDXTOSEL($s) |  &SEL_TI_LDT |  &SEL_UPL));
    }' unless defined(&SEL_LDT);
    eval 'sub CPL_MASK () {3;}' unless defined(&CPL_MASK);
    eval 'sub SELISLDT {
        my($s) = @_;
	    eval q(((($s) &  &SEL_TI_LDT) ==  &SEL_TI_LDT));
    }' unless defined(&SELISLDT);
    eval 'sub SELISUPL {
        my($s) = @_;
	    eval q(((($s) &  &CPL_MASK) ==  &SEL_UPL));
    }' unless defined(&SELISUPL);
    unless(defined(&_ASM)) {
	if(defined(&__amd64)) {
	}
 elsif(defined(&__i386)) {
	}
	if(defined(&__amd64)) {
	}
	if(defined(&__amd64)) {
	}
 elsif(defined(&__i386)) {
	}
	if(!defined(&__amd64)) {
	    eval 'sub USEGD_GETBASE {
	        my($usd) = @_;
    		eval q((($usd)-> &usd_lobase | ($usd)-> &usd_midbase << 16| ($usd)-> &usd_hibase << (16+ 8)));
	    }' unless defined(&USEGD_GETBASE);
	    eval 'sub USEGD_SETBASE {
	        my($usd, $b) = @_;
    		eval q((($usd)-> &usd_lobase = ($b), ($usd)-> &usd_midbase = ($b) >> 16, ($usd)-> &usd_hibase = ($b) >> (16+ 8)));
	    }' unless defined(&USEGD_SETBASE);
	    eval 'sub USEGD_GETLIMIT {
	        my($usd) = @_;
    		eval q((($usd)-> &usd_lolimit | ($usd)-> &usd_hilimit << 16));
	    }' unless defined(&USEGD_GETLIMIT);
	    eval 'sub USEGD_SETLIMIT {
	        my($usd, $lim) = @_;
    		eval q((($usd)-> &usd_lolimit = $lim, ($usd)-> &usd_hilimit = $lim >> 16));
	    }' unless defined(&USEGD_SETLIMIT);
	    eval 'sub USD_TYPESHIFT () {5;}' unless defined(&USD_TYPESHIFT);
	} else {
	    eval 'sub USEGD_GETBASE {
	        my($usd) = @_;
    		eval q((($usd)-> &usd_lobase | ($usd)-> &usd_midbase << 16| ($usd)-> &usd_hibase << (16+ 8)));
	    }' unless defined(&USEGD_GETBASE);
	    eval 'sub USEGD_SETBASE {
	        my($usd, $b) = @_;
    		eval q((($usd)-> &usd_lobase = ($b), ($usd)-> &usd_midbase = ($b) >> 16, ($usd)-> &usd_hibase = ($b) >> (16+ 8)));
	    }' unless defined(&USEGD_SETBASE);
	    eval 'sub USEGD_GETLIMIT {
	        my($usd) = @_;
    		eval q((($usd)-> &usd_lolimit | ($usd)-> &usd_hilimit << 16));
	    }' unless defined(&USEGD_GETLIMIT);
	    eval 'sub USEGD_SETLIMIT {
	        my($usd, $lim) = @_;
    		eval q((($usd)-> &usd_lolimit = $lim, ($usd)-> &usd_hilimit = $lim >> 16));
	    }' unless defined(&USEGD_SETLIMIT);
	    eval 'sub USD_TYPESHIFT () {5;}' unless defined(&USD_TYPESHIFT);
	}
	if(!defined(&__amd64)) {
	} else {
	}
	eval 'sub SYSSEGD_SETLIMIT {
	    my($ssd, $lim) = @_;
    	    eval q((($ssd)-> &ssd_lolimit = $lim, ($ssd)-> &ssd_hilimit = $lim >> 16));
	}' unless defined(&SYSSEGD_SETLIMIT);
	eval 'sub SYSSEGD_GETLIMIT {
	    my($ssd) = @_;
    	    eval q(((($ssd)-> &ssd_hilimit << 16) | ($ssd)-> &ssd_lolimit));
	}' unless defined(&SYSSEGD_GETLIMIT);
	if(!defined(&__amd64)) {
	    eval 'sub GATESEG_GETOFFSET {
	        my($sgd) = @_;
    		eval q((( &uintptr_t)(($sgd)-> &sgd_looffset | ($sgd)-> &sgd_hioffset << 16)));
	    }' unless defined(&GATESEG_GETOFFSET);
	} else {
	    eval 'sub GATESEG_GETOFFSET {
	        my($sgd) = @_;
    		eval q((( &uintptr_t)(($sgd)-> &sgd_looffset | ($sgd)-> &sgd_hioffset << 16| ( &uint64_t)(($sgd)-> &sgd_hi64offset) << 32)));
	    }' unless defined(&GATESEG_GETOFFSET);
	}
	if(defined(&__amd64)) {
	}
 elsif(defined(&__i386)) {
	}
	if(defined(&__xpv)) {
	}
    }
    eval 'sub SDP_BYTES () {0;}' unless defined(&SDP_BYTES);
    eval 'sub SDP_PAGES () {1;}' unless defined(&SDP_PAGES);
    eval 'sub SDP_OP32 () {1;}' unless defined(&SDP_OP32);
    eval 'sub SDP_LONG () {1;}' unless defined(&SDP_LONG);
    eval 'sub SDP_SHORT () {0;}' unless defined(&SDP_SHORT);
    eval 'sub SDT_SYSNULL () {0;}' unless defined(&SDT_SYSNULL);
    eval 'sub SDT_SYS286TSS () {1;}' unless defined(&SDT_SYS286TSS);
    eval 'sub SDT_SYSLDT () {2;}' unless defined(&SDT_SYSLDT);
    eval 'sub SDT_SYS286BSY () {3;}' unless defined(&SDT_SYS286BSY);
    eval 'sub SDT_SYS286CGT () {4;}' unless defined(&SDT_SYS286CGT);
    eval 'sub SDT_SYSTASKGT () {5;}' unless defined(&SDT_SYSTASKGT);
    eval 'sub SDT_SYS286IGT () {6;}' unless defined(&SDT_SYS286IGT);
    eval 'sub SDT_SYS286TGT () {7;}' unless defined(&SDT_SYS286TGT);
    eval 'sub SDT_SYSNULL2 () {8;}' unless defined(&SDT_SYSNULL2);
    eval 'sub SDT_SYSTSS () {9;}' unless defined(&SDT_SYSTSS);
    eval 'sub SDT_SYSNULL3 () {10;}' unless defined(&SDT_SYSNULL3);
    eval 'sub SDT_SYSTSSBSY () {11;}' unless defined(&SDT_SYSTSSBSY);
    eval 'sub SDT_SYSCGT () {12;}' unless defined(&SDT_SYSCGT);
    eval 'sub SDT_SYSNULL4 () {13;}' unless defined(&SDT_SYSNULL4);
    eval 'sub SDT_SYSIGT () {14;}' unless defined(&SDT_SYSIGT);
    eval 'sub SDT_SYSTGT () {15;}' unless defined(&SDT_SYSTGT);
    eval 'sub SDT_MEMRO () {16;}' unless defined(&SDT_MEMRO);
    eval 'sub SDT_MEMROA () {17;}' unless defined(&SDT_MEMROA);
    eval 'sub SDT_MEMRW () {18;}' unless defined(&SDT_MEMRW);
    eval 'sub SDT_MEMRWA () {19;}' unless defined(&SDT_MEMRWA);
    eval 'sub SDT_MEMROD () {20;}' unless defined(&SDT_MEMROD);
    eval 'sub SDT_MEMRODA () {21;}' unless defined(&SDT_MEMRODA);
    eval 'sub SDT_MEMRWD () {22;}' unless defined(&SDT_MEMRWD);
    eval 'sub SDT_MEMRWDA () {23;}' unless defined(&SDT_MEMRWDA);
    eval 'sub SDT_MEME () {24;}' unless defined(&SDT_MEME);
    eval 'sub SDT_MEMEA () {25;}' unless defined(&SDT_MEMEA);
    eval 'sub SDT_MEMER () {26;}' unless defined(&SDT_MEMER);
    eval 'sub SDT_MEMERA () {27;}' unless defined(&SDT_MEMERA);
    eval 'sub SDT_MEMEC () {28;}' unless defined(&SDT_MEMEC);
    eval 'sub SDT_MEMEAC () {29;}' unless defined(&SDT_MEMEAC);
    eval 'sub SDT_MEMERC () {30;}' unless defined(&SDT_MEMERC);
    eval 'sub SDT_MEMERAC () {31;}' unless defined(&SDT_MEMERAC);
    eval 'sub IDT_DE () {0;}' unless defined(&IDT_DE);
    eval 'sub IDT_DB () {1;}' unless defined(&IDT_DB);
    eval 'sub IDT_NMI () {2;}' unless defined(&IDT_NMI);
    eval 'sub IDT_BP () {3;}' unless defined(&IDT_BP);
    eval 'sub IDT_OF () {4;}' unless defined(&IDT_OF);
    eval 'sub IDT_BR () {5;}' unless defined(&IDT_BR);
    eval 'sub IDT_UD () {6;}' unless defined(&IDT_UD);
    eval 'sub IDT_NM () {7;}' unless defined(&IDT_NM);
    eval 'sub IDT_DF () {8;}' unless defined(&IDT_DF);
    eval 'sub IDT_FPUGP () {9;}' unless defined(&IDT_FPUGP);
    eval 'sub IDT_TS () {10;}' unless defined(&IDT_TS);
    eval 'sub IDT_NP () {11;}' unless defined(&IDT_NP);
    eval 'sub IDT_SS () {12;}' unless defined(&IDT_SS);
    eval 'sub IDT_GP () {13;}' unless defined(&IDT_GP);
    eval 'sub IDT_PF () {14;}' unless defined(&IDT_PF);
    eval 'sub IDT_MF () {16;}' unless defined(&IDT_MF);
    eval 'sub IDT_AC () {17;}' unless defined(&IDT_AC);
    eval 'sub IDT_MC () {18;}' unless defined(&IDT_MC);
    eval 'sub IDT_XF () {19;}' unless defined(&IDT_XF);
    eval 'sub NIDT () {256;}' unless defined(&NIDT);
    eval 'sub GDT_NULL () {0;}' unless defined(&GDT_NULL);
    eval 'sub GDT_B32DATA () {1;}' unless defined(&GDT_B32DATA);
    eval 'sub GDT_B32CODE () {2;}' unless defined(&GDT_B32CODE);
    eval 'sub GDT_B16CODE () {3;}' unless defined(&GDT_B16CODE);
    eval 'sub GDT_B16DATA () {4;}' unless defined(&GDT_B16DATA);
    eval 'sub GDT_B64CODE () {5;}' unless defined(&GDT_B64CODE);
    eval 'sub GDT_BGSTMP () {7;}' unless defined(&GDT_BGSTMP);
    if(defined(&__amd64)) {
	eval 'sub GDT_KCODE () {6;}' unless defined(&GDT_KCODE);
	eval 'sub GDT_KDATA () {7;}' unless defined(&GDT_KDATA);
	eval 'sub GDT_U32CODE () {8;}' unless defined(&GDT_U32CODE);
	eval 'sub GDT_UDATA () {9;}' unless defined(&GDT_UDATA);
	eval 'sub GDT_UCODE () {10;}' unless defined(&GDT_UCODE);
	eval 'sub GDT_LDT () {12;}' unless defined(&GDT_LDT);
	eval 'sub GDT_KTSS () {14;}' unless defined(&GDT_KTSS);
	eval 'sub GDT_FS () { &GDT_NULL;}' unless defined(&GDT_FS);
	eval 'sub GDT_GS () { &GDT_NULL;}' unless defined(&GDT_GS);
	eval 'sub GDT_LWPFS () {55;}' unless defined(&GDT_LWPFS);
	eval 'sub GDT_LWPGS () {56;}' unless defined(&GDT_LWPGS);
	eval 'sub GDT_BRANDMIN () {57;}' unless defined(&GDT_BRANDMIN);
	eval 'sub GDT_BRANDMAX () {61;}' unless defined(&GDT_BRANDMAX);
	eval 'sub NGDT () {62;}' unless defined(&NGDT);
	eval 'sub TEMPGDT_KCODE64 () {1;}' unless defined(&TEMPGDT_KCODE64);
    }
 elsif(defined(&__i386)) {
	eval 'sub GDT_LDT () {40;}' unless defined(&GDT_LDT);
	eval 'sub GDT_KTSS () {42;}' unless defined(&GDT_KTSS);
	eval 'sub GDT_KCODE () {43;}' unless defined(&GDT_KCODE);
	eval 'sub GDT_KDATA () {44;}' unless defined(&GDT_KDATA);
	eval 'sub GDT_UCODE () {45;}' unless defined(&GDT_UCODE);
	eval 'sub GDT_UDATA () {46;}' unless defined(&GDT_UDATA);
	eval 'sub GDT_DBFLT () {47;}' unless defined(&GDT_DBFLT);
	eval 'sub GDT_FS () {53;}' unless defined(&GDT_FS);
	eval 'sub GDT_GS () {54;}' unless defined(&GDT_GS);
	eval 'sub GDT_LWPFS () {55;}' unless defined(&GDT_LWPFS);
	eval 'sub GDT_LWPGS () {56;}' unless defined(&GDT_LWPGS);
	eval 'sub GDT_BRANDMIN () {57;}' unless defined(&GDT_BRANDMIN);
	eval 'sub GDT_BRANDMAX () {61;}' unless defined(&GDT_BRANDMAX);
	if(!defined(&__xpv)) {
	    eval 'sub NGDT () {90;}' unless defined(&NGDT);
	} else {
	    eval 'sub NGDT () {512;}' unless defined(&NGDT);
	}
    }
    if(defined(&__xpv)  && defined(&__amd64)) {
	eval 'sub KCS_SEL () {0xe030;}' unless defined(&KCS_SEL);
	eval 'sub KDS_SEL () {0xe02b;}' unless defined(&KDS_SEL);
    } else {
	eval 'sub KCS_SEL () { &SEL_GDT( &GDT_KCODE,  &SEL_KPL);}' unless defined(&KCS_SEL);
	eval 'sub KDS_SEL () { &SEL_GDT( &GDT_KDATA,  &SEL_KPL);}' unless defined(&KDS_SEL);
    }
    eval 'sub UCS_SEL () { &SEL_GDT( &GDT_UCODE,  &SEL_UPL);}' unless defined(&UCS_SEL);
    if(defined(&__amd64)) {
	eval 'sub TEMP_CS64_SEL () { &SEL_GDT( &TEMPGDT_KCODE64,  &SEL_KPL);}' unless defined(&TEMP_CS64_SEL);
	eval 'sub U32CS_SEL () { &SEL_GDT( &GDT_U32CODE,  &SEL_UPL);}' unless defined(&U32CS_SEL);
    }
    eval 'sub UDS_SEL () { &SEL_GDT( &GDT_UDATA,  &SEL_UPL);}' unless defined(&UDS_SEL);
    eval 'sub ULDT_SEL () { &SEL_GDT( &GDT_LDT,  &SEL_KPL);}' unless defined(&ULDT_SEL);
    eval 'sub KTSS_SEL () { &SEL_GDT( &GDT_KTSS,  &SEL_KPL);}' unless defined(&KTSS_SEL);
    eval 'sub DFTSS_SEL () { &SEL_GDT( &GDT_DBFLT,  &SEL_KPL);}' unless defined(&DFTSS_SEL);
    eval 'sub KFS_SEL () {0;}' unless defined(&KFS_SEL);
    eval 'sub KGS_SEL () { &SEL_GDT( &GDT_GS,  &SEL_KPL);}' unless defined(&KGS_SEL);
    eval 'sub LWPFS_SEL () { &SEL_GDT( &GDT_LWPFS,  &SEL_UPL);}' unless defined(&LWPFS_SEL);
    eval 'sub LWPGS_SEL () { &SEL_GDT( &GDT_LWPGS,  &SEL_UPL);}' unless defined(&LWPGS_SEL);
    eval 'sub BRANDMIN_SEL () { &SEL_GDT( &GDT_BRANDMIN,  &SEL_UPL);}' unless defined(&BRANDMIN_SEL);
    eval 'sub BRANDMAX_SEL () { &SEL_GDT( &GDT_BRANDMAX,  &SEL_UPL);}' unless defined(&BRANDMAX_SEL);
    eval 'sub B64CODE_SEL () { &SEL_GDT( &GDT_B64CODE,  &SEL_KPL);}' unless defined(&B64CODE_SEL);
    eval 'sub B32CODE_SEL () { &SEL_GDT( &GDT_B32CODE,  &SEL_KPL);}' unless defined(&B32CODE_SEL);
    eval 'sub B32DATA_SEL () { &SEL_GDT( &GDT_B32DATA,  &SEL_KPL);}' unless defined(&B32DATA_SEL);
    eval 'sub B16CODE_SEL () { &SEL_GDT( &GDT_B16CODE,  &SEL_KPL);}' unless defined(&B16CODE_SEL);
    eval 'sub B16DATA_SEL () { &SEL_GDT( &GDT_B16DATA,  &SEL_KPL);}' unless defined(&B16DATA_SEL);
    eval 'sub KMDBGS_SEL () { &SEL_GDT( &GDT_BGSTMP,  &SEL_KPL);}' unless defined(&KMDBGS_SEL);
    if(defined(&__amd64)) {
	eval 'sub KMDBCODE_SEL () { &B64CODE_SEL;}' unless defined(&KMDBCODE_SEL);
    } else {
	eval 'sub KMDBCODE_SEL () { &B32CODE_SEL;}' unless defined(&KMDBCODE_SEL);
    }
    eval 'sub LDT_SYSCALL () {0;}' unless defined(&LDT_SYSCALL);
    eval 'sub LDT_SIGCALL () {1;}' unless defined(&LDT_SIGCALL);
    eval 'sub LDT_RESVD1 () {2;}' unless defined(&LDT_RESVD1);
    eval 'sub LDT_RESVD2 () {3;}' unless defined(&LDT_RESVD2);
    eval 'sub LDT_ALTSYSCALL () {4;}' unless defined(&LDT_ALTSYSCALL);
    eval 'sub LDT_ALTSIGCALL () {5;}' unless defined(&LDT_ALTSIGCALL);
    eval 'sub LDT_UDBASE () {6;}' unless defined(&LDT_UDBASE);
    eval 'sub MINNLDT () {512;}' unless defined(&MINNLDT);
    eval 'sub MAXNLDT () {8192;}' unless defined(&MAXNLDT);
    unless(defined(&_ASM)) {
	if(defined(&__amd64)) {
	}
	if(defined(&__amd64)) {
	}
	if(defined(&__i386)) {
	}
	if(!defined(&__xpv)) {
	}
	if(!defined(&__amd64)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
