require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_STAT_H)) {
    eval 'sub _SYS_STAT_H () {1;}' unless defined(&_SYS_STAT_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    if(defined(&__cplusplus)) {
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	require 'sys/time_impl.ph';
    } else {
	require 'sys/time_std_impl.ph';
    }
    eval 'sub _ST_FSTYPSZ () {16;}' unless defined(&_ST_FSTYPSZ);
    if(defined(&_KERNEL)) {
	if(defined(&_LP64)) {
	} else {
	}
    } else {
	if(!defined(&_LP64)  && (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
		if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__) || defined(&_ATFILE_SOURCE)) {
		}
		if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG_2) || defined(&__EXTENSIONS__)) {
		}
	    } else {
		eval 'sub fstat () { &fstat64;}' unless defined(&fstat);
		eval 'sub stat () { &stat64;}' unless defined(&stat);
		if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__) || defined(&_ATFILE_SOURCE)) {
		    eval 'sub fstatat () { &fstatat64;}' unless defined(&fstatat);
		}
		if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG_2) || defined(&__EXTENSIONS__)) {
		    eval 'sub lstat () { &lstat64;}' unless defined(&lstat);
		}
	    }
	}
	if(defined(&_LP64)  && defined(&_LARGEFILE64_SOURCE)) {
	    if(defined(&__PRAGMA_REDEFINE_EXTNAME)) {
		if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__) || defined(&_ATFILE_SOURCE)) {
		}
		if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG_2) || defined(&__EXTENSIONS__)) {
		}
	    } else {
		eval 'sub fstat64 () { &fstat;}' unless defined(&fstat64);
		eval 'sub stat64 () { &stat;}' unless defined(&stat64);
		if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__) || defined(&_ATFILE_SOURCE)) {
		    eval 'sub fstatat64 () { &fstatat;}' unless defined(&fstatat64);
		}
		if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG_2) || defined(&__EXTENSIONS__)) {
		    eval 'sub lstat64 () { &lstat;}' unless defined(&lstat64);
		}
	    }
	}
	if(defined(&_LP64)) {
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    } else {
	    }
	} else {
	    if((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) != 64) {
	    }
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    } else {
	    }
	}
	if(defined(&_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64)  && !defined(&__PRAGMA_REDEFINE_EXTNAME))) {
	    if(defined(&_LP64)) {
		if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
		} else {
		}
	    } else {
		if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
		} else {
		}
	    }
	}
	if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	    eval 'sub st_atime () { ($st_atim->{tv_sec});}' unless defined(&st_atime);
	    eval 'sub st_mtime () { ($st_mtim->{tv_sec});}' unless defined(&st_mtime);
	    eval 'sub st_ctime () { ($st_ctim->{tv_sec});}' unless defined(&st_ctime);
	} else {
	    eval 'sub st_atime () { ($st_atim->{__tv_sec});}' unless defined(&st_atime);
	    eval 'sub st_mtime () { ($st_mtim->{__tv_sec});}' unless defined(&st_mtime);
	    eval 'sub st_ctime () { ($st_ctim->{__tv_sec});}' unless defined(&st_ctime);
	}
    }
    if(defined(&_SYSCALL32)) {
	if((defined(&_LONG_LONG_ALIGNMENT) ? &_LONG_LONG_ALIGNMENT : undef) == 8 && (defined(&_LONG_LONG_ALIGNMENT_32) ? &_LONG_LONG_ALIGNMENT_32 : undef) == 4) {
	}
	if((defined(&_LONG_LONG_ALIGNMENT) ? &_LONG_LONG_ALIGNMENT : undef) == 8 && (defined(&_LONG_LONG_ALIGNMENT_32) ? &_LONG_LONG_ALIGNMENT_32 : undef) == 4) {
	}
    }
    eval 'sub S_IFMT () {0xf000;}' unless defined(&S_IFMT);
    eval 'sub S_IAMB () {0x1ff;}' unless defined(&S_IAMB);
    eval 'sub S_IFIFO () {0x1000;}' unless defined(&S_IFIFO);
    eval 'sub S_IFCHR () {0x2000;}' unless defined(&S_IFCHR);
    eval 'sub S_IFDIR () {0x4000;}' unless defined(&S_IFDIR);
    eval 'sub S_IFNAM () {0x5000;}' unless defined(&S_IFNAM);
    eval 'sub S_INSEM () {0x1;}' unless defined(&S_INSEM);
    eval 'sub S_INSHD () {0x2;}' unless defined(&S_INSHD);
    eval 'sub S_IFBLK () {0x6000;}' unless defined(&S_IFBLK);
    eval 'sub S_IFREG () {0x8000;}' unless defined(&S_IFREG);
    eval 'sub S_IFLNK () {0xa000;}' unless defined(&S_IFLNK);
    eval 'sub S_IFSOCK () {0xc000;}' unless defined(&S_IFSOCK);
    eval 'sub S_IFDOOR () {0xd000;}' unless defined(&S_IFDOOR);
    eval 'sub S_IFPORT () {0xe000;}' unless defined(&S_IFPORT);
    eval 'sub S_ISUID () {0x800;}' unless defined(&S_ISUID);
    eval 'sub S_ISGID () {0x400;}' unless defined(&S_ISGID);
    eval 'sub S_ISVTX () {0x200;}' unless defined(&S_ISVTX);
    eval 'sub S_IREAD () {00400;}' unless defined(&S_IREAD);
    eval 'sub S_IWRITE () {00200;}' unless defined(&S_IWRITE);
    eval 'sub S_IEXEC () {00100;}' unless defined(&S_IEXEC);
    eval 'sub S_ENFMT () { &S_ISGID;}' unless defined(&S_ENFMT);
    eval 'sub S_IRWXU () {00700;}' unless defined(&S_IRWXU);
    eval 'sub S_IRUSR () {00400;}' unless defined(&S_IRUSR);
    eval 'sub S_IWUSR () {00200;}' unless defined(&S_IWUSR);
    eval 'sub S_IXUSR () {00100;}' unless defined(&S_IXUSR);
    eval 'sub S_IRWXG () {00070;}' unless defined(&S_IRWXG);
    eval 'sub S_IRGRP () {00040;}' unless defined(&S_IRGRP);
    eval 'sub S_IWGRP () {00020;}' unless defined(&S_IWGRP);
    eval 'sub S_IXGRP () {00010;}' unless defined(&S_IXGRP);
    eval 'sub S_IRWXO () {00007;}' unless defined(&S_IRWXO);
    eval 'sub S_IROTH () {00004;}' unless defined(&S_IROTH);
    eval 'sub S_IWOTH () {00002;}' unless defined(&S_IWOTH);
    eval 'sub S_IXOTH () {00001;}' unless defined(&S_IXOTH);
    eval 'sub S_ISFIFO {
        my($mode) = @_;
	    eval q(((($mode)&0xf000) == 0x1000));
    }' unless defined(&S_ISFIFO);
    eval 'sub S_ISCHR {
        my($mode) = @_;
	    eval q(((($mode)&0xf000) == 0x2000));
    }' unless defined(&S_ISCHR);
    eval 'sub S_ISDIR {
        my($mode) = @_;
	    eval q(((($mode)&0xf000) == 0x4000));
    }' unless defined(&S_ISDIR);
    eval 'sub S_ISBLK {
        my($mode) = @_;
	    eval q(((($mode)&0xf000) == 0x6000));
    }' unless defined(&S_ISBLK);
    eval 'sub S_ISREG {
        my($mode) = @_;
	    eval q(((($mode)&0xf000) == 0x8000));
    }' unless defined(&S_ISREG);
    eval 'sub S_ISLNK {
        my($mode) = @_;
	    eval q(((($mode)&0xf000) == 0xa000));
    }' unless defined(&S_ISLNK);
    eval 'sub S_ISSOCK {
        my($mode) = @_;
	    eval q(((($mode)&0xf000) == 0xc000));
    }' unless defined(&S_ISSOCK);
    eval 'sub S_ISDOOR {
        my($mode) = @_;
	    eval q(((($mode)&0xf000) == 0xd000));
    }' unless defined(&S_ISDOOR);
    eval 'sub S_ISPORT {
        my($mode) = @_;
	    eval q(((($mode)&0xf000) == 0xe000));
    }' unless defined(&S_ISPORT);
    eval 'sub S_TYPEISMQ {
        my($_buf) = @_;
	    eval q((0));
    }' unless defined(&S_TYPEISMQ);
    eval 'sub S_TYPEISSEM {
        my($_buf) = @_;
	    eval q((0));
    }' unless defined(&S_TYPEISSEM);
    eval 'sub S_TYPEISSHM {
        my($_buf) = @_;
	    eval q((0));
    }' unless defined(&S_TYPEISSHM);
    if(defined(&__i386) || (defined(&__i386_COMPAT)  && defined(&_KERNEL))) {
	eval 'sub _R3_MKNOD_VER () {1;}' unless defined(&_R3_MKNOD_VER);
	eval 'sub _MKNOD_VER () {2;}' unless defined(&_MKNOD_VER);
	eval 'sub _R3_STAT_VER () {1;}' unless defined(&_R3_STAT_VER);
	eval 'sub _STAT_VER () {2;}' unless defined(&_STAT_VER);
    }
    if(defined(&__EXTENSIONS__) || (!defined(&_STRICT_STDC)  && !defined(&__XOPEN_OR_POSIX))) {
	eval 'sub UTIME_NOW () {-1;}' unless defined(&UTIME_NOW);
	eval 'sub UTIME_OMIT () {-2;}' unless defined(&UTIME_OMIT);
    }
    if(!defined(&_KERNEL) || defined(&_BOOT)) {
	if(!defined(&__XOPEN_OR_POSIX) || ((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) > 2) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	}
	if(defined(&_LARGEFILE64_SOURCE)  && !(((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64)  && !defined(&__PRAGMA_REDEFINE_EXTNAME))) {
	    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__) || defined(&_ATFILE_SOURCE)) {
	    }
	}
	if(defined(&__EXTENSIONS__) || defined(&_ATFILE_SOURCE) || (!defined(&_STRICT_STDC)  && !defined(&__XOPEN_OR_POSIX))) {
	}
	require 'sys/stat_impl.ph';
    }
    if(defined(&__cplusplus)) {
    }
}
1;
