require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SYSTM_H)) {
    eval 'sub _SYS_SYSTM_H () {1;}' unless defined(&_SYS_SYSTM_H);
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/proc.ph';
    require 'sys/dditypes.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&__sparcv9)) {
    } else {
    }
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	require 'sys/types32.ph';
	require 'sys/varargs.ph';
	require 'sys/uadmin.ph';
	eval("sub TOD_REVERSED () { 0; }") unless defined(&TOD_REVERSED);
	eval("sub TOD_STALLED () { 1; }") unless defined(&TOD_STALLED);
	eval("sub TOD_JUMPED () { 2; }") unless defined(&TOD_JUMPED);
	eval("sub TOD_RATECHANGED () { 3; }") unless defined(&TOD_RATECHANGED);
	eval("sub TOD_RDONLY () { 4; }") unless defined(&TOD_RDONLY);
	eval("sub TOD_NOFAULT () { 5; }") unless defined(&TOD_NOFAULT);
	eval 'sub TOD_GET_FAILED () {0x1;}' unless defined(&TOD_GET_FAILED);
	eval 'sub TOD_SET_DONE () {0x2;}' unless defined(&TOD_SET_DONE);
	eval 'sub TOD_CPR_RESUME_DONE () {0x4;}' unless defined(&TOD_CPR_RESUME_DONE);
	eval 'sub TOD_DR_RESUME_DONE () {0x8;}' unless defined(&TOD_DR_RESUME_DONE);
	unless(defined(&_LP64)) {
	    unless(defined(&min)) {
	    }
	    unless(defined(&max)) {
	    }
	}
	unless(defined(&_FAKE_KERNEL)) {
	}
	if(defined(&_LP64)) {
	}
	if(defined(&_LP64)) {
	}
	if(!defined(&_BOOT)  && !defined(&_FAKE_KERNEL)) {
	}
	eval 'sub insque {
	    my($q, $p) = @_;
    	    eval q( &_insque($q, $p));
	}' unless defined(&insque);
	eval 'sub remque {
	    my($q) = @_;
    	    eval q( &_remque($q));
	}' unless defined(&remque);
    }
    if(defined(&_LP64)) {
    } else {
    }
    if(defined(&_SYSCALL32_IMPL)) {
    }
    eval 'sub NSYSCALL () {256;}' unless defined(&NSYSCALL);
    eval 'sub LOADABLE_SYSCALL {
        my($s) = @_;
	    eval q(( ($s->{sy_flags}) &  &SE_LOADABLE));
    }' unless defined(&LOADABLE_SYSCALL);
    eval 'sub LOADED_SYSCALL {
        my($s) = @_;
	    eval q(( ($s->{sy_flags}) &  &SE_LOADED));
    }' unless defined(&LOADED_SYSCALL);
    eval 'sub SE_32RVAL1 () {0x;}' unless defined(&SE_32RVAL1);
    eval 'sub SE_32RVAL2 () {0x1;}' unless defined(&SE_32RVAL2);
    eval 'sub SE_64RVAL () {0x2;}' unless defined(&SE_64RVAL);
    eval 'sub SE_RVAL_MASK () {0x3;}' unless defined(&SE_RVAL_MASK);
    eval 'sub SE_LOADABLE () {0x8;}' unless defined(&SE_LOADABLE);
    eval 'sub SE_LOADED () {0x10;}' unless defined(&SE_LOADED);
    eval 'sub SE_NOUNLOAD () {0x20;}' unless defined(&SE_NOUNLOAD);
    eval 'sub SE_ARGC () {0x40;}' unless defined(&SE_ARGC);
    eval 'sub r_val1 () { ($r_v->{r_v1});}' unless defined(&r_val1);
    eval 'sub r_val2 () { ($r_v->{r_v2});}' unless defined(&r_val2);
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	if(defined(&_SYSCALL32_IMPL)) {
	}
	eval 'sub INITNAME_SZ () {32;}' unless defined(&INITNAME_SZ);
    }
    if(defined(&_KERNEL) || defined(&_FAKE_KERNEL) || defined(&_BOOT)) {
	if((defined(&__cplusplus) ? &__cplusplus : undef) >= 199711) {
	    unless(defined(&_STRCHR_INLINE)) {
		eval 'sub _STRCHR_INLINE () {1;}' unless defined(&_STRCHR_INLINE);
	    }
	    unless(defined(&_STRRCHR_INLINE)) {
		eval 'sub _STRRCHR_INLINE () {1;}' unless defined(&_STRRCHR_INLINE);
	    }
	    unless(defined(&_STRSTR_INLINE)) {
		eval 'sub _STRSTR_INLINE () {1;}' unless defined(&_STRSTR_INLINE);
	    }
	} else {
	}
	if((defined(&__cplusplus) ? &__cplusplus : undef) >= 199711) {
	    unless(defined(&_STRPBRK_INLINE)) {
		eval 'sub _STRPBRK_INLINE () {1;}' unless defined(&_STRPBRK_INLINE);
	    }
	} else {
	}
	if(defined(&__lint)) {
	} else {
	    eval 'sub __lintzero () {0;}' unless defined(&__lintzero);
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
