require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_T_LOCK_H)) {
    eval 'sub _SYS_T_LOCK_H () {1;}' unless defined(&_SYS_T_LOCK_H);
    unless(defined(&_ASM)) {
	require 'sys/machlock.ph';
	require 'sys/param.ph';
	require 'sys/mutex.ph';
	require 'sys/rwlock.ph';
	require 'sys/semaphore.ph';
	require 'sys/condvar.ph';
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	if(defined(&_KERNEL)) {
	    eval 'sub DISP_LOCK_INIT {
	        my($lp) = @_;
    		eval q( &LOCK_INIT_CLEAR(( &lock_t *)($lp)));
	    }' unless defined(&DISP_LOCK_INIT);
	    eval 'sub DISP_LOCK_HELD {
	        my($lp) = @_;
    		eval q( &LOCK_HELD(( &lock_t *)($lp)));
	    }' unless defined(&DISP_LOCK_HELD);
	    eval 'sub DISP_LOCK_DESTROY {
	        my($lp) = @_;
    		eval q( &ASSERT(! &DISP_LOCK_HELD($lp)));
	    }' unless defined(&DISP_LOCK_DESTROY);
	    unless(defined(&NO_LOCKS_HELD)) {
		eval 'sub NO_LOCKS_HELD () {1;}' unless defined(&NO_LOCKS_HELD);
	    }
	    unless(defined(&NO_COMPETING_THREADS)) {
		eval 'sub NO_COMPETING_THREADS () {1;}' unless defined(&NO_COMPETING_THREADS);
	    }
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
