require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_TYPES_H)) {
    eval 'sub _SYS_TYPES_H () {1;}' unless defined(&_SYS_TYPES_H);
    if(!defined(&_KERNEL)  && !defined(&_BOOT)) {
	require 'features.ph';
    } else {
	require 'sys/feature_tests.ph';
    }
    require 'sys/isa_defs.ph';
    require 'sys/machtypes.ph';
    if(defined(&_KERNEL)) {
	require 'sys/inttypes.ph';
    } else {
	require 'sys/int_types.ph';
    }
    if(defined(&_KERNEL) || defined(&_SYSCALL32)) {
	require 'sys/types32.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if(defined(&_LONGLONG_TYPE)) {
    } else {
    }
    if(defined(&_LP64) || defined(&_I32LPx)) {
    } else {
    }
    if(!defined(&_PTRDIFF_T) || (defined(&__cplusplus) ? &__cplusplus : undef) >= 199711) {
	eval 'sub _PTRDIFF_T () {1;}' unless defined(&_PTRDIFF_T);
	if(defined(&_LP64) || defined(&_I32LPx)) {
	} else {
	}
    }
    unless(defined(&_OFF_T)) {
	eval 'sub _OFF_T () {1;}' unless defined(&_OFF_T);
	if(defined(&_LP64) || (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 32) {
	}
 elsif((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64) {
	}
	if(defined(&_LARGEFILE64_SOURCE)) {
	    if(defined(&_LP64)) {
	    } else {
	    }
	}
    }
    if(defined(&_LP64)) {
    } else {
    }
    if(defined(&_LP64) || (defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 32) {
    }
 elsif((defined(&_FILE_OFFSET_BITS) ? &_FILE_OFFSET_BITS : undef) == 64) {
    }
    if(defined(&_LARGEFILE64_SOURCE)) {
	if(defined(&_LP64)) {
	} else {
	}
    }
    if(defined(&_LP64)) {
    } else {
    }
    unless(defined(&BOOLEAN_T_DEFINED)) {
	eval 'sub BOOLEAN_T_DEFINED () {1;}' unless defined(&BOOLEAN_T_DEFINED);
	eval 'sub _B_TRUE () { &B_TRUE;}' unless defined(&_B_TRUE);
	eval 'sub _B_FALSE () { &B_FALSE;}' unless defined(&_B_FALSE);
	eval("sub B_FALSE () { 0; }") unless defined(&B_FALSE);
	eval("sub B_TRUE () { 1; }") unless defined(&B_TRUE);
    }
    if(defined(&_KERNEL)) {
	eval 'sub VALID_BOOLEAN {
	    my($x) = @_;
    	    eval q(((($x) ==  &B_FALSE) || (($x) ==  &B_TRUE)));
	}' unless defined(&VALID_BOOLEAN);
	eval 'sub VOID2BOOLEAN {
	    my($x) = @_;
    	    eval q(((( &uintptr_t)($x) == 0) ?  &B_FALSE :  &B_TRUE));
	}' unless defined(&VOID2BOOLEAN);
    }
    if(defined(&_KERNEL)) {
	eval 'sub BOOLEAN2VOID {
	    my($x) = @_;
    	    eval q((($x) ? 1: 0));
	}' unless defined(&BOOLEAN2VOID);
    }
    if(defined(&_INT64_TYPE)) {
    } else {
    }
    if((defined(&_KERNEL) || defined(&_KMEMUSER) || defined(&_BOOT))) {
    }
    if(defined(&_LONG_LONG_LTOH)) {
    }
    if(defined(&_LONG_LONG_HTOL)) {
    }
    if(defined(&_LONG_LONG_LTOH)) {
    }
    if(defined(&_LONG_LONG_HTOL)) {
    }
    if(defined(&_LP64) || defined(&_I32LPx)) {
    } else {
    }
    unless(defined(&_SUSECONDS_T)) {
	eval 'sub _SUSECONDS_T () {1;}' unless defined(&_SUSECONDS_T);
    }
    if(defined(&_LP64) || defined(&_I32LPx)) {
    } else {
    }
    if(defined(&_LP64) || defined(&_I32LPx)) {
    } else {
    }
    unless(defined(&_UID_T)) {
	eval 'sub _UID_T () {1;}' unless defined(&_UID_T);
    }
    eval 'sub _MUTEX_MAGIC () {0x4d58;}' unless defined(&_MUTEX_MAGIC);
    eval 'sub _SEMA_MAGIC () {0x534d;}' unless defined(&_SEMA_MAGIC);
    eval 'sub _COND_MAGIC () {0x4356;}' unless defined(&_COND_MAGIC);
    eval 'sub _RWL_MAGIC () {0x5257;}' unless defined(&_RWL_MAGIC);
    if(defined(&_LP64) || defined(&_I32LPx)) {
    } else {
    }
    if(!defined(&_SIZE_T) || (defined(&__cplusplus) ? &__cplusplus : undef) >= 199711) {
	eval 'sub _SIZE_T () {1;}' unless defined(&_SIZE_T);
	if(defined(&_LP64) || defined(&_I32LPx)) {
	} else {
	}
    }
    unless(defined(&_SSIZE_T)) {
	eval 'sub _SSIZE_T () {1;}' unless defined(&_SSIZE_T);
	if(defined(&_LP64) || defined(&_I32LPx)) {
	} else {
	}
    }
    if(!defined(&_TIME_T) || (defined(&__cplusplus) ? &__cplusplus : undef) >= 199711) {
	eval 'sub _TIME_T () {1;}' unless defined(&_TIME_T);
    }
    if(!defined(&_CLOCK_T) || (defined(&__cplusplus) ? &__cplusplus : undef) >= 199711) {
	eval 'sub _CLOCK_T () {1;}' unless defined(&_CLOCK_T);
    }
    unless(defined(&_CLOCKID_T)) {
	eval 'sub _CLOCKID_T () {1;}' unless defined(&_CLOCKID_T);
    }
    unless(defined(&_TIMER_T)) {
	eval 'sub _TIMER_T () {1;}' unless defined(&_TIMER_T);
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	if(defined(&_KERNEL) || defined(&_FAKE_KERNEL)) {
	    eval 'sub SHRT_MIN () {(-32768);}' unless defined(&SHRT_MIN);
	    eval 'sub SHRT_MAX () {32767;}' unless defined(&SHRT_MAX);
	    eval 'sub USHRT_MAX () {65535;}' unless defined(&USHRT_MAX);
	    eval 'sub INT_MIN () {(-2147483647-1);}' unless defined(&INT_MIN);
	    eval 'sub INT_MAX () {2147483647;}' unless defined(&INT_MAX);
	    eval 'sub UINT_MAX () {4294967295;}' unless defined(&UINT_MAX);
	    if(defined(&_LP64)) {
		eval 'sub LONG_MIN () {(-9223372036854775807-1);}' unless defined(&LONG_MIN);
		eval 'sub LONG_MAX () {9223372036854775807;}' unless defined(&LONG_MAX);
		eval 'sub ULONG_MAX () {18446744073709551615;}' unless defined(&ULONG_MAX);
	    } else {
		eval 'sub LONG_MIN () {(-2147483647-1);}' unless defined(&LONG_MIN);
		eval 'sub LONG_MAX () {2147483647;}' unless defined(&LONG_MAX);
		eval 'sub ULONG_MAX () {4294967295;}' unless defined(&ULONG_MAX);
	    }
	    eval 'sub LLONG_MIN () {(-9223372036854775807-1);}' unless defined(&LLONG_MIN);
	    eval 'sub LLONG_MAX () {9223372036854775807;}' unless defined(&LLONG_MAX);
	    eval 'sub ULLONG_MAX () {18446744073709551615;}' unless defined(&ULLONG_MAX);
	}
	eval 'sub P_MYPID () {(( &pid_t)0);}' unless defined(&P_MYPID);
	eval 'sub P_MYID () {(-1);}' unless defined(&P_MYID);
	eval 'sub NOPID () {( &pid_t)(-1);}' unless defined(&NOPID);
	unless(defined(&NODEV)) {
	    eval 'sub NODEV () {( &dev_t)(-1);}' unless defined(&NODEV);
	    if(defined(&_SYSCALL32)) {
		eval 'sub NODEV32 () {( &dev32_t)(-1);}' unless defined(&NODEV32);
	    }
	}
	eval 'sub PFN_INVALID () {(( &pfn_t)-1);}' unless defined(&PFN_INVALID);
	eval 'sub PFN_SUSPENDED () {(( &pfn_t)-2);}' unless defined(&PFN_SUSPENDED);
	require 'sys/select.ph';
    }
    eval 'sub _VOID () { &void;}' unless defined(&_VOID);
    if(defined(&__cplusplus)) {
    }
}
1;
