require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_UADMIN_H)) {
    eval 'sub _SYS_UADMIN_H () {1;}' unless defined(&_SYS_UADMIN_H);
    if(!defined(&_ASM)) {
	require 'sys/types.ph';
	require 'sys/cred.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub A_REBOOT () {1;}' unless defined(&A_REBOOT);
    eval 'sub A_SHUTDOWN () {2;}' unless defined(&A_SHUTDOWN);
    eval 'sub A_FREEZE () {3;}' unless defined(&A_FREEZE);
    eval 'sub A_REMOUNT () {4;}' unless defined(&A_REMOUNT);
    eval 'sub A_DUMP () {5;}' unless defined(&A_DUMP);
    eval 'sub A_FTRACE () {15;}' unless defined(&A_FTRACE);
    eval 'sub A_SWAPCTL () {16;}' unless defined(&A_SWAPCTL);
    eval 'sub A_SDTTEST () {22;}' unless defined(&A_SDTTEST);
    eval 'sub A_CONFIG () {23;}' unless defined(&A_CONFIG);
    eval 'sub AD_UNKNOWN () {-1;}' unless defined(&AD_UNKNOWN);
    eval 'sub AD_HALT () {0;}' unless defined(&AD_HALT);
    eval 'sub AD_BOOT () {1;}' unless defined(&AD_BOOT);
    eval 'sub AD_IBOOT () {2;}' unless defined(&AD_IBOOT);
    eval 'sub AD_SBOOT () {3;}' unless defined(&AD_SBOOT);
    eval 'sub AD_SIBOOT () {4;}' unless defined(&AD_SIBOOT);
    eval 'sub AD_POWEROFF () {6;}' unless defined(&AD_POWEROFF);
    eval 'sub AD_NOSYNC () {7;}' unless defined(&AD_NOSYNC);
    eval 'sub AD_FASTREBOOT () {8;}' unless defined(&AD_FASTREBOOT);
    eval 'sub AD_FASTREBOOT_DRYRUN () {9;}' unless defined(&AD_FASTREBOOT_DRYRUN);
    eval 'sub AD_COMPRESS () {0;}' unless defined(&AD_COMPRESS);
    eval 'sub AD_FORCE () {1;}' unless defined(&AD_FORCE);
    eval 'sub AD_CHECK () {2;}' unless defined(&AD_CHECK);
    eval 'sub AD_SUSPEND_TO_DISK () { &AD_COMPRESS;}' unless defined(&AD_SUSPEND_TO_DISK);
    eval 'sub AD_CHECK_SUSPEND_TO_DISK () { &AD_CHECK;}' unless defined(&AD_CHECK_SUSPEND_TO_DISK);
    eval 'sub AD_SUSPEND_TO_RAM () {20;}' unless defined(&AD_SUSPEND_TO_RAM);
    eval 'sub AD_CHECK_SUSPEND_TO_RAM () {21;}' unless defined(&AD_CHECK_SUSPEND_TO_RAM);
    eval 'sub AD_REUSEINIT () {3;}' unless defined(&AD_REUSEINIT);
    eval 'sub AD_REUSABLE () {4;}' unless defined(&AD_REUSABLE);
    eval 'sub AD_REUSEFINI () {5;}' unless defined(&AD_REUSEFINI);
    eval 'sub AD_FTRACE_START () {1;}' unless defined(&AD_FTRACE_START);
    eval 'sub AD_FTRACE_STOP () {2;}' unless defined(&AD_FTRACE_STOP);
    eval 'sub AD_UPDATE_BOOT_CONFIG () {1;}' unless defined(&AD_UPDATE_BOOT_CONFIG);
    eval 'sub BOOTARGS_MAX () {256;}' unless defined(&BOOTARGS_MAX);
    if(!defined(&_KERNEL)) {
	eval 'sub FMRI_BOOT_CONFIG () {"svc:/system/boot-config:default";}' unless defined(&FMRI_BOOT_CONFIG);
	eval 'sub BOOT_CONFIG_PG_PARAMS () {"config";}' unless defined(&BOOT_CONFIG_PG_PARAMS);
	eval 'sub BOOT_CONFIG_PG_FBBLACKLIST () {"fastreboot_blacklist";}' unless defined(&BOOT_CONFIG_PG_FBBLACKLIST);
	eval 'sub BOOT_CONFIG_PG_OVR () {"config_ovr";}' unless defined(&BOOT_CONFIG_PG_OVR);
    }
    eval 'sub UA_FASTREBOOT_DEFAULT () {0x1;}' unless defined(&UA_FASTREBOOT_DEFAULT);
    eval 'sub UA_FASTREBOOT_ONPANIC () {0x2;}' unless defined(&UA_FASTREBOOT_ONPANIC);
    eval 'sub FASTREBOOT_DEFAULT () {"fastreboot_default";}' unless defined(&FASTREBOOT_DEFAULT);
    eval 'sub FASTREBOOT_ONPANIC () {"fastreboot_onpanic";}' unless defined(&FASTREBOOT_ONPANIC);
    eval 'sub FASTREBOOT_ONPANIC_CMDLINE () {"fastreboot_onpanic_cmdline";}' unless defined(&FASTREBOOT_ONPANIC_CMDLINE);
    eval 'sub FASTREBOOT_ONPANIC_NOTSET {
        my($p) = @_;
	    eval q(( &strcmp(($p), \\"false\\") == 0||  &strcmp(($p), \\"no\\") == 0||  &strcmp(($p), \\"0\\") == 0));
    }' unless defined(&FASTREBOOT_ONPANIC_NOTSET);
    eval 'sub FASTREBOOT_ONPANIC_ISSET {
        my($p) = @_;
	    eval q(( &strcmp(($p), \\"true\\") == 0||  &strcmp(($p), \\"yes\\") == 0||  &strcmp(($p), \\"1\\") == 0));
    }' unless defined(&FASTREBOOT_ONPANIC_ISSET);
    if(!defined(&_ASM)) {
	if(defined(&_KERNEL)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
