require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_VA_IMPL_H)) {
    eval 'sub _SYS_VA_IMPL_H () {1;}' unless defined(&_SYS_VA_IMPL_H);
    require 'sys/va_list.ph';
    if(defined(&__cplusplus)) {
    }
    if(defined(&__lint) ) {
	eval 'sub __va_start {
	    my($list, $name) = @_;
    	    eval q((($list) = ( &__va_list)$name));
	}' unless defined(&__va_start);
	eval 'sub __va_arg {
	    my($list, $type) = @_;
    	    eval q((($type *)($list))[0]);
	}' unless defined(&__va_arg);
	eval 'sub __va_copy {
	    my($to, $from) = @_;
    	    eval q( &__va_void((($to) = ($from))));
	}' unless defined(&__va_copy);
    }
 elsif(defined(&__BUILTIN_VA_STRUCT) ) {
	eval 'sub __va_start {
	    my($list, $name) = @_;
    	    eval q( &__builtin_va_start($list, 0));
	}' unless defined(&__va_start);
	eval 'sub __va_arg {
	    my($list, $type) = @_;
    	    eval q((($type *) &__builtin_va_arg_incr($list, ($type *)0))[0]);
	}' unless defined(&__va_arg);
	eval 'sub __va_copy {
	    my($to, $from) = @_;
    	    eval q( &__va_void((($to)[0] = ($from)[0])));
	}' unless defined(&__va_copy);
	eval 'sub __va_end {
	    my($list) = @_;
    	    eval q( &__va_void(0));
	}' unless defined(&__va_end);
    }
 elsif(defined(&__BUILTIN_VA_ARG_INCR) ) {
	eval 'sub __va_start {
	    my($list, $name) = @_;
    	    eval q( &__va_void((($list) = ( &__va_list)& &__builtin_va_alist)));
	}' unless defined(&__va_start);
	eval 'sub __va_arg {
	    my($list, $type) = @_;
    	    eval q((($type *) &__builtin_va_arg_incr(($type *)($list)))[0]);
	}' unless defined(&__va_arg);
	eval 'sub __va_copy {
	    my($to, $from) = @_;
    	    eval q( &__va_void((($to) = ($from))));
	}' unless defined(&__va_copy);
	eval 'sub __va_end {
	    my($list) = @_;
    	    eval q( &__va_void(0));
	}' unless defined(&__va_end);
    }
 elsif(defined(&__GNUC__)  && (((defined(&__GNUC__) ? &__GNUC__ : undef) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : undef) >= 96) || ((defined(&__GNUC__) ? &__GNUC__ : undef) >= 3)) ) {
	if(((defined(&__GNUC__) ? &__GNUC__ : undef) < 3) || (((defined(&__GNUC__) ? &__GNUC__ : undef) == 3)  && ((defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : undef) < 3))) {
	    eval 'sub __va_start {
	        my($list, $name) = @_;
    		eval q( &__builtin_stdarg_start($list, $name));
	    }' unless defined(&__va_start);
	} else {
	    eval 'sub __va_start {
	        my($list, $name) = @_;
    		eval q( &__builtin_va_start($list, $name));
	    }' unless defined(&__va_start);
	}
	eval 'sub __va_arg {
	    my($list, $type) = @_;
    	    eval q( &__builtin_va_arg($list, $type));
	}' unless defined(&__va_arg);
	eval 'sub __va_end {
	    my($list) = @_;
    	    eval q( &__builtin_va_end($list));
	}' unless defined(&__va_end);
	eval 'sub __va_copy {
	    my($to, $from) = @_;
    	    eval q( &__builtin_va_copy($to, $from));
	}' unless defined(&__va_copy);
    } else {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
