require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_WAIT_H)) {
    eval 'sub _SYS_WAIT_H () {1;}' unless defined(&_SYS_WAIT_H);
    require 'sys/feature_tests.ph';
    require 'sys/types.ph';
    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	require 'sys/resource.ph';
	require 'sys/siginfo.ph';
	require 'sys/procset.ph';
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub WUNTRACED () {0004;}' unless defined(&WUNTRACED);
    eval 'sub WNOHANG () {0100;}' unless defined(&WNOHANG);
    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval 'sub WEXITED () {0001;}' unless defined(&WEXITED);
	eval 'sub WTRAPPED () {0002;}' unless defined(&WTRAPPED);
	eval 'sub WSTOPPED () { &WUNTRACED;}' unless defined(&WSTOPPED);
	eval 'sub WCONTINUED () {0010;}' unless defined(&WCONTINUED);
	eval 'sub WNOWAIT () {0200;}' unless defined(&WNOWAIT);
	eval 'sub WOPTMASK () {( &WEXITED| &WTRAPPED| &WSTOPPED| &WCONTINUED| &WNOHANG| &WNOWAIT);}' unless defined(&WOPTMASK);
    }
    if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	eval 'sub WSTOPFLG () {0177;}' unless defined(&WSTOPFLG);
	eval 'sub WCONTFLG () {0177777;}' unless defined(&WCONTFLG);
	eval 'sub WCOREFLG () {0200;}' unless defined(&WCOREFLG);
	eval 'sub WSIGMASK () {0177;}' unless defined(&WSIGMASK);
	eval 'sub WLOBYTE {
	    my($stat) = @_;
    	    eval q(((($stat)&0377)));
	}' unless defined(&WLOBYTE);
	eval 'sub WHIBYTE {
	    my($stat) = @_;
    	    eval q((((($stat)>>8)&0377)));
	}' unless defined(&WHIBYTE);
	eval 'sub WWORD {
	    my($stat) = @_;
    	    eval q(((($stat))&0177777));
	}' unless defined(&WWORD);
	eval 'sub WIFCONTINUED {
	    my($stat) = @_;
    	    eval q(( &WWORD($stat) ==  &WCONTFLG));
	}' unless defined(&WIFCONTINUED);
	eval 'sub WCOREDUMP {
	    my($stat) = @_;
    	    eval q((($stat) &WCOREFLG));
	}' unless defined(&WCOREDUMP);
    }
    eval 'sub WIFEXITED {
        my($stat) = @_;
	    eval q(((($stat)&0xff) == 0));
    }' unless defined(&WIFEXITED);
    eval 'sub WIFSIGNALED {
        my($stat) = @_;
	    eval q(((&0xff) > 0 && (($stat)&0xff00) == 0));
    }' unless defined(&WIFSIGNALED);
    eval 'sub WIFSTOPPED {
        my($stat) = @_;
	    eval q(((&0xff) == 0177 && (($stat)&0xff00) != 0));
    }' unless defined(&WIFSTOPPED);
    eval 'sub WEXITSTATUS {
        my($stat) = @_;
	    eval q((((($stat)>>8)&0xff)));
    }' unless defined(&WEXITSTATUS);
    eval 'sub WTERMSIG {
        my($stat) = @_;
	    eval q(((($stat)&0x7f)));
    }' unless defined(&WTERMSIG);
    eval 'sub WSTOPSIG {
        my($stat) = @_;
	    eval q((((($stat)>>8)&0xff)));
    }' unless defined(&WSTOPSIG);
    if(!defined(&_KERNEL)) {
	if(!defined(&__XOPEN_OR_POSIX) || defined(&_XPG4_2) || defined(&__EXTENSIONS__)) {
	    if(!defined(&_XPG6) || defined(&__EXTENSIONS__)) {
	    }
	}
	if(!defined(&__XOPEN_OR_POSIX) || defined(&__EXTENSIONS__)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
