require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_XEN_MMU_H)) {
    eval 'sub _SYS_XEN_MMU_H () {1;}' unless defined(&_SYS_XEN_MMU_H);
    if(defined(&__cplusplus)) {
    }
    if((defined(&_BOOT)  && defined(&_BOOT_TARGET_amd64)) || (!defined(&_BOOT)  && defined(&__amd64))) {
	eval 'sub __target_amd64 () {1;}' unless defined(&__target_amd64);
    }
    eval 'sub mfn_to_ma {
        my($mfn) = @_;
	    eval q((( &maddr_t)($mfn) <<  &MMU_PAGESHIFT));
    }' unless defined(&mfn_to_ma);
    if(defined(&__xpv)) {
	if(defined(&__target_amd64)) {
	    eval 'sub IN_HYPERVISOR_VA {
	        my($va) = @_;
    		eval q((($va) >=  &HYPERVISOR_VIRT_START  && ($va) <  &HYPERVISOR_VIRT_END));
	    }' unless defined(&IN_HYPERVISOR_VA);
	} else {
	    eval 'sub IN_HYPERVISOR_VA {
	        my($va) = @_;
    		eval q((($va) >=  &xen_virt_start));
	    }' unless defined(&IN_HYPERVISOR_VA);
	    undef(&HYPERVISOR_VIRT_START) if defined(&HYPERVISOR_VIRT_START);
	    undef(&machine_to_phys_mapping) if defined(&machine_to_phys_mapping);
	}
	undef(&__target_amd64) if defined(&__target_amd64);
    }
    unless(defined(&_BOOT)) {
	if(defined(&__xpv)) {
	}
	eval 'sub MFN_INVALID () {(-( &mfn_t)1);}' unless defined(&MFN_INVALID);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
